"Change Set:		7489Tests-mha.36

Tests-mha.36:
* make tests more disciplined: remove files created during testing
* moreover, several methods have a changed revision number (not changed by me)

"!
!BitmapStreamTests methodsFor: 'private' stamp: 'mha 7/30/2009 11:21'!
validateImageSegment
	"array is set up with an array."
	| other filename |
	filename := 'bitmapStreamTest.extSeg'.

	FileDirectory default deleteFileNamed: filename ifAbsent: [ ].

	(ImageSegment new copyFromRootsForExport: (Array with: array))
         writeForExport: filename.

	other := (FileDirectory default readOnlyFileNamed: filename)
		fileInObjectAndCode.

	self assert: array = other originalRoots first.
	
	"clean up disk"
	FileDirectory default deleteFileNamed: filename ifAbsent: [ ]! !

!BitmapStreamTests methodsFor: 'private' stamp: 'mha 7/30/2009 11:22'!
validateSmartRefStreamOnDisk
	"array is set up with an array."
	| other filename |

	filename := 'bitmapStreamTest.ref'.
	FileDirectory default deleteFileNamed: filename ifAbsent: [ ].

	stream := FileDirectory default fileNamed: filename.
	stream fileOutClass: nil andObject: array.
	stream close.

	stream := FileDirectory default fileNamed: filename.
	other := stream fileInObjectAndCode.
	stream close.

	self assert: array = other.
	
	"clean up disk"
	FileDirectory default deleteFileNamed: filename ifAbsent: [ ]! !

!BitmapStreamTests methodsFor: 'private' stamp: 'mha 7/30/2009 11:22'!
validateRefStreamOnDisk
	"array is set up with an array."
	| other filename |

	filename := 'bitmapStreamTest.ref'.
	FileDirectory default deleteFileNamed: filename ifAbsent: [ ].

	stream := ReferenceStream fileNamed: filename.
	stream nextPut: array; close.

	stream := ReferenceStream fileNamed: filename.
	other := stream next.
	stream close.

	self assert: array = other.
	
	"clean up disk"
	FileDirectory default deleteFileNamed: filename ifAbsent: [ ]! !

!PCCByCompilationTest methodsFor: 'example module' stamp: 'mha 7/30/2009 11:28'!
cExternalCall2
		<primitive:'prim2'module:'CPCCT'>
		self primitiveFailed! !

!PCCByCompilationTest methodsFor: 'test methods' stamp: 'mha 7/30/2009 11:28'!
cRealExternalCallOrPrimitiveFailed
	<primitive: 'primGetModuleName' module:'LargeIntegers'>
	self primitiveFailed! !

!PCCByCompilationTest methodsFor: 'example module' stamp: 'mha 7/30/2009 11:28'!
cExternalCall1
	<primitive: 'prim1' module: 'CPCCT'>
! !

!PCCByCompilationTest methodsFor: 'test methods' stamp: 'mha 7/30/2009 11:28'!
cFailedCall
	<primitive: 'primGetModuleName' module:'CFailModule'>
	^ 'failed call'! !

