"Change Set:		7544CollectionsTests-nice.89

CollectionsTests-nice.89:
Test for
http://bugs.squeak.org/view.php?id=7269
OrderedCollection streamContents broken
http://bugs.squeak.org/view.php?id=2390
ReadWriteStream with an OrderedCollection bugs when growing  

CollectionsTests-nice.88:
Test for
http://bugs.squeak.org/view.php?id=7296
forceTo:paddingWith: doesn't work with OrderedCollections 

"!
!OrderedCollectionTest methodsFor: 'testsAdding' stamp: 'ar 7/15/2008 23:09'!
testAddAfterIndex
	"self run: #testAddAfterIndex"
	| l |
	l := #(1 2 3 4) asOrderedCollection.
	l add: 77 afterIndex: 0.
	self assert: (l =  #(77 1 2 3 4) asOrderedCollection).
	l add: 88 afterIndex: 2.
	self assert: (l =  #(77 1 88 2 3 4) asOrderedCollection). 
	l add: 99 afterIndex: l size.
	self assert: (l =  #(77 1 88 2 3 4 99) asOrderedCollection). 
	self should:[l add: 666 afterIndex: -1] raise: Error.
	self should:[l add: 666 afterIndex: l size+1] raise: Error.
! !

!OrderedCollectionTest methodsFor: 'testsAdding' stamp: 'ar 7/15/2008 23:08'!
testAddBeforeIndex
	"self run: #testAddBeforeIndex"
	| l |
	l := #(1 2 3 4) asOrderedCollection.
	l add: 77 beforeIndex: 1.
	self assert: (l =  #(77 1 2 3 4) asOrderedCollection).
	l add: 88 beforeIndex: 3.
	self assert: (l =  #(77 1 88 2 3 4) asOrderedCollection). 
	l add: 99 beforeIndex: l size+1.
	self assert: (l =  #(77 1 88 2 3 4 99) asOrderedCollection). 
	self should:[l add: 666 beforeIndex: 0] raise: Error.
	self should:[l add: 666 beforeIndex: l size+2] raise: Error.

! !

!OrderedCollectionTest methodsFor: 'testStreaming' stamp: 'nice 2/26/2009 11:35'!
testStreamContents
	| oc |
	self shouldnt: [oc := OrderedCollection streamContents: [:stream | 1 to: 3 do: [:i | stream nextPut: i]]]
		raise: Error
		description: 'it should be possible to stream over an OrderedCollection'.
	self assert: oc class = OrderedCollection.
	self assert: oc = (1 to: 3) asOrderedCollection.! !

!OrderedCollectionTest methodsFor: 'testsCopying' stamp: 'nice 2/26/2009 11:54'!
testForceToPadding
	"This is a non regression bug for http://bugs.squeak.org/view.php?id=7296"
	
	| c1 c2 paddingElement |
	"source collection"
	c1 := #(5 3 7 2 ) asOrderedCollection.
	paddingElement := nil.
	
	"force length to longer"
	self shouldnt: [c2 := c1 forceTo: 10 paddingWith: paddingElement] raise: Error.
	self assert: (c1 ~~ c2) description: 'forceTo:paddingWith: should modify a copy'.
	self assert: (c2 size = 10).
	self assert: (c2 copyFrom: 1 to: c1 size) = c1.
	self assert: ((c1 size + 1 to: c2 size) allSatisfy: [:i | (c2 at: i) = paddingElement]).
	
	"force length to shorter"
	self shouldnt: [c2 := c1 forceTo: 3 paddingWith: paddingElement] raise: Error.
	self assert: (c1 ~~ c2) description: 'forceTo:paddingWith: should modify a copy'.
	self assert: (c2 size = 3).
	self assert: (c2 copyFrom: 1 to: 3) = (c1 copyFrom: 1 to: 3).
	
	"SAME TEST BUT PADDING AT START FOLLOWING..."
	
	"force length to longer"
	self shouldnt: [c2 := c1 forceTo: 10 paddingStartWith: paddingElement] raise: Error.
	self assert: (c1 ~~ c2) description: 'forceTo:paddingStartWith: should modify a copy'.
	self assert: (c2 size = 10).
	self assert: (c2 copyFrom: c2 size - c1 size + 1 to: c2 size) = c1.
	self assert: ((1 to: c2 size - c1 size) allSatisfy: [:i | (c2 at: i) = paddingElement]).
	
	"force length to shorter"
	self shouldnt: [c2 := c1 forceTo: 3 paddingStartWith: paddingElement] raise: Error.
	self assert: (c1 ~~ c2) description: 'forceTo:paddingStartWith: should modify a copy'.
	self assert: (c2 size = 3).
	self assert: (c2 copyFrom: 1 to: 3) = (c1 copyFrom: 1 to: 3).! !

