"Change Set:		7689PreferenceBrowser-ar.37

PreferenceBrowser-ar.37:
A fix for clients using custom view registries, such as polymorph. Without a bi-directional mapping between type and view registry these become inaccessible leading to problems if one actually tries to use one.

"!
!PreferenceViewRegistry class methodsFor: 'accessing' stamp: 'ar 8/25/2009 19:38'!
forType: typeName
	"Answer the preference registry for the given type name"
	^typeName caseOf:{
		[#Boolean]	->	[self ofBooleanPreferences].
		[#Color]	->	[self ofColorPreferences].
		[#Font]		->	[self ofFontPreferences].
		[#Number]	->	[self ofNumericPreferences].
		[#String]	->	[self ofTextPreferences].
		[#Halo]		->	[self ofHaloThemePreferences].
		[#WindowColor]	-> [self registryOf: #windowColorPreferences]
	} otherwise:[self registryOf: typeName].! !

!PreferenceViewRegistry class methodsFor: 'accessing' stamp: 'ar 8/25/2009 19:38'!
typeOfRegistry: aRegistry
	"Answer the type name for a particular view registry"
	^aRegistry caseOf:{
		[self ofBooleanPreferences]	-> [#Boolean].
		[self ofColorPreferences]		-> [#Color].
		[self ofFontPreferences]		-> [#Font].
		[self ofNumericPreferences]	-> [#Number].
		[self ofTextPreferences]		-> [#String].
		[self ofHaloThemePreferences]	-> [#Halo].
		[self registryOf: #windowColorPreferences]	-> [#WindowColor].
	} otherwise:[self registries keyAtIdentityValue: aRegistry ifAbsent:[nil]].! !

