"Change Set:		7778Tools-ar.125

Tools-ar.125:
Fix CustomMenu references. There is one last reference left in StringHolder>>offerMenuFrom:shifted: but it will require going through its callers so leave that for another day.

Tools-ar.123:
Fix ChangeSorter labeling.

Tools-dtl.124:
DualChangeSorter class>>open opens a dual change sorter, so ChangeSorter class>>open should open a change sorter (not a Workspace).

"!
!ChangeSorter methodsFor: 'toolbuilder' stamp: 'ar 9/6/2009 16:01'!
buildWith: builder
	"
		ToolBuilder open: ChangeSorter.
	"
	|  windowSpec |
	windowSpec := builder pluggableWindowSpec new.
	windowSpec label: 'Change Sorter'.
	windowSpec model: self.
	windowSpec children: OrderedCollection new.
	windowSpec label: #labelString.
	self buildWith: builder in: windowSpec rect: (0@0 extent: 1@1).
	^builder build: windowSpec! !

!ChangeSorter methodsFor: 'initialize' stamp: 'ar 9/6/2009 16:02'!
initialize
	super initialize.
	myChangeSet := ChangeSet current.! !

!CodeHolder methodsFor: 'what to show' stamp: 'ar 9/7/2009 14:23'!
offerWhatToShowMenu
	"Offer a menu governing what to show"
	| builder menuSpec item |
	builder := ToolBuilder default.
	menuSpec := builder pluggableMenuSpec new.
	self contentsSymbolQuints do: [:aQuint | aQuint == #-
		ifTrue: [menuSpec addSeparator]
		ifFalse: [
			item := menuSpec add: (self perform: aQuint third) 
					target: self selector: aQuint second argumentList: #().
			item help: aQuint fifth.
		].
	].
	builder runModal: (builder open: menuSpec).! !

!ChangeSorter class methodsFor: 'instance creation' stamp: 'dtl 9/6/2009 19:36'!
open
	"Open a new instance of the receiver's class"

	self new open! !

!DualChangeSorter methodsFor: 'toolbuilder' stamp: 'ar 9/6/2009 16:07'!
buildWith: builder
	| windowSpec window |
	leftCngSorter := ChangeSorter new myChangeSet: ChangeSet current.
	leftCngSorter parent: self.
	rightCngSorter := ChangeSorter new myChangeSet: 
			ChangeSorter secondaryChangeSet.
	rightCngSorter parent: self.

	windowSpec := builder pluggableWindowSpec new.
	windowSpec model: self.
	windowSpec label: 'Change Sorter'.
	windowSpec children: OrderedCollection new.
	windowSpec label: #labelString.
	leftCngSorter buildWith: builder in: windowSpec rect: (0@0 extent: 0.5@1).
	rightCngSorter buildWith: builder in: windowSpec rect: (0.5@0 extent: 0.5@1).
	window := builder build: windowSpec.
	leftCngSorter addDependent: window.		"so it will get changed: #relabel"
	rightCngSorter addDependent: window.	"so it will get changed: #relabel"
	^window! !

!Debugger methodsFor: 'context stack menu' stamp: 'ar 9/7/2009 14:45'!
contextStackMenu: aMenu shifted: shifted
	"Set up the menu appropriately for the context-stack-list, either shifted or unshifted as per the parameter provided"

	^ shifted ifFalse:[
		aMenu addList: {
			{'fullStack (f)'.		#fullStack}.
			{'restart (r)'.		#restart}.
			{'proceed (p)'.		#proceed}.
			{'step (t)'.			#doStep}.
			{'step through (T)'.	#stepIntoBlock}.
			{'send (e)'.			#send}.
			{'where (w)'.		#where}.
			{'peel to first like this'.		#peelToFirst}.
			#-.
			{'return entered value'.		#returnValue}.
			#-.
			{'toggle break on entry'.	#toggleBreakOnEntry}.
			{'senders of... (n)'.			#browseSendersOfMessages}.
			{'implementors of... (m)'.	#browseMessages}.
			{'inheritance (i)'.	#methodHierarchy}.
			#-.
			{'versions (v)'.		#browseVersions}.
			{'inst var refs...'.		#browseInstVarRefs}.
			#-.
			{'inst var defs...'.	#browseInstVarDefs}.
			{'class var refs...'.	#browseClassVarRefs}.
			{'class variables'.	#browseClassVariables}.
			#-.
			{'class refs (N)'.		#browseClassRefs}.
			{'browse full (b)'.	#browseMethodFull}.
			{'file out '.			#fileOutMessage}.
			#-.
			{'mail out bug report'.	#mailOutBugReport}.
			{'more...'.		#shiftedYellowButtonActivity}.
		}.
	] ifTrue: [
		aMenu addList: {
			{'browse class hierarchy'.	#classHierarchy}.
			{'browse class'.				#browseClass}.
			{'browse method (O)'.		#openSingleMessageBrowser}.
			{'implementors of sent messages'.		#browseAllMessages}.
			{'change sets with this method'.		#findMethodInChangeSets}.
			#-.
			{'inspect instances'.		#inspectInstances}.
			{'inspect subinstances'.		#inspectSubInstances}.
			#-.
			{'revert to previous version'.			#revertToPreviousVersion}.
			{'remove from current change set'.		#removeFromCurrentChanges}.
			{'revert & remove from changes'.		#revertAndForget}.
			#-.
			{'more...'.					#unshiftedYellowButtonActivity}. 
		}
	].! !

CodeHolder removeSelector: #addContentsTogglesTo:!
