"Change Set:		7949KernelTests-mha.100

KernelTests-mha.100:
made MethodPropertiesTest pass

MethodPropertiesTest >> #propertyDictionaryFor: would ask the passed AdditionalMethodState instance to answer its instance variable named 'properties', which does not exist due to AdditionalMethodState's being implemented as a variable subclass of Object, and hence storing properties in immediate fields.

Also, the tests did not honour the AdditionalMethodState protocol in that they expected AdditionalMethodState >> #properties to return nil in case there were no properties; however, it returns an empty dictionary in these cases. The corresponding checks were changed from #isNil to #isEmpty.

"!
!MethodPropertiesTest methodsFor: 'testing' stamp: 'mha 10/11/2009 20:13'!
testRemoveKeyifAbsent
	method properties at: #zork put: 'hello'.
	self assert: (method properties removeKey: #halt ifAbsent: [ 'hi' ]) = 'hi'.
	self assert: (method properties removeKey: #zork ifAbsent: [ 'hi' ]) = 'hello'.
	self assert: (self propertyDictionaryFor: method) isEmpty.
	self should: (method properties removeKey: #zork ifAbsent: [ 'hi' ]) = 'hi'.
	self assert: (self propertyDictionaryFor: method) isEmpty.! !

!MethodPropertiesTest methodsFor: 'testing' stamp: 'mha 10/11/2009 20:01'!
testAt
	self should: [ method properties at: #zork ] raise: Error.
	self assert: (self propertyDictionaryFor: method) isEmpty.
	method properties at: #zork put: 'hello'.
	self assert: (method properties at: #zork) = 'hello'.! !

!MethodPropertiesTest methodsFor: 'testing' stamp: 'mha 10/11/2009 20:13'!
testRemoveKey
	method properties at: #zork put: 'hello'.
	self should: [ method properties removeKey: #halt ] raise: Error.
	self assert: (method properties removeKey: #zork) = 'hello'.
	self assert: (self propertyDictionaryFor: method) isEmpty.
	self should: [ method properties removeKey: #zork ] raise: Error.
	self assert: (self propertyDictionaryFor: method) isEmpty.! !

!MethodPropertiesTest methodsFor: 'private' stamp: 'mha 10/11/2009 20:13'!
propertyDictionaryFor: aMethod
	^ aMethod properties properties! !

!MethodPropertiesTest methodsFor: 'testing' stamp: 'mha 10/11/2009 20:10'!
testAtIfAbsent
	self assert: (method properties at: #zork ifAbsent: [ 'hello' ]) = 'hello'.
	self assert: (self propertyDictionaryFor: method) isEmpty.
	method properties at: #zork put: 'hi'.
	self assert: (method properties at: #zork ifAbsent: [ 'hello' ]) = 'hi'.! !

!MethodPropertiesTest methodsFor: 'testing' stamp: 'mha 10/11/2009 20:10'!
testIncludesKey
	self deny: (method properties includesKey: #zork).
	self assert: (self propertyDictionaryFor: method) isEmpty.
	method properties at: #zork put: 123.
	self assert: (method properties includesKey: #zork).! !

