"Change Set:		8012Traits-nice.237

Traits-nice.237:
Track selectors usage, use #asSet where due

Traits-nice.236:
use fasterKeys

"!
!TCompilingBehavior methodsFor: 'accessing method dictionary' stamp: 'nice 10/20/2009 20:16'!
selectors
	"Answer a collection of all the message selectors specified in the receiver's 
	method dictionary."

	^ self methodDict keys! !

!TPureBehavior methodsFor: 'traits' stamp: 'nice 10/20/2009 21:45'!
ensureLocalSelectors
	"Ensures that the instance variable localSelectors is effectively used to maintain
	the set of local selectors.
	This method must be called before any non-local selectors are added to the
	method dictionary!!"

	self basicLocalSelectors isNil 
		ifTrue: [self basicLocalSelectors: self selectors asSet]! !

!TraitDescription methodsFor: 'organization' stamp: 'nice 10/19/2009 23:58'!
organization
	"Answer the instance of ClassOrganizer that represents the organization 
	of the messages of the receiver."

	organization ifNil:
		[self organization: (ClassOrganizer defaultList: self methodDict fasterKeys sort)].
	(organization isMemberOf: Array) ifTrue:
		[self recoverFromMDFaultWithTrace].
	
	"Making sure that subject is set correctly. It should not be necessary."
	organization ifNotNil: [organization setSubject: self].
	^ organization! !

!TCompilingBehavior methodsFor: 'user interface' stamp: 'nice 10/20/2009 21:49'!
crossReference
	"Answer an Array of arrays of size 2 whose first element is a message selector in the receiver's method dictionary and whose second element is a set of all message selectors in the method dictionary whose methods send a message with that selector. Subclasses are not included."

	^self selectors asArray sort collect: [:x | Array
			with: (String with: Character cr), x 
			with: (self whichSelectorsReferTo: x)]

	"Point crossReference."! !

