"Change Set:		8016MonticelloConfigurations-nice.64

MonticelloConfigurations-nice.64:
Use #keys rather than #fasterKeys
Note that pattern (x keys asArray sort) could as well be written (x keys sort) now that keys returns an Array...
This #asArray is here solely for cross-dialect/fork compatibility.

"!
!MCConfiguration methodsFor: 'updating' stamp: 'nice 10/21/2009 00:09'!
updateFromRepositories
	| oldInfos newNames sortedNames newDeps |
	oldInfos := self dependencies collect: [:dep | dep versionInfo].
	newNames := Dictionary new.
	self repositories
		do: [:repo | 
			ProgressNotification signal: '' extra: 'Checking ', repo description.
			(repo possiblyNewerVersionsOfAnyOf: oldInfos)
				do: [:newName | newNames at: newName put: repo]]
		displayingProgress: 'Searching new versions'.

	sortedNames := newNames keys asArray sort:
		[:a :b | a numericSuffix > b numericSuffix].

	newDeps := OrderedCollection new.
	self dependencies do: [:dep |
		| newName |
		newName := sortedNames
			detect: [:each | (each copyUpToLast: $-) = dep package name]
			ifNone: [nil].
		newDeps add: (newName
			ifNil: [dep]
			ifNotNil: [
				| repo info  |
				repo := newNames at: newName.
				info := self versionInfoNamed: newName for: dep from: repo.
				info ifNil: [dep]
					ifNotNil: [MCVersionDependency package: dep package info: info]
			])
	] displayingProgress: 'downloading new versions'.

	self dependencies: newDeps.
! !

