"Change Set:		8152MorphicExtras-dtl.55

MorphicExtras-dtl.55:
Restore missing method PartsBin>>listDirection:quadList:buttonClass: used by external package Connectors. Add comment to discourage removal.
Reference: http://lists.squeakfoundation.org/pipermail/squeak-dev/2009-November/140870.html

MorphicExtras-kb.54:
 - fix: http://bugs.squeak.org/view.php?id=7411
   Fixed the building of edge selection menu in  Flaps class >> addLocalFlap.

"!
!Flaps class methodsFor: 'new flap' stamp: 'kb 11/12/2009 11:03'!
addLocalFlap
	"Menu command -- let the user add a new project-local flap.  Once the new flap is born, the user can tell it to become a shared flap.  Obtain an initial name and edge for the flap, launch the flap, and also launch a menu governing the flap, so that the user can get started right away with customizing it."

	| aMenu reply aFlapTab aWorld edge |
	edge := self askForEdgeOfNewFlap.

	edge ifNotNil:
		[reply := UIManager default request: 'Wording for this flap: ' translated initialAnswer: 'Flap' translated.
		reply isEmptyOrNil ifFalse:
			[aFlapTab := self newFlapTitled: reply onEdge: edge.
			(aWorld := self currentWorld) addMorphFront: aFlapTab.
			aFlapTab adaptToWorld: aWorld.
			aMenu := aFlapTab buildHandleMenu: ActiveHand.
			aFlapTab addTitleForHaloMenu: aMenu.
			aFlapTab computeEdgeFraction.
			aMenu popUpEvent: ActiveEvent in: ActiveWorld]]
	
! !

!PartsBin methodsFor: 'initialization' stamp: 'dtl 11/13/2009 00:24'!
listDirection: aListDirection quadList: quadList buttonClass: buttonClass
	"Initialize the receiver to run horizontally or vertically, obtaining its elements from the list of tuples of the form:
		(<receiver> <selector> <label> <balloonHelp>)
	Used by external package Connectors."

	| aButton aClass |
	self layoutPolicy: TableLayout new.
	self listDirection: aListDirection.
	self wrapCentering: #topLeft.
	self layoutInset: 2.
	self cellPositioning: #bottomCenter.

	aListDirection == #leftToRight
		ifTrue:
			[self vResizing: #rigid.
			self hResizing: #spaceFill.
			self wrapDirection: #topToBottom]
		ifFalse:
			[self hResizing: #rigid.
			self vResizing: #spaceFill.
			self wrapDirection: #leftToRight].
	quadList do:
		[:tuple |
			aClass _ Smalltalk at: tuple first.
			aButton _ buttonClass new initializeWithThumbnail: (self class thumbnailForQuad: tuple color: self color) withLabel: tuple third andColor: self color andSend: tuple second to: aClass.
			(tuple size > 3 and: [tuple fourth isEmptyOrNil not]) ifTrue:
				[aButton setBalloonText: tuple fourth].
 			self addMorphBack: aButton]! !

!Flaps class methodsFor: 'new flap' stamp: 'kb 11/12/2009 11:16'!
askForEdgeOfNewFlap

	
	^MenuMorph 
		chooseFrom: (#('left' 'right' 'top' 'bottom') collect: [ :each | each translated ])
		values: #(left right top bottom)
		lines: #()
		title: 'Where should the new flap cling?' translated.
! !

