"Change Set:		8293ST80-dtl.73

ST80-dtl.73:
Better progress display handling and rudimentary MVC implementations for
  Project>>loadFromServer:
  Project>>storeOnServerWithProgressInfo:
  Project>>storeOnServerWithProgressInfoOn:


ST80-dtl.72:
Remove all remaining explicit MVC and Morphic dependencies (hopefully) from class Project.

"!
!MVCProject methodsFor: 'file in/out' stamp: 'dtl 11/29/2009 13:10'!
storeSegmentNoFile
	"For testing.  Make an ImageSegment.  Keep the outPointers in memory.  Also useful if you want to enumerate the objects in the segment afterwards (allObjectsDo:)"

	(World == world) ifTrue: [^ self].		" inform: 'Can''t send the current world out'."
	world isInMemory ifFalse: [^ self].  "already done"
	self projectParameters at: #isMVC put: true.
	^ self	"Only Morphic projects for now"
! !

!MVCProject methodsFor: 'utilities' stamp: 'dtl 11/30/2009 22:34'!
do: aBlock withProgressInfoOn: aMorphOrNil label: aString
	"Evaluate aBlock with a labeled progress bar. Use a simple progress
	bar set to 50% progress. In Morphic, progress is displayed with a
	ComplexProgressIndicator."

	aString
		displayProgressAt: Sensor cursorPoint
		from: 0 to: 2
		during: [:bar |  bar value: 1.
				aBlock value]

! !

!MVCProject methodsFor: 'file in/out' stamp: 'dtl 11/29/2009 13:14'!
storeSegment
	"Store my project out on the disk as an ImageSegment.  Keep the outPointers in memory.  Name it <project name>.seg.  *** Caller must be holding (Project alInstances) to keep subprojects from going out. ***"

	(World == world) ifTrue: [^ false]. 
	"self inform: 'Can''t send the current world out'."
	world isInMemory ifFalse: [^ false].  "already done"
	self projectParameters at: #isMVC put: true.
	^ false	"Only Morphic projects for now"
! !

!MVCProject methodsFor: 'project parameters' stamp: 'dtl 11/28/2009 18:35'!
initializeProjectPreferences
	"Initialize the project's preferences from currently-prevailing preferences that are currently being held in projects in this system"
	
	self flapsSuppressed: true.
	super initializeProjectPreferences
! !

!MVCProject methodsFor: 'file in/out' stamp: 'dtl 11/29/2009 13:23'!
exportSegmentWithChangeSet: aChangeSetOrNil fileName: aFileName
directory: aDirectory
	"Store my project out on the disk as an *exported*
ImageSegment.  All outPointers will be in a form that can be resolved
in the target image.  Name it <project name>.extSeg.  Whatdo we do
about subProjects, especially if they are out as local image
segments?  Force them to come in?
	Player classes are included automatically."

	"Files out a changeSet first, so that a project can contain
its own classes"
	self projectParameters at: #isMVC put: true.
	^ false	"Only Morphic projects for now"
! !

!MVCProject methodsFor: 'file in/out' stamp: 'dtl 11/29/2009 13:26'!
exportSegmentWithCatagories: catList classes: classList fileName: aFileName directory: aDirectory
	"Store my project out on the disk as an *exported* ImageSegment.  All outPointers will be in a form that can be resolved in the target image.  Name it <project name>.extSeg.  What do we do about subProjects, especially if they are out as local image segments?  Force them to come in?
	Player classes are included automatically."

	self flag: #toRemove.
	self halt.  "unused"
	"world == World ifTrue: [^ false]."
	"self inform: 'Can''t send the current world out'."
	self projectParameters at: #isMVC put: true.
	^ false	"Only Morphic projects for now"
! !

