"Change Set:		8366Kernel-ul.325

Kernel-ul.325:
- don't parse the method if the selector is not an alias selector in CompiledMethod >> #getSourceFor:in:. This improves source fetching performance.

"!
!CompiledMethod methodsFor: 'source code management' stamp: 'ul 12/8/2009 07:02'!
getSourceFor: selector in: class
	"Retrieve or reconstruct the source code for this method."
	| flagByte source |
	flagByte := self last.
	(flagByte = 0
		or: [flagByte = 251 "some source-less methods have flag = 251, rest = 0"
			and: [((1 to: 3) allSatisfy: [:i | (self at: self size - i) = 0])]])
		ifTrue:
		["No source pointer -- decompile without temp names"
		^ (class decompilerClass new decompile: selector in: class method: self)
			decompileString].
	flagByte < 252 ifTrue:
		["Magic sources -- decompile with temp names"
		^ ((class decompilerClass new withTempNames: self tempNamesString)
				decompile: selector in: class method: self)
			decompileString].

	"Situation normal;  read the sourceCode from the file"
	
	source := [self getSourceFromFile]
				on: Error
		"An error can happen here if, for example, the changes file has been truncated by an aborted download.  The present solution is to ignore the error and fall back on the decompiler.  A more thorough solution should probably trigger a systematic invalidation of all source pointers past the end of the changes file.  Consider that, as time goes on, the changes file will eventually grow large enough to cover the lost code, and then instead of falling into this error case, random source code will get returned."
				do: [ :ex | ex return: nil].
		
	^source
		ifNotNil: [
			| sourceSelector |
			"I think this is something to do with the traits system.  It would be ncie if someone
			 documented this.  It looks like an egregious hack to me. eem 9/5/2009 09:04"
			(class isAliasSelector: selector)
				ifFalse: [ source ]
				ifTrue: [ "Only alias selectors need this replacement"
					 sourceSelector := Parser parserClass new parseSelector: source.
					 sourceSelector = selector
						ifTrue: [ source ]
						ifFalse: [ self replace: sourceSelector with: selector in: source ] ] ]
		ifNil: [
			"Something really wrong -- decompile blind (no temps)"
			 (class decompilerClass new decompile: selector in: class method: self)
				decompileString]! !

