"Change Set:		8491System-jcg.198

System-jcg.198:
Support for using #future and #future: keywords to conveniently send asynchronous messages.

Core support is in the Kernel package, and the default behavior is defined by Project, in the System package.

"!
!Project methodsFor: 'futures' stamp: 'jcg 12/17/2009 01:27'!
future: receiver do: aSelector at: deltaMSecs args: args
	"Send a message deltaSeconds into the future.  No response is expected."
	| msg |
	msg := MessageSend receiver: receiver selector: aSelector arguments: args.
	deltaMSecs = 0 
		ifTrue: [self addDeferredUIMessage: msg]
		ifFalse: [
			[	(Delay forMilliseconds: deltaMSecs) wait.
				self addDeferredUIMessage: msg.
			] forkAt: Processor userSchedulingPriority + 1.
		]..
	^nil! !

!Project methodsFor: 'futures' stamp: 'jcg 12/17/2009 01:27'!
future: receiver send: aSelector at: deltaMSecs args: args
	"Send a message deltaSeconds into the future.  Answers a Promise that will be resolved at some time in the future."
	| pr |
	pr := Promise new.
	deltaMSecs = 0
		ifTrue: [
			self addDeferredUIMessage: 
				[pr resolveWith: (receiver perform: aSelector withArguments: args)]
		]
		ifFalse: [
			[	(Delay forMilliseconds: deltaMSecs) wait.
				self addDeferredUIMessage: 
					[pr resolveWith: (receiver perform: aSelector withArguments: args)]
			] forkAt: Processor userSchedulingPriority + 1.
		].
	^pr
		! !

