"Change Set:		8525Kernel-ar.336

Kernel-ar.336:
Once more: Convert those trailers!
(but this time the method is idempotent so calling initialize twice should have no effect).

"!
Object subclass: #CompiledMethodTrailer
	instanceVariableNames: 'data encodedData kind size method'
	classVariableNames: 'TrailerClass'
	poolDictionaries: ''
	category: 'Kernel-Methods'!

!CompiledMethodTrailer class methodsFor: 'as yet unclassified' stamp: 'ar 12/22/2009 13:28'!
initialize
	"CompiledMethodTrailer initialize"
	^self convertTrailers
! !

!CompiledMethodTrailer class methodsFor: 'as yet unclassified' stamp: 'ar 12/22/2009 13:28'!
convertTrailers
	| toConvert converted |
	"Protect against doing this in already converted image."
	self usingNewFormat ifTrue:[^self].

	toConvert := OrderedCollection new.
	CompiledMethod allInstancesDo: [:m |
		"we need to convert only methods which has no sourcePointer "
		m sourcePointer = 0 ifTrue: [
			toConvert add: m.
			].
		].

	toConvert := toConvert asArray.
	converted := toConvert collect: [:m |
		m copyWithTrailerBytes: self basicNew initialize. "clear the trailers"
	].

	toConvert elementsExchangeIdentityWith: converted asArray.

	"replace the #trailerClass method in CompiledMethodTrailer class"
	TrailerClass := CompiledMethodTrailer.	
! !

!CompiledMethodTrailer class methodsFor: 'as yet unclassified' stamp: 'ar 12/22/2009 13:27'!
trailerClass
	^TrailerClass ifNil:[OldMethodTrailer]! !

CompiledMethodTrailer initialize!
