"Change Set:		8663Tools-dtl.154

Tools-dtl.154:
Change ChangesOrganizer class>>reorderChangesSets to use 'Project current wakeUpTopWindow' rather than an #isMorphic test.

Tools-dtl.153:
Remove unnecessary #isMorphic sends in SelectorBrowser>>selectorList: and SelectorBrowser>>searchResult:

Move #offerMenuFrom:shifted: from StringHolder to Project to eliminate #isMorphic send.

"!
!ChangesOrganizer class methodsFor: 'services' stamp: 'dtl 12/28/2009 22:55'!
reorderChangeSets
	"Change the order of the change sets to something more convenient:
		First come the project changesets that come with the release.  These are mostly empty.
		Next come all numbered updates.
		Next come all remaining changesets
	In a ChangeSorter, they will appear in the reversed order."

	"ChangeSorter reorderChangeSets"

	| newHead newMid newTail |
	newHead := OrderedCollection new.
	newMid := OrderedCollection new.
	newTail := OrderedCollection new.
	ChangeSet allChangeSets do:
		[:aChangeSet |
			(self belongsInProjectsInRelease: aChangeSet)
				ifTrue:
					[newHead add: aChangeSet]
				ifFalse:
					[(self belongsInNumbered: aChangeSet)
						ifTrue:
							[newMid add: aChangeSet]
						ifFalse:
							[newTail add: aChangeSet]]].
	ChangeSet allChangeSets: newHead, newMid, newTail.
	Project current wakeUpTopWindow! !

!SelectorBrowser methodsFor: 'as yet unclassified' stamp: 'dtl 12/28/2009 18:13'!
searchResult: anExternalSearchResult

	self contents: ''.
	classList := #(). classListIndex := 0.
	selectorIndex := 0.
	selectorList := self listFromResult: anExternalSearchResult.
 	self changed: #messageList.
	self changed: #classList.
	self changed: #contents
! !

!StringHolder methodsFor: '*Tools' stamp: 'dtl 12/28/2009 19:56'!
offerMenuFrom: menuRetriever shifted: aBoolean
	"Pop up a menu whose target is the receiver and whose contents are provided
	by sending the menuRetriever to the receiver. The menuRetriever takes two
	arguments: a menu, and a boolean representing the shift state."

	Project current offerMenuFrom: menuRetriever shifted: aBoolean
! !

!SelectorBrowser methodsFor: 'as yet unclassified' stamp: 'dtl 12/28/2009 18:13'!
selectorList: anExternalList

	self contents: ''.
	classList := #(). classListIndex := 0.
	selectorIndex := 0.
	selectorList := anExternalList.
	self changed: #messageList.
	self changed: #classList.
	self changed: #contents

! !

