"Change Set:		8690Kernel-ar.358

Kernel-ar.358:
Some recategorization and removal of empty categories.

Kernel-ar.357:
Remove obsolete iVars.

"!
ClassDescription subclass: #Metaclass
	instanceVariableNames: 'thisClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-Classes'!

ClassDescription subclass: #Class
	instanceVariableNames: 'subclasses name classPool sharedPools environment category'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-Classes'!

!ClassDescription class methodsFor: 'class initialization' stamp: 'ar 12/30/2009 15:24'!
initialize
	"Do some reformatting of categories"
	{
		Behavior	->	#(#'initialize-release' #accessing #'accessing class hierarchy' #'accessing instances and variables' #'accessing method dictionary' #testing #'testing class hierarchy' #'testing method dictionary' #comparing #'adding/removing methods' #compiling #enumerating #copying #'instance creation' #'obsolete subclasses' #printing #queries #'system startup' #'user interface' #private
		). 
		ClassDescription->#(#'initialize-release' #accessing #'accessing class hierarchy' #'accessing comment' #'accessing method dictionary' #'accessing parallel hierarchy' #compiling #copying #'fileIn/Out' #'instance variables' #organization #printing #private
		). 
		Class->#(#'initialize-release' #accessing #'accessing class hierarchy' #testing #'class name' #'class variables' #compiling #copying #'fileIn/Out' #'instance variables' #organization #'pool variables' #'subclass creation' #private
		). 
		Metaclass->#(#'initialize-release' #accessing #'accessing parallel hierarchy' #testing #'class hierarchy' #compiling #copying #enumerating #'fileIn/Out' #'instance creation' #'instance variables' #'pool variables' #private
		).
		Behavior class->#(#'class initialization' #testing) . 
		ClassDescription class->#(#'class initialization' #traits) . 
		Class class->#(#'fileIn/Out' #'instance creation' #inquiries) . 
		Metaclass class->#(#'anti-corruption')
	} do:[:assoc| | organizer categories |
		organizer := assoc key organization.
		categories := assoc value, 
			(organizer categories reject:[:cat| assoc value includes: cat]).
		organizer categories: categories.
		organizer removeEmptyCategories.
	].! !

!ClassDescription methodsFor: 'organization' stamp: 'al 5/9/2004 14:02'!
notifyOfRecategorizedSelector: element from: oldCategory to: newCategory
	SystemChangeNotifier uniqueInstance selector: element recategorizedFrom: oldCategory to: newCategory inClass: self! !

!Behavior methodsFor: 'comparing' stamp: 'md 2/16/2006 17:50'!
hash
	^ self name hash! !

!Behavior methodsFor: 'accessing' stamp: 'al 9/16/2005 14:22'!
environment
	"Return the environment in which the receiver is visible"
	^Smalltalk! !

!Behavior methodsFor: 'initialize-release' stamp: 'al 12/1/2005 16:01'!
emptyMethodDictionary

	^ MethodDictionary new! !

!Behavior methodsFor: 'initialize-release' stamp: 'ar 12/30/2009 02:56'!
obsolete
	"Invalidate and recycle local methods,
	e.g., zap the method dictionary if can be done safely."
	self canZapMethodDictionary
		ifTrue: [self methodDict: self emptyMethodDictionary].! !

Class removeSelector: #shouldNotBeRedefined!
ClassDescription initialize!
