"Change Set:		8845Files-ul.67

Files-ul.67:
- fix StandardFileStream >> #upTo:

Files-nice.65:
Extend fileNamed:do: protocol to FileDirectory

Files-dtl.66:
Change Set:		compressSources-bf
Date:			14 January 2010
Author:			Bert Freudenberg

Fix compressing sources to preserve utf8 encoding. Fix reading chunks to decode utf8.
TODO: figure out if anything else than chunk reading is used. decode utf8 there, too.

"!
!FileDirectory methodsFor: 'file stream creation' stamp: 'nice 1/12/2010 08:38'!
oldFileNamed: localFileName do: aBlock
	"Open the existing file with the given name in this directory and pass it as argument to aBlock."

	^ FileStream concreteStream oldFileNamed: (self fullNameFor: localFileName) do: aBlock
! !

!StandardFileStream methodsFor: 'read, write, position' stamp: 'ul 1/15/2010 20:16'!
upTo: delim 
	"Fast version to speed up nextChunk"
	| pos buffer count |
	collection ifNotNil: [
		(position < readLimit and: [
			(pos := collection indexOf: delim startingAt: position + 1) <= readLimit and: [
				pos > 0 ] ]) ifTrue: [
					^collection copyFrom: position + 1 to: (position := pos) - 1 ] ].
	pos := self position.
	buffer := self next: 2000.
	(count := buffer indexOf: delim) > 0 ifTrue: 
		["Found the delimiter part way into buffer"
		self position: pos + count.
		^ buffer copyFrom: 1 to: count - 1].
	self atEnd ifTrue:
		["Never found it, and hit end of file"
		^ buffer].
	"Never found it, but there's more..."
	^ buffer , (self upTo: delim)! !

!CompressedSourceStream methodsFor: 'access' stamp: 'bf 1/14/2010 15:11'!
nextChunk
	self flag: #workAround. 	"all accessors should decode utf8"
	^super nextChunk utf8ToSqueak! !

!FileDirectory methodsFor: 'file stream creation' stamp: 'nice 1/12/2010 08:38'!
readOnlyFileNamed: localFileName do: aBlock
	"Open the existing file with the given name in this directory for read-only access and pass it as argument to aBlock."

	^ FileStream concreteStream readOnlyFileNamed: (self fullNameFor: localFileName) do: aBlock
! !

!FileDirectory methodsFor: 'file stream creation' stamp: 'nice 1/12/2010 08:37'!
fileNamed: localFileName do: aBlock
	"Open the file with the given name in this directory for writing and pass it as argument to aBlock."

	^ FileStream concreteStream fileNamed: (self fullNameFor: localFileName) do: aBlock
! !

!FileDirectory methodsFor: 'file stream creation' stamp: 'nice 1/12/2010 08:37'!
forceNewFileNamed: localFileName do: aBlock
	"Open the file with the given name in this directory for writing.  If it already exists, delete it first without asking and pass it as argument to aBlock."

	^ FileStream concreteStream forceNewFileNamed: (self fullNameFor: localFileName) do: aBlock
! !

!FileDirectory methodsFor: 'file stream creation' stamp: 'nice 1/12/2010 08:37'!
newFileNamed: localFileName do: aBlock
	"Create a new file with the given name in this directory and pass it as argument to aBlock."

	^ FileStream concreteStream newFileNamed: (self fullNameFor: localFileName) do: aBlock
! !

