"Change Set:		8951TrueType-nice.14

TrueType-nice.14:
move temp assignment outside block

TrueType-nice.13:
Use ByteArray literals

"!
!TTFileDescription class methodsFor: 'font paths' stamp: 'nice 1/18/2010 19:17'!
findFontFile: fontFileName
	"Find the path containing the font with the given name.
	If it can't be found, return nil."
	
	self fontPathsDo:[:path|
		| fd |
		fd := FileDirectory on: path.
		([fd fileExists: fontFileName] on: Error do:[false]) 
			ifTrue:[^fd fullNameFor: fontFileName].
	].
	^nil! !

!TTFileDescription class methodsFor: 'instance creation' stamp: 'nice 1/18/2010 19:18'!
openFontFile: fontFileName do: aBlock
	"Open the font with the given font file name"
	| fontFilePath file |
	fontFilePath := FontPaths at: fontFileName 
		ifAbsentPut:[self findFontFile: fontFileName].
	fontFilePath ifNil:[^nil].
	file := [FileStream readOnlyFileNamed: fontFilePath] on: Error do:[:ex|
		"We lost the font; someone might have moved it away"
		fontFilePath removeKey: fontFileName ifAbsent:[].
		^nil
	].
	^[aBlock value: file binary] ensure:[file close].! !

!TTFileDescription class methodsFor: 'instance creation' stamp: 'nice 1/18/2010 18:11'!
fontOffsetsInFile: file
	"Answer a collection of font offsets in the given file"
	| tag version nFonts |
	file position: 0.
	tag := file next: 4.
	tag caseOf:{
		['true' asByteArray] -> ["Version 1.0 TTF file"
			"http://developer.apple.com/textfonts/TTRefMan/RM06/Chap6.html
			The values 'true' (0x74727565) and 0x00010000 are recognized by the Mac OS 
			as referring to TrueType fonts."
			^Array with: 0 "only one font"
		].
		[#[0 1 0 0]] -> ["Version 1.0 TTF file"
			^Array with: 0 "only one font"
		].
		['ttcf' asByteArray]	-> ["TTC file"
			version := file next: 4.
			version = #(0 1 0 0) asByteArray ifFalse:[^self error: 'Unsupported TTC version'].
			nFonts := file nextNumber: 4.
			^(1 to: nFonts) collect:[:i| file nextNumber: 4].
		].
	} otherwise:[
		self error: 'This is not a valid Truetype file'.
	].! !

