"Change Set:		8961Tools-dtl.166

Tools-dtl.166:
FileChooser fixes (class examples were broken).

Implement FileChooser class>>new to bypass new behavior in superclass
FileList, not appropriate for FileChooser. Correct spelling errors in method names.

Note: FileChooser is unreferenced in the image. It was introduced in
Squeak 3.9, but is not used in Squeak 3.9 or Squeak trunk. It has a rather
Etoys look about it, but does not appear to be used in Etoys.

"!
!FileChooser class methodsFor: 'examples' stamp: 'dtl 2/1/2010 19:47'!
example3
	"Open file chooser with a system window UI that has a caption pane and shows only picture files."
	"FileChooser example3"
	| fc stream |
	fc := FileChooser new.
	fc initializeAsSystemWindowWithCaptionPane.
	fc setCaption: 'Select a picture file' translated.
	fc setSuffixes: {'png' . 'gif' . 'bmp' . 'jpg' . 'jpeg' }.
	stream := fc open.
	stream ifNotNil: [(Form fromBinaryStream: stream) asMorph openInHand].! !

!FileChooser class methodsFor: 'examples' stamp: 'dtl 2/1/2010 19:46'!
example2
	"Open file chooser with a system window UI."
	"FileChooser example2"
	| fc stream |
	fc := FileChooser new.
	fc initializeAsSystemWindow.
	stream := fc open.
	stream inspect.! !

!FileChooser methodsFor: 'initialization' stamp: 'dtl 2/1/2010 19:47'!
initializeAsSystemWindowWithCaptionPane
	self initializeBasicParameters.
	self createSystemWindowUIWithCaptionPane.! !

!FileChooser methodsFor: 'initialization' stamp: 'dtl 2/1/2010 19:47'!
initializeAsSystemWindow
	self initializeBasicParameters.
	self createSystemWindowUI.! !

!FileChooser class methodsFor: 'examples' stamp: 'dtl 2/1/2010 19:46'!
example1
	"Open file chooser with the standard dialog box UI."
	"FileChooser example1"
	| fc stream |
	fc := FileChooser new.
	fc initializeAsDialogBox.
	stream := fc open.
	stream inspect.! !

!FileChooser methodsFor: 'initialization' stamp: 'dtl 2/1/2010 19:45'!
initializeBasicParameters
	self showShortFileNames: true.
	self setDirectory: FileDirectory default.! !

!FileChooser methodsFor: 'initialization' stamp: 'dtl 2/1/2010 19:47'!
initializeAsDialogBox
	self initializeBasicParameters.
	self createDialogBoxUI.
	self morphicView
		useRoundedCorners;
		color: Preferences menuColor;
		adoptPaneColor: Preferences menuLineColor.
	self 
		setCaptionColor: Preferences menuTitleColor;
		setButtonColor: Preferences menuColor.! !

!FileChooser class methodsFor: 'instance creation' stamp: 'dtl 2/1/2010 19:49'!
new
	"Superclass may attempt to initialize to a specific default directory. Bypass
	that behavior."

	^ self basicNew initialize! !

!FileChooser class methodsFor: 'examples' stamp: 'dtl 2/1/2010 19:46'!
example4
	"Open file chooser with a customized dialog box UI. The order of the messages is important. In general, call the initialize method first, then modify things, and finally call open."
	"FileChooser example4"
	| fc stream |
	fc := FileChooser new.
	fc initializeAsDialogBox.
	fc setDirectory: FileDirectory root.
	fc setSuffixes: {'png' . 'gif' . 'bmp' . 'jpg' . 'jpeg' }.
	fc setCaption: 'Select a picture file' translated.
	fc morphicView 
		borderColor: Color black; 
		borderWidth: 2;
		color: Color white.
	fc setPaneColor: Color gray muchLighter.
	fc captionPane color: Color orange muchLighter.
	fc okButton color: Color green muchLighter.
	fc cancelButton color: Color blue muchLighter.
	fc morphicView position: 20@20.
	stream := fc open.
	stream ifNotNil: [(Form fromBinaryStream: stream) asMorph openInHand].! !

FileChooser removeSelector: #initalizeAsDialogBox!
FileChooser removeSelector: #initalizeAsSystemWindow!
FileChooser removeSelector: #initalizeAsSystemWindowWithCaptionPane!
FileChooser removeSelector: #initalizeBasicParameters!
