"Change Set:		9244Morphic-ar.322

Morphic-ar.322:
Merging Morphic-cmm.321

- Recovered 'Auto Indent' preference lost back in 3.9, updated for the new TextEditor and Preference Pragma's.

Morphic-cmm.319:
Fix for potential World lockup due to the
UI process waiting for the #next of an empty deferredUIMessages.  For discussion:

http://lists.squeakfoundation.org/pipermail/squeak-dev/2009-March/135119.html

Morphic-cmm.320:
Fix for TextAnchor.  See http://lists.squeakfoundation.org/pipermail/squeak-dev/2008-December/133305.html for discussion.  Also, http://bugs.squeak.org/view.php?id=7248.

Morphic-cmm.321:
- Recovered 'Auto Indent' preference lost back in 3.9, updated for the new TextEditor and Preference Pragma's.

Morphic-ar.320:
Restore execution timeout for deferred ui message processing which was lost in previous change.

"!
Editor subclass: #TextEditor
	instanceVariableNames: 'model paragraph pointBlock markBlock beginTypeInBlock emphasisHere otherInterval lastParenLocation oldInterval'
	classVariableNames: 'AutoIndent ChangeText FindText UndoInterval UndoMessage UndoParagraph UndoSelection Undone'
	poolDictionaries: ''
	category: 'Morphic-Text Support'!

!TextEditor methodsFor: 'typing/selecting keys' stamp: 'cmm 2/5/2010 11:28'!
tabCount
	^ self class autoIndent
		ifTrue:
			[ | tabCount s i char |
			s := paragraph string.
			i := self stopIndex.
			tabCount := 0.
			[(i := i-1) > 0 and: [(char := s at: i) ~= Character cr]]
				whileTrue:  "Count tabs and brackets (but not a leading bracket)"
				[(char = Character tab and: [i < s size and: [(s at: i+1) ~= $[ ]]) ifTrue: [tabCount := tabCount + 1].
				char = $[ ifTrue: [tabCount := tabCount + 1].
				char = $] ifTrue: [tabCount := tabCount - 1]].
			tabCount ]
		ifFalse: [ 0 ]! !

!TextEditor methodsFor: 'typing/selecting keys' stamp: 'cmm 2/5/2010 11:25'!
crWithIndent: characterStream 
	"Replace the current text selection with CR followed by as many tabs
	as on the current line (+/- bracket count) -- initiated by Shift-Return."
	sensor keyboard.		"flush character"
	characterStream crtab: self tabCount.  "Now inject CR with tabCount tabs"
	^ false! !

!TextEditor class methodsFor: 'accessing' stamp: 'cmm 2/5/2010 11:17'!
autoIndent
	<preference: 'Auto Indent'
		category: 'Morphic'
		description: 'When true, tabs will be inserted after pressing Enter | Return such that the new line will be indented equally with the previous line.'
		type: #Boolean>
	^ AutoIndent ifNil: [ true ]! !

!TextEditor class methodsFor: 'accessing' stamp: 'cmm 2/5/2010 11:16'!
autoIndent: aBoolean
	AutoIndent := aBoolean! !

!TextEditor methodsFor: 'accessing' stamp: 'jmv 11/4/2008 11:51'!
totalTextHeight

	^paragraph lines last bottom! !

!TextEditor methodsFor: 'accessing' stamp: 'jmv 11/4/2008 11:51'!
visibleHeight

	^morph owner bounds height! !

!WorldState methodsFor: 'stepping' stamp: 'ar 2/4/2010 22:37'!
runStepMethodsIn: aWorld
	"Perform periodic activity inbetween event cycles"
	| queue msg limit stamp |
	"Limit processing of deferredUIMessages to a max. amount of time"
	limit := self class deferredExecutionTimeLimit.
	stamp := Time millisecondClockValue.
	queue := self class deferredUIMessages.
	[(Time millisecondsSince: stamp) >= limit 
		or:[(msg := queue nextOrNil) == nil]] 
			whileFalse: [msg value].
	self runLocalStepMethodsIn: aWorld.
! !

