"Change Set:		9245MorphicTests-ar.13

MorphicTests-ar.13:
Add a test for deferred ui queue timeout.

"!
ClassTestCase subclass: #WorldStateTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicTests-Worlds'!

!WorldStateTest methodsFor: 'tests' stamp: 'ar 2/4/2010 22:44'!
testDeferredUIQueueTimeout
	"Ensure that the World's deferredUIMessage will take no more time than
	specified by WorldState's deferredExecutionTimeLimit"
	| firstWasRun secondWasRun thirdWasRun |
	firstWasRun := secondWasRun := thirdWasRun := false.
	WorldState addDeferredUIMessage:[
		firstWasRun := true.
		(Delay forMilliseconds: WorldState deferredExecutionTimeLimit + 50) wait.
	].
	WorldState addDeferredUIMessage:[
		secondWasRun := true.
	].
	WorldState addDeferredUIMessage:[
		thirdWasRun := true.
	].
	self deny: firstWasRun.
	self deny: secondWasRun.
	self deny: thirdWasRun.
	World doOneCycleNow.
	self assert: firstWasRun.
	self deny: secondWasRun.
	self deny: thirdWasRun.
	World doOneCycleNow.
	self assert: firstWasRun.
	self assert: secondWasRun.
	self assert: thirdWasRun.
! !

