"Change Set:		9249Tests-ar.45

Tests-ar.45:
Add a consistency test to ensure that the Windows VM's 3ButtonMouse preference is consistent with the swapMouseButton setting.

"!
TestCase subclass: #Win32VMTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-VM'!

!Win32VMTest methodsFor: 'tests' stamp: 'ar 2/8/2010 14:28'!
testWinVM3ButtonMousePreference
	"Ensure that swapMouseButtons agrees with 3ButtonMouse preference"
	| iniData iniPref exePath |
	SmalltalkImage current platformName = 'Win32' ifFalse:[^self].
	exePath := SmalltalkImage current getSystemAttribute: 0.
	iniData := [
		(FileStream readOnlyFileNamed: (exePath copyUpToLast: $.), '.ini')
			 contentsOfEntireFile
	] on: Error do:[:ex| ex return: ''].
	iniPref := false. "default is OFF"
	iniData linesDo:[:line|
		(line beginsWith: '3ButtonMouse') ifTrue:[
			iniPref := (line copyAfter: $=) withBlanksTrimmed ~= '0'.
		].
	].
	self assert: iniPref = Preferences swapMouseButtons.
! !

