"Change Set:		9258System-dtl.247

System-dtl.247:
Remove VMC/Morphic dependencies from Form, FileList2, and Imports
Update Imports>>viewImages
Add Project>>formViewClass
Add Project>>openImage:name:saveResource:

System-dtl.245:
Remove explicit reference to MVC ParagraphEditor in Preferences class>>noviceModeSettingChanged.
Add comment and #flag: markers in Project>>dispatchTo:addPrefixAndSend:withArguments: to explain that this method should be replaced by proper ToolBuilder support in classes that use it (PluggableFileList and PopUpMenu so far).

System-dtl.246:
Change HTTPClient to use Project current rather than MVC ScreenController

"!
Model subclass: #Project
	instanceVariableNames: 'world changeSet transcript parentProject previousProject displayDepth viewSize thumbnail nextProject guards projectParameters version urlList environment lastDirectory lastSavedAtSeconds projectPreferenceFlagDictionary resourceManager'
	classVariableNames: 'AllProjects CurrentProject GoalFreePercent GoalNotMoreThan LastScreenModeSelected UIProcess'
	poolDictionaries: ''
	category: 'System-Support'!

!Project methodsFor: 'menu messages' stamp: 'dtl 2/10/2010 10:12'!
fullScreenOff

	Display fullScreenMode: (LastScreenModeSelected := false).
	DisplayScreen checkForNewScreenSize.
	self restoreDisplay.
! !

!Project methodsFor: 'menu messages' stamp: 'dtl 2/10/2010 10:12'!
fullScreenOn

	Display fullScreenMode: (LastScreenModeSelected := true).
	DisplayScreen checkForNewScreenSize.
	self restoreDisplay.! !

!Project methodsFor: 'dispatching' stamp: 'dtl 2/9/2010 22:35'!
dispatchTo: requestor addPrefixAndSend: baseSelector withArguments: arguments
	"Sender wants to perform a method with dependencies on the type of project.
	Dispatch to an appropriate method for the current project.
	
	This method is a workaround for lack of proper ToolBuilder support in the sender,
	and should be eliminated when possible (dtl Feb 2010)"

	| selector |
	"Flag target selectors to help identify senders"
	self flag: #mvcOpenLabel:in: .
	self flag: #morphicOpenLabel:in: .
	self flag: #mvcStartUpLeftFlush .
	self flag: #morphicStartUpLeftFlush .
	self flag: #mvcStartUpWithCaption:icon:at:allowKeyboard: .
	self flag: #morphicStartUpWithCaption:icon:at:allowKeyboard: .
	self flag: #mvcOpen: .
	self flag: #morphicOpen: .
	self flag: #mvcOpen .
	self flag: #morphicOpen .
	
	selector := (self selectorPrefixForDispatch, baseSelector) asSymbol.
	^ requestor perform: selector withArguments: arguments! !

!Project methodsFor: 'editors' stamp: 'dtl 2/10/2010 15:26'!
openImage: aForm name: fullName saveResource: aBoolean
	"Open a view on an image. If aBoolean is true, save the image as a project resource."

	self subclassResponsibility! !

!Project methodsFor: 'accessing' stamp: 'dtl 2/10/2010 10:17'!
lastScreenModeSelected

	^LastScreenModeSelected ifNil: [LastScreenModeSelected := false]! !

!Preferences class methodsFor: 'reacting to change' stamp: 'dtl 1/31/2010 22:16'!
noviceModeSettingChanged
	"The current value of the noviceMode flag has changed;  
	now react"
	TheWorldMainDockingBar updateInstances.
	PasteUpMorph allSubInstances
		select: [:each | each isWorldMorph]
		thenDo: [:each | each initializeDesktopCommandKeySelectors].
	(Smalltalk hasClassNamed: #ParagraphEditor)
		ifTrue: [Smalltalk at: #ParagraphEditor initialize]! !

!HTTPClient class methodsFor: 'testing' stamp: 'dtl 2/10/2010 10:15'!
shouldUsePluginAPI
	"HTTPClient shouldUsePluginAPI" 

	self isRunningInBrowser
		ifFalse: [^false].
	self browserSupportsAPI
		ifFalse: [^false].
	"The Mac plugin calls do not work in full screen mode"
	^((SmalltalkImage current  platformName = 'Mac OS')
		and: [Project current lastScreenModeSelected]) not! !

!Project methodsFor: 'editors' stamp: 'dtl 2/10/2010 13:19'!
formViewClass
	"Answer a class suitable for a view on a form or collection of forms"

	self subclassResponsibility! !

!Imports methodsFor: 'images' stamp: 'dtl 2/10/2010 13:22'!
viewImages
	"Open up a special Form inspector on the dictionary of graphical imports."
	"Imports default viewImages"

	imports size isZero ifTrue:
		[^ self inform: 
'The ImageImports repository is currently empty,
so there is nothing to view at this time.  You can
use a file list to import graphics from external files
into Imports, and once you have done that,
you will find this command more interesting.'].
	
	Project current formViewClass openOn:  imports withLabel: 'Graphical Imports'

! !

