"Change Set:		9334Graphics-dtl.106

Graphics-dtl.106:
Remove explicit references to MVC Paragraph from TextPrinter.
Note - TextPrinter is used only by Paragraph in the image but appears to be of general utility.

"!
!TextPrinter methodsFor: 'printing' stamp: 'dtl 2/12/2010 20:16'!
printText: aText
	"Print aText"
	| paragraphClass |
	form isNil ifTrue:[
		form := Form extent: self pixelSize depth: depth.
	].
	paragraphClass := Smalltalk at: #Paragraph
				ifAbsent: [^ self notify: 'MVC class Paragraph not present'].
	para := paragraphClass withText: aText asText.
	Cursor wait showWhile:[
		self printParagraph.
	].! !

!TextPrinter methodsFor: 'header' stamp: 'dtl 2/12/2010 20:15'!
headerParagraph
	"Return a paragraph for the footer"
	| hPara rect paragraphClass |
	paragraphClass := Smalltalk at: #Paragraph
				ifAbsent: [^ self notify: 'MVC class Paragraph not present'].
	hPara := paragraphClass new.
	hPara destinationForm: form.
	rect := (self in2pix: self textArea topLeft - (0.0@self headerHeight)) corner: 
				(self in2pix: self textArea topRight).
	hPara clippingRectangle: rect.
	hPara compositionRectangle: rect.
	^hPara! !

!TextPrinter methodsFor: 'footer' stamp: 'dtl 2/12/2010 20:15'!
footerParagraph
	"Return a paragraph for the footer"
	| fPara rect paragraphClass |
	paragraphClass := Smalltalk at: #Paragraph
				ifAbsent: [^ self notify: 'MVC class Paragraph not present'].
	fPara := paragraphClass new.
	fPara destinationForm: form.
	rect := (self in2pix: self textArea bottomLeft) corner: 
				(self in2pix: self textArea bottomRight + (0.0@self footerHeight)).
	fPara clippingRectangle: rect.
	fPara compositionRectangle: rect.
	^fPara! !

