"Change Set:		9468SMBase-nice.97

SMBase-nice.97:
Use FileDirectory>>#newFileNamed:do:

"!
!SMAccount methodsFor: 'files' stamp: 'nice 1/12/2010 08:42'!
newFile: fileName block: aBlock
	"Create a new file. Let <aBlock> fill the file with content by calling it with a stream."

	| dir |
	dir := self uploadsDirectory.
	(dir fileExists: fileName) ifTrue:[dir deleteFileNamed: fileName].
	dir newFileNamed: fileName do: [:stream |
		stream binary.
		aBlock value: stream]! !

!SMFileCache methodsFor: 'services' stamp: 'nice 1/13/2010 08:29'!
download: aDownloadable 
	"Download the file for this SMObject into the local file cache.
	If the file already exists, delete it.
	No unpacking or installation into the running image."

	
	[ | dir fileName |
	fileName := aDownloadable downloadFileName.
	fileName
		ifNil: [self inform: 'No download url, can not download.'.
			^ false].
	fileName isEmpty
		ifTrue: [self inform: 'Download url lacks filename, can not download.'.
			^ false].
	dir := aDownloadable cacheDirectory.
	[ | stream |
	stream := self getStream: aDownloadable.
	stream ifNil: [^ false].
	(dir fileExists: fileName)
		ifTrue: [dir deleteFileNamed: fileName].
	dir newFileNamed: fileName do: [:file | file binary; nextPutAll: stream contents]]]
		on: Error
		do: [^ false].
	^ true! !

