"Change Set:		9481Tests-nice.49

Tests-nice.49:
merge ar.48 nice.48

Tests-kb.47:
 - fix: MCSnapshotBrowserTest by using ToolBuilder to build the morph if it's available.

Tests-ar.48:
Add a test for SecureHashAlgorithm with empty input.

Tests-nice.48:
Cuis 2.2 ScannerTestFix

"!
!ScannerTest methodsFor: 'testing' stamp: 'jmv 2/24/2010 10:03'!
testLiteralSymbols

	self assert: ('*+-/\~=<>&@%,|' allSatisfy: [:char | Scanner isLiteralSymbol: (String with: char) asSymbol])
		description: 'single letter binary symbols can be printed without string quotes'.
		
	self assert: (#('x' 'x:' 'x:y:' 'from:to:by:' 'yourself') allSatisfy: [:str | Scanner isLiteralSymbol: str asSymbol])
		description: 'valid ascii selector symbols can be printed without string quotes'.
		
	((32 to: 126) collect: [:ascii | Character value: ascii]) ,
	#(':x:yourself' '::' 'x:yourself' '123' 'x0:1:2:' 'x.y.z' '1abc' 'a1b0c2' ' x' 'x ' '+x-y' '||' '--' '++' '+-' '+/-' '-/+' '<|>' '#x' '()' '[]' '{}' '')
		do: [:str |
			self assert: (Compiler evaluate: str asSymbol printString) = str asSymbol
				description: 'in all case, a Symbol must be printed in an interpretable fashion']! !

!MCSnapshotBrowserTest methodsFor: 'testing' stamp: 'kb 2/24/2010 21:58'!
testAnnotationPane
	| oldPref |
	oldPref := Preferences annotationPanes.

	Preferences disable: #annotationPanes.
	self buildWindow.
	self assert: (self morphsOfClass: TextMorph) size = 1.

	Preferences enable: #annotationPanes.
	self buildWindow.
	self assert: (self morphsOfClass: TextMorph) size = 2.

	Preferences setPreference: #annotationPanes toValue: oldPref! !

!SecureHashAlgorithmTest methodsFor: 'testing - examples' stamp: 'ar 2/25/2010 23:40'!
testEmptyInput
	self assert: ((SecureHashAlgorithm new hashMessage: '') radix: 16)
			= 'DA39A3EE5E6B4B0D3255BFEF95601890AFD80709'! !

!MCSnapshotBrowserTest methodsFor: 'morphic' stamp: 'kb 2/24/2010 21:57'!
buildWindow

	Smalltalk at: #ToolBuilder ifPresent: [:tb | 
		morph := tb build: model. 
		^self ].
	morph := model buildWindow.! !

!MCSnapshotBrowserTest methodsFor: 'running' stamp: 'kb 2/24/2010 21:57'!
setUp
	model := MCSnapshotBrowser forSnapshot: MCSnapshotResource current snapshot.
	self buildWindow! !

