"Change Set:		9708MorphicExtras-cmm.80

MorphicExtras-cmm.80:
- More improved guads of authorInitialsPerSe.

"!
!SqueakPage class methodsFor: 'as yet unclassified' stamp: 'cmm 3/9/2010 15:14'!
newURLAndPageFor: aMorph
	"Create a new SqueakPage whose contents is the given morph. Assign a URL for that page, record it in the page cache, and answer its URL."

	| pg newURL stamp |
	pg := self new.
	stamp := Utilities authorInitialsPerSe.
	stamp isEmptyOrNil ifTrue: [ stamp := '*' ].
	pg saveMorph: aMorph author: stamp.
	newURL := SqueakPageCache generateURL.
	SqueakPageCache atURL: newURL put: pg.
	^ newURL! !

!SqueakPage methodsFor: 'saving' stamp: 'cmm 3/9/2010 15:14'!
write
	"Decide whether to write this page on the disk."
	| sf |
	policy == #neverWrite ifTrue: [^ self].
		"demo mode, or write only when user explicitly orders it"

	"All other policies do write:   #now"
	contentsMorph ifNil: [^ self].
	dirty := dirty | ((contentsMorph valueOfProperty: #pageDirty) == true).
		"set by layoutChanged"
	dirty == true ifTrue: [ 
		sf := ServerDirectory new fullPath: url.
		"check for shared password"
		"contentsMorph allMorphsDo: [:m | m prepareToBeSaved].
				done in objectToStoreOnDataStream"
		lastChangeAuthor := Utilities authorInitialsPerSe.
		lastChangeAuthor isEmptyOrNil ifTrue: [ lastChangeAuthor := '*'].
		lastChangeTime := Time totalSeconds.
		Cursor wait showWhile: [ | remoteFile |
			remoteFile := sf fileNamed: url.	"no notification when overwriting"
			remoteFile dataIsValid.
			remoteFile fileOutClass: nil andObject: self.
			"remoteFile close"].
		contentsMorph setProperty: #pageDirty toValue: nil.
		dirty := false].! !

