"Change Set:		9809Morphic-ar.395

Morphic-ar.395:
Merging Morphic-tfel.394:

Updates to Menu
	* Use the new buttons
	* Fix the highlighting for the pin icon
	* Fix the shadow

(ar: changed postscript to not nuke custome window title fonts and avoid odd effects after recreating label areas)

Morphic-ar.388:
Updated preferences for ongoing facelift.

Morphic-laza.389:
make inactive Window buttons dimmed

Morphic-mha.390:
cache dimmed and highlighted forms for SystemWindowButtons

Morphic-mha.391:
also cache darkened forms of IconicButtons to avoid 'black wholes', whatever those are ;-)

Morphic-laza.392:
Make the progress bar color like the list selection color

Morphic-bf.393:
- dim inactive window's title bar buttons (but keep them responsive)

Morphic-tfel.394:
Updates to Menu
	* Use the new buttons
	* Fix the highlighting for the pin icon
	* Fix the shadow
	
Updates to System Window
	* adjust title font size


"!
IconicButton subclass: #SystemWindowButton
	instanceVariableNames: 'dimmed dimmedForm highlightedForm'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Windows'!

SimpleButtonMorph subclass: #IconicButton
	instanceVariableNames: 'darkenedForm'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Widgets'!

RectangleMorph subclass: #SystemProgressBarMorph
	instanceVariableNames: 'barSize'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Widgets'!

!SystemWindowButton methodsFor: 'accessing' stamp: 'laza 3/25/2010 14:19'!
unlock
	self restoreImage.
	super unlock! !

!SystemWindowButton methodsFor: 'accessing' stamp: 'bf 3/26/2010 10:24'!
lock
	self firstSubmorph form: self dimmedForm.
	super lock! !

!MenuMorph class methodsFor: 'instance creation' stamp: 'tfel 3/26/2010 11:47'!
initialize

	"MenuMorph initialize"
	CloseBoxImage := nil.
	PushPinImage := nil.

! !

!SystemWindow methodsFor: 'top window' stamp: 'bf 3/26/2010 10:34'!
undimWindowButtons
	{closeBox. collapseBox. menuBox. expandBox}
		do: [:b | b ifNotNil: [b undim]]! !

!MenuMorph methodsFor: 'initialization' stamp: 'nice 1/1/2010 21:56'!
setDefaultParameters
	"change the receiver's appareance parameters"

	| colorFromMenu worldColor menuColor |
	
	colorFromMenu := Preferences menuColorFromWorld
									and: [Display depth > 4
									and: [(worldColor := self currentWorld color) isColor]].

	menuColor := colorFromMenu
						ifTrue: [worldColor luminance > 0.7
										ifTrue: [worldColor mixed: 0.85 with: Color black]
										ifFalse: [worldColor mixed: 0.4 with: Color white]]
						ifFalse: [Preferences menuColor].

	self color: menuColor.
	self borderWidth: Preferences menuBorderWidth.

	Preferences menuAppearance3d ifTrue: [
		self borderStyle: BorderStyle thinGray.
		self
			addDropShadow;
			shadowColor: (TranslucentColor r: 0.0 g: 0.0 b: 0.0 alpha: 0.666);
			shadowOffset: 1 @ 1
	]
	ifFalse: [
		| menuBorderColor |
		menuBorderColor := colorFromMenu
										ifTrue: [worldColor muchDarker]
										ifFalse: [Preferences menuBorderColor].
		self borderColor: menuBorderColor.
	].


	self layoutInset: 3.
! !

!SystemWindow class methodsFor: 'initializing' stamp: 'ar 3/24/2010 21:29'!
initialize
	"SystemWindow initialize"
	
	CollapseBoxImage := nil.
	CloseBoxImage := nil.
	ExpandBoxImage := nil.
	MenuBoxImage := nil.
	
	self updatePreferences.! !

!SystemWindow methodsFor: 'top window' stamp: 'bf 3/26/2010 10:35'!
lockInactivePortions
	"Make me unable to respond to mouse and keyboard.  Control boxes remain active, except in novice mode"

	self submorphsDo: [:m | m == labelArea ifFalse: [m lock]].
	self dimWindowButtons.
	labelArea ifNotNil: 
		[labelArea submorphsDo: 
				[:m | 
					(Preferences noviceMode or: [m ~~ closeBox and: [m ~~ collapseBox]]) 
						ifTrue: [m lock]]]
		ifNil: "i.e. label area is nil, so we're titleless"
			[self adjustBorderUponDeactivationWhenLabeless].! !

!SystemWindow methodsFor: 'top window' stamp: 'bf 3/26/2010 09:35'!
passivate
	"Make me unable to respond to mouse and keyboard"

	label ifNotNil: [label color: Color darkGray].
	self setStripeColorsFrom: self paneColorToUse.
	model modelSleep.

	self lockInactivePortions
! !

!SystemWindow methodsFor: 'top window' stamp: 'bf 3/26/2010 11:06'!
activateWindow
	"Bring me to the front and make me able to respond to mouse and keyboard.
	Was #activate (sw 5/18/2001 23:20)"

	| oldTop outerMorph sketchEditor pal |
	outerMorph := self topRendererOrSelf.
	outerMorph owner ifNil: [^ self "avoid spurious activate when drop in trash"].
	oldTop := TopWindow.
	oldTop = self ifTrue: [^self].
	TopWindow := self.
	oldTop ifNotNil: [oldTop passivate].
	outerMorph owner firstSubmorph == outerMorph
		ifFalse: ["Bring me (with any flex) to the top if not already"
				outerMorph owner addMorphFront: outerMorph].
	self submorphsDo: [:m | m unlock].

	label ifNotNil: [label color: Color black].

	self undimWindowButtons.
	labelArea ifNotNil:
		[labelArea submorphsDo: [:m | m unlock; show].
		self setStripeColorsFrom: self paneColorToUse].
	self isCollapsed ifFalse:
		[model modelWakeUpIn: self.
		self positionSubmorphs.
		labelArea ifNil: [self adjustBorderUponActivationWhenLabeless]].

	(sketchEditor := self extantSketchEditor) ifNotNil:
		[sketchEditor comeToFront.
		(pal := self world findA: PaintBoxMorph) ifNotNil:
			[pal comeToFront]].
! !

!SystemWindow methodsFor: 'initialization' stamp: 'tfel 3/25/2010 23:00'!
addLabelArea

	labelArea ifNotNil: [labelArea abandon].
	labelArea := (AlignmentMorph newSpacer: Color transparent)
			vResizing: #spaceFill;
			layoutPolicy: ProportionalLayout new.
	self addMorph: labelArea.! !

!SystemWindowButton methodsFor: 'visual properties' stamp: 'bf 3/26/2010 09:03'!
dim
	dimmed := true.
	self restoreImage.! !

!SystemWindowButton methodsFor: 'visual properties' stamp: 'bf 3/26/2010 09:14'!
undim
	dimmed := false..
	self isLocked ifFalse: [self restoreImage].! !

!SystemWindow methodsFor: 'top window' stamp: 'bf 3/26/2010 10:49'!
dimWindowButtons
	self == TopWindow ifFalse: [
		{closeBox. collapseBox. menuBox. expandBox}
			do: [:b | b ifNotNil: [b dim]]]! !

!SystemProgressBarMorph methodsFor: 'initialization' stamp: 'laza 3/26/2010 09:53'!
initialize
	super initialize.

	self
		borderWidth: 0;
		color: Preferences menuColor muchLighter.
		
	barSize := 0.
! !

!IconicButton methodsFor: 'as yet unclassified' stamp: 'bf 3/26/2010 09:01'!
darkenedForm
	^ darkenedForm ifNil: [ darkenedForm := self firstSubmorph baseGraphic darker ]! !

!SystemWindowButton methodsFor: 'visual properties' stamp: 'bf 3/26/2010 09:01'!
dimmedForm
	^ dimmedForm ifNil: [ dimmedForm := self firstSubmorph baseGraphic dimmed ]! !

!SystemWindow class methodsFor: 'initializing' stamp: 'ar 3/24/2010 21:28'!
updatePreferences
	"Temporary method to update system-wide preferences"
	Preferences setPreference: #defaultWindowColor toValue: (Color veryVeryLightGray muchLighter).
	(Preferences dictionaryOfPreferences at: #defaultWindowColor) defaultValue: (Color veryVeryLightGray muchLighter).

	Preferences setPreference: #menuAppearance3d toValue: true.
	(Preferences dictionaryOfPreferences at: #menuAppearance3d) defaultValue: true.

	Preferences setPreference: #menuColorFromWorld toValue: false.
	(Preferences dictionaryOfPreferences at: #menuColorFromWorld) defaultValue: false.

	Preferences setPreference: #roundedMenuCorners toValue: false.
	(Preferences dictionaryOfPreferences at: #roundedMenuCorners) defaultValue: false.

	Preferences setParameter: #menuColor to: (Color gray: 0.9).
	Preferences setParameter: #menuTitleColor to: (Color transparent).
	Preferences setParameter: #menuTitleBorderWidth to: 0.
	Preferences setParameter: #defaultWorldColor to: (Color gray: 0.25).

	Preferences setPreference: #showSplitterHandles toValue: true.
	(Preferences dictionaryOfPreferences at: #showSplitterHandles) defaultValue: true.

	Preferences setPreference: #showSharedFlaps toValue: false.
	(Preferences dictionaryOfPreferences at: #showSharedFlaps) defaultValue: false.

	Preferences installUniformWindowColors.

	CornerGripMorph drawCornerResizeHandles: false.
	FillInTheBlankMorph roundedDialogCorners: true.

	LazyListMorph
		listSelectionColor: LazyListMorph listSelectionColor;
		listSelectionTextColor: Color black.
	PluggableButtonMorph roundedButtonCorners: true.
	SystemWindow
		clickOnLabelToEdit: false;
		doubleClickOnLabelToExpand: true;
		moveMenuButtonRight: true;
		hideExpandButton: false.
! !

!MenuMorph methodsFor: 'construction' stamp: 'tfel 3/25/2010 07:24'!
addTitle: aString icon: aForm updatingSelector: aSelector updateTarget: aTarget 
	"Add a title line at the top of this menu Make aString its initial  
	contents.  
	If aSelector is not nil, then periodically obtain fresh values for  
	its  
	contents by sending aSelector to aTarget.."
	| title titleContainer |
	title := AlignmentMorph newColumn.
	self setTitleParametersFor: title.
	""
	aForm isNil
		ifTrue: [titleContainer := title]
		ifFalse: [| pair | 
			pair := AlignmentMorph newRow.

			pair color: Color transparent.
			pair hResizing: #shrinkWrap.
			pair layoutInset: 0.
			""
			pair addMorphBack: aForm asMorph.
			""
			titleContainer := AlignmentMorph newColumn.
			titleContainer color: Color transparent.
			titleContainer vResizing: #shrinkWrap.
			titleContainer wrapCentering: #center.
			titleContainer cellPositioning: #topCenter.
			titleContainer layoutInset: 0.
			pair addMorphBack: titleContainer.
			""
			title addMorphBack: pair].
	""
	aSelector
		ifNil: [""
			aString asString
				linesDo: [:line | titleContainer 
					addMorphBack: ((StringMorph 
										contents: line 
										font: Preferences standardMenuFont)
										color: (Color black);
										yourself)]]
		ifNotNil: [| usm | 
			usm := UpdatingStringMorph on: aTarget selector: aSelector.
			usm font: Preferences standardMenuFont.
			usm useStringFormat.
			usm lock.
			titleContainer addMorphBack: usm].
	""
	title setProperty: #titleString toValue: aString.
	self addMorphFront: title.
	""
	title useSquareCorners.
	(self hasProperty: #needsTitlebarWidgets)
		ifTrue: [self addStayUpIcons]! !

!SystemWindowButton methodsFor: 'visual properties' stamp: 'bf 3/26/2010 10:23'!
restoreImage
	dimmed == true
		ifTrue: [self firstSubmorph form: self dimmedForm]
		ifFalse: [super restoreImage]
! !

!MenuMorph class methodsFor: 'images' stamp: 'tfel 3/25/2010 07:35'!
pushPinImage
	"Answer the push-pin image, creating and caching it at this time if it is absent"

	^ PushPinImage ifNil: [PushPinImage := ((ColorForm
	extent: 13@14
	depth: 8
	fromArray: #( 4294967295 4278387717 101187583 4278190080 4294967295 4278914061 235868177 4278190080 4294967295 303240213 370612249 4278190080 4294967295 454827294 522199330 587202560 4280624679 673786411 741158447 805306368 825373492 892745528 960117564 1023410176 1044332609 1111704645 1179076681 1241513984 1263291726 1330663762 1398035764 1442840576 1465407834 1532779870 1600151906 1660944384 1684366951 1751738987 1819148287 4278190080 4285559154 1937012086 2004418559 4278190080 2038070140 2101902975 2150891519 4278190080 2172814212 2240186248 327811071 4278190080 2324430732 2374930320 2449473535 4278190080)
	offset: 0@0)
	colorsFromArray: #(#(1.0 1.0 1.0) #(0.995 0.995 0.995) #(0.987 0.987 0.987) #(0.667 0.662 0.667) #(0.149 0.149 0.145) #(0.254 0.262 0.262) #(0.215 0.262 0.285) #(0.478 0.482 0.482) #(0.921 0.921 0.929) #(0.987 0.991 0.983) #(0.956 0.956 0.956) #(0.102 0.102 0.102) #(0.69 0.717 0.717) #(0.293 0.694 0.89) #(0.027 0.58 0.87) #(0.023 0.293 0.443) #(0.18 0.184 0.199) #(0.874 0.878 0.874) #(0.858 0.858 0.858) #(0.02 0.02 0.02) #(0.811 0.858 0.882) #(0.012 0.595 0.893) #(0.0 0.595 0.893) #(0.008 0.591 0.886) #(0.02 0.242 0.369) #(0.207 0.199 0.199) #(0.948 0.948 0.948) #(0.886 0.886 0.886) #(0.035 0.031 0.027) #(0.698 0.71 0.717) #(0.141 0.638 0.886) #(0.004 0.595 0.897) #(0.008 0.587 0.89) #(0.023 0.533 0.796) #(0.016 0.039 0.063) #(0.568 0.568 0.568) #(0.983 0.983 0.983) #(0.925 0.925 0.925) #(0.694 0.694 0.694) #(0.807 0.807 0.807) #(0.63 0.63 0.63) #(0.035 0.043 0.039) #(0.345 0.349 0.333) #(0.533 0.804 0.929) #(0.004 0.595 0.893) #(0.008 0.591 0.893) #(0.012 0.595 0.905) #(0.031 0.164 0.246) #(0.188 0.196 0.192) #(0.893 0.893 0.893) #(0.192 0.192 0.192) #(0.207 0.207 0.207) #(0.012 0.012 0.012) #(0.023 0.012 0.02) #(0.016 0.086 0.129) #(0.031 0.043 0.055) #(0.427 0.595 0.702) #(0.031 0.599 0.893) #(0.008 0.587 0.897) #(0.02 0.587 0.897) #(0.016 0.254 0.365) #(0.027 0.031 0.027) #(0.466 0.466 0.466) #(0.361 0.361 0.361) #(0.341 0.341 0.341) #(0.035 0.027 0.023) #(0.408 0.423 0.427) #(0.102 0.591 0.847) #(0.027 0.529 0.804) #(0.016 0.584 0.866) #(0.016 0.587 0.878) #(0.023 0.568 0.85) #(0.023 0.58 0.862) #(0.023 0.129 0.192) #(0.063 0.063 0.063) #(0.317 0.317 0.313) #(0.423 0.419 0.415) #(0.714 0.725 0.714) #(0.714 0.714 0.71) #(0.979 0.976 0.968) #(0.239 0.674 0.905) #(0.016 0.595 0.89) #(0.023 0.564 0.862) #(0.031 0.145 0.219) #(0.02 0.027 0.047) #(0.012 0.039 0.059) #(0.431 0.431 0.431) #(0.458 0.458 0.466) #(0.133 0.199 0.231) #(0.505 0.792 0.933) #(0.741 0.886 0.956) #(0.474 0.776 0.925) #(0.035 0.587 0.882) #(0.023 0.556 0.843) #(0.027 0.188 0.278) #(0.043 0.035 0.051) #(0.435 0.439 0.435) #(0.357 0.357 0.357) #(0.619 0.619 0.619) #(0.952 0.952 0.952) #(0.792 0.8 0.804) #(0.008 0.02 0.027) #(0.023 0.478 0.725) #(0.016 0.587 0.893) #(0.023 0.595 0.89) #(0.023 0.466 0.706) #(0.016 0.094 0.141) #(0.008 0.008 0.012) #(0.02 0.012 0.012) #(0.638 0.638 0.642) #(0.991 0.991 0.991) #(0.976 0.976 0.976) #(0.168 0.164 0.164) #(0.016 0.18 0.25) #(0.008 0.58 0.874) #(0.016 0.591 0.87) #(0.031 0.156 0.239) #(0.02 0.008 0.016) #(0.012 0.012 0.02) #(0.008 0.008 0.008) #(0.258 0.258 0.258) #(0.866 0.866 0.866) #(0.051 0.047 0.047) #(0.023 0.016 0.027) #(0.027 0.258 0.388) #(0.016 0.564 0.858) #(0.016 0.435 0.654) #(0.023 0.18 0.258) #(0.016 0.016 0.016) #(0.4 0.4 0.4) #(0.039 0.039 0.039) #(0.325 0.325 0.321) #(0.035 0.031 0.039) #(0.02 0.09 0.133) #(0.031 0.188 0.289) #(0.023 0.137 0.188) #(0.016 0.027 0.043) #(0.576 0.576 0.576) #(0.16 0.16 0.16) #(0.733 0.733 0.733) #(0.753 0.749 0.749) #(0.365 0.365 0.376) #(0.117 0.113 0.121) #(0.074 0.066 0.066) #(0.203 0.203 0.219) #(0.603 0.603 0.603) #(0.979 0.979 0.979) #(1.0 1.0 1.0) #(1.0 1.0 1.0) #(1.0 1.0 1.0) #(1.0 1.0 1.0) #(1.0 1.0 1.0) #(1.0 1.0 1.0) #(1.0 1.0 1.0) #(1.0 1.0 1.0) #(1.0 1.0 1.0) #(1.0 1.0 1.0) #(1.0 1.0 1.0) #(1.0 1.0 1.0) #(1.0 1.0 1.0) #(1.0 1.0 1.0) #(1.0 1.0 1.0) #(1.0 1.0 1.0) #(1.0 1.0 1.0) #(1.0 1.0 1.0) #(1.0 1.0 1.0) #(1.0 1.0 1.0) #(1.0 1.0 1.0) #(1.0 1.0 1.0) #(1.0 1.0 1.0) #(1.0 1.0 1.0) #(1.0 1.0 1.0) #(1.0 1.0 1.0) #(1.0 1.0 1.0) #(1.0 1.0 1.0) #(1.0 1.0 1.0) #(1.0 1.0 1.0) #(1.0 1.0 1.0) #(1.0 1.0 1.0) #(1.0 1.0 1.0) #(1.0 1.0 1.0) #(1.0 1.0 1.0) #(1.0 1.0 1.0) #(1.0 1.0 1.0) #(1.0 1.0 1.0) #(1.0 1.0 1.0) #(1.0 1.0 1.0) #(1.0 1.0 1.0) #(1.0 1.0 1.0) #(1.0 1.0 1.0) #(1.0 1.0 1.0) #(1.0 1.0 1.0) #(1.0 1.0 1.0) #(1.0 1.0 1.0) #(1.0 1.0 1.0) #(1.0 1.0 1.0) #(1.0 1.0 1.0) #(1.0 1.0 1.0) #(1.0 1.0 1.0) #(1.0 1.0 1.0) #(1.0 1.0 1.0) #(1.0 1.0 1.0) #(1.0 1.0 1.0) #(1.0 1.0 1.0) #(1.0 1.0 1.0) #(1.0 1.0 1.0) #(1.0 1.0 1.0) #(1.0 1.0 1.0) #(1.0 1.0 1.0) #(1.0 1.0 1.0) #(1.0 1.0 1.0) #(1.0 1.0 1.0) #(1.0 1.0 1.0) #(1.0 1.0 1.0) #(1.0 1.0 1.0) #(1.0 1.0 1.0) #(1.0 1.0 1.0) #(1.0 1.0 1.0) #(1.0 1.0 1.0) #(1.0 1.0 1.0) #(1.0 1.0 1.0) #(1.0 1.0 1.0) #(1.0 1.0 1.0) #(1.0 1.0 1.0) #(1.0 1.0 1.0) #(1.0 1.0 1.0) #(1.0 1.0 1.0) #(1.0 1.0 1.0) #(1.0 1.0 1.0) #(1.0 1.0 1.0) #(1.0 1.0 1.0) #(1.0 1.0 1.0) #(1.0 1.0 1.0) #(1.0 1.0 1.0) #(1.0 1.0 1.0) #(1.0 1.0 1.0) #(1.0 1.0 1.0) #(1.0 1.0 1.0) #(1.0 1.0 1.0) #(1.0 1.0 1.0) #(1.0 1.0 1.0) #(1.0 1.0 1.0) #(1.0 1.0 1.0) #(1.0 1.0 1.0) #(1.0 1.0 1.0) #(1.0 1.0 1.0) #(1.0 1.0 1.0) #(1.0 1.0 1.0) #(1.0 1.0 1.0) #(1.0 1.0 1.0) #(1.0 1.0 1.0) #(1.0 1.0 1.0) #(1.0 1.0 1.0) #(1.0 1.0 1.0) #(1.0 1.0 1.0) #( )  )) asFormOfDepth: 32]! !

!SystemWindowButton methodsFor: 'visual properties' stamp: 'mha 3/25/2010 23:35'!
highlight

	self firstSubmorph form: self highlightedForm
! !

!SystemWindow class methodsFor: 'preferences' stamp: 'tfel 3/25/2010 23:05'!
boxExtent
	"answer the extent to use in all the buttons"
	
	^ (Preferences alternativeWindowBoxesLook
		ifTrue: [18 @ 18]
		ifFalse: [16 @ 16])! !

!MenuMorph methodsFor: 'construction' stamp: 'tfel 3/25/2010 07:32'!
addStayUpIcons
	| title closeBox pinBox titleBarArea titleString |
	title := submorphs
				detect: [:ea | ea hasProperty: #titleString]
				ifNone: [self setProperty: #needsTitlebarWidgets toValue: true.
					^ self].
	closeBox := SystemWindowButton new target: self;
				 actionSelector: #delete;
				 labelGraphic: self class closeBoxImage;
				 color: Color transparent;
				 extent: 14 @ 16;
				 borderWidth: 0.
	pinBox := SystemWindowButton new target: self;
				 actionSelector: #stayUp:;
				 arguments: {true};
				 labelGraphic: self class pushPinImage;
				 color: Color transparent;
				 extent: 14 @ 15;
				 borderWidth: 0.
	Preferences noviceMode
		ifTrue: [closeBox setBalloonText: 'close this menu'.
			pinBox setBalloonText: 'keep this menu up'].
	titleBarArea :=  AlignmentMorph newRow vResizing: #shrinkWrap;
			 layoutInset: 3;
			 color: Preferences menuTitleColor;
			 addMorphBack: closeBox;
			 addMorphBack: title;
			 addMorphBack: pinBox.
	
	title color: Color transparent.

	titleString := title 
		findDeepSubmorphThat: [:each | each respondsTo: #font: ]
		ifAbsent: [StringMorph contents: String empty].
	titleString font: Preferences windowTitleFont.
	Preferences roundedMenuCorners
		ifTrue: [titleBarArea useRoundedCorners].
	
	self addMorphFront: titleBarArea.
	titleBarArea setProperty: #titleString toValue: (title valueOfProperty: #titleString).
	title removeProperty: #titleString.
	self setProperty: #hasTitlebarWidgets toValue: true.
	self removeProperty: #needsTitlebarWidgets.
	self removeStayUpItems! !

!SystemProgressBarMorph methodsFor: 'drawing' stamp: 'laza 3/26/2010 09:45'!
drawOn: aCanvas
	| area |
	super drawOn: aCanvas.
	
	barSize > 0 ifTrue: [
		area := self innerBounds.
		area := area origin extent: barSize-2@area extent y.
		aCanvas fillRectangle: area color: LazyListMorph listSelectionColor
	].
! !

!SystemWindowButton methodsFor: 'visual properties' stamp: 'bf 3/26/2010 09:01'!
highlightedForm
	^ highlightedForm ifNil: [ highlightedForm := self firstSubmorph baseGraphic lighter ]! !

!IconicButton methodsFor: 'as yet unclassified' stamp: 'mha 3/26/2010 00:00'!
darken

	self firstSubmorph form: self darkenedForm! !

PopUpMenu removeSelector: #morphicStartUpLeftFlush!
PopUpMenu removeSelector: #morphicStartUpWithCaption:icon:at:allowKeyboard:!
MenuMorph initialize!
SystemWindow initialize!
