"Change Set:		7424Graphics-ar.63

Graphics-ar.63:
UIManagerization. Replaces all the trivial references to PopUpMenu, SelectionMenu, CustomMenu, and FillInTheBlank.

Graphics-ar.48:
Addresses an interesting bug in [Multi]DisplayScanner. All stopConditions exept #endOfRun have lastIndex past the last character displayed. #endOfRun sets it *on* the character. If we display up until lastIndex then we will also display invisible characters like CR and tab. This problem should be fixed in the scanner (i.e., position lastIndex consistently) but I don't want to deal with the fallout right now so we keep the fix minimally invasive.

Graphics-ar.49:
Addresses an interesting bug in [Multi]DisplayScanner. All stopConditions exept #endOfRun have lastIndex past the last character displayed. #endOfRun sets it *on* the character. If we display up until lastIndex then we will also display invisible characters like CR and tab. This problem should be fixed in the scanner (i.e., position lastIndex consistently) but I don't want to deal with the fallout right now so we keep the fix minimally invasive.

Graphics-ar.50:
Allow non-portable fonts in Morphic font selection menu when TTFileDescription>>offerNonPortableFonts is enabled.

Graphics-ar.51:
Integrate a fix from Multilingual-Support-FromEToys.

Graphics-ar.52:
Add subfamily name 'Negrata' to the list of known styles of Truetype fonts.

Graphics-jmv.53:
Part of StrikeFont enhancements to support glyphs up to 32bpp, with anti aliasing.

Graphics-jmv.54:
Additional DejaVu StrikeFonts, sizes 7 and 12.

Graphics-jmv.55:
Fixes Display alpha channel for AA StrikeFonts.

Graphics-jmv.56:
Moves the double pass for AA StrikeFonts from GrafPort up to BitBlt.

Graphics-ar.57:
Removes the extra iVars from BitBlt again (pushed down into GrafPort) since they would cause WarpBlt primitives to fail. Sigh.

Graphics-ar.58:
Adds CompositionScanner>>computeDefaultLineHeight to compute the height of an empty string correctly from its attributes.

Graphics-jmv.59:
Moves dual pass for AA StrikeFonts back to BitBlt, without needing any new instvar (that would break WarpBlt). Enhanced a bit the spacing between glyphs.

Graphics-jmv.60:
Another round of small fixes for AA StrikeFonts.

Graphics-jmv.61:
When setting new fonts to use the underscore and caret glyphs, don't mess with older existing StrikeFonts.

Graphics-jmv.62:
And do run the install again!

"!
Object subclass: #BitBlt
	instanceVariableNames: 'destForm sourceForm halftoneForm combinationRule destX destY width height sourceX sourceY clipX clipY clipWidth clipHeight colorMap'
	classVariableNames: 'CachedFontColorMaps ColorConvertingMaps'
	poolDictionaries: ''
	category: 'Graphics-Primitives'!

!StrikeFont methodsFor: 'building' stamp: 'jmv 10/18/2008 23:50'!
setGlyphsDepthAtMost: aNumber
	glyphs depth > aNumber ifTrue: [
		glyphs _ glyphs asFormOfDepth: aNumber ]! !

!StrikeFont class methodsFor: 'character shapes' stamp: 'jmv 3/27/2009 09:28'!
makeControlCharsVisible
	"
	Make normally not visible characters, visible
	StrikeFont makeControlCharsVisible
	"
	self allInstances do: [ :font | font makeControlCharsVisible ]! !

!StrikeFont class methodsFor: 'character shapes' stamp: 'jmv 8/6/2009 14:31'!
useUnderscoreIfOver1bpp
	"Sets underscore and caret glyphs for chars 95 and 94. 
	Only for enhanced StrikeFonts, i.e. those with glyphs of more than 1bpp.
	ASCII standard glyphs"
	"
	StrikeFont useUnderscoreIfOver1bpp
	"
	self allInstances do: [ :font | font useUnderscoreIfOver1bpp ]! !

!StrikeFont class methodsFor: 'dejaVu font data' stamp: 'jmv 8/5/2009 22:33'!
dejaVuSansBoldOblique9Data
	"Created using:
	Clipboard default clipboardText:
		((FileStream oldFileNamed: 'AAFonts\DejaVu Sans Bold Oblique 9.txt') contentsOfEntireFile substrings 
			collect: [ :each | each asNumber]) asString
	"
	^#(9 11 3 0 3 8 14 24 33 45 56 59 65 71 78 87 91 97 100 107 117 127 137 147 157 167 177 187 197 207 211 216 226 236 245 252 264 275 285 295 306 315 324 335 346 352 360 371 379 392 403 414 424 435 445 454 463 473 483 497 508 518 528 535 539 546 552 562 566 575 585 593 603 612 619 629 638 644 651 661 667 680 689 698 708 718 726 734 741 750 758 769 778 788 796 804 807 815 824 831 839 847 853 863 870 877 884 891 898 905 912 919 926 933 940 947 954 961 968 975 982 989 996 1003 1010 1017 1024 1031 1038 1045 1052 1059 1062 1067 1075 1085 1095 1105 1114 1122 1130 1140 1147 1154 1164 1170 1180 1185 1191 1201 1207 1213 1223 1233 1241 1245 1253 1258 1265 1272 1286 1300 1310 1316 1327 1338 1349 1360 1371 1382 1397 1407 1416 1425 1434 1443 1449 1455 1462 1469 1480 1491 1502 1513 1524 1535 1546 1554 1566 1576 1586 1596 1606 1616 1626 1636 1645 1654 1663 1672 1681 1690 1704 1712 1721 1730 1739 1748 1753 1760 1766 1772 1782 1791 1800 1809 1818 1827 1836 1845 1855 1864 1873 1882 1891 1901 1911 1921)! !

!StrikeFont methodsFor: 'character shapes' stamp: 'jmv 3/26/2009 14:40'!
makeTabInvisible
	self characterToGlyphMap.
	characterToGlyphMap at: 10 put: (10 < minAscii ifFalse: [10] ifTrue:[maxAscii+1])! !

!StrikeFont methodsFor: 'character shapes' stamp: 'jmv 3/26/2009 15:17'!
useLeftArrow
	self characterToGlyphMap.
	characterToGlyphMap at: 96 put: 95.
	characterToGlyphMap at: 95 put: 94! !

!StrikeFont methodsFor: 'emphasis' stamp: 'jmv 8/3/2009 09:22'!
reset
	"Reset the cache of derivative emphasized fonts"

	fallbackFont class = FixedFaceFont
		ifTrue: [fallbackFont _ nil].
		
	derivativeFonts notNil ifTrue: [
		derivativeFonts withIndexDo: [ :f :i |
			(f notNil and: [f isSynthetic]) ifTrue: [derivativeFonts at: i put: nil]]].
	"
	derivativeFonts _ Array new: 32.
	#('B' 'I' 'BI') doWithIndex:
		[:tag :index | 
		(style _ TextStyle named: self familyName) ifNotNil:
			[(font _ style fontArray
				detect: [:each | each name = (self name , tag)]
				ifNone: [nil]) ifNotNil: [derivativeFonts at: index put: font]]]
	"! !

!StrikeFont methodsFor: 'accessing' stamp: 'jmv 3/19/2009 15:50'!
descent
	"Answer the receiver's maximum extent of characters below the baseline."

	^pointSize < 9
		ifTrue: [descent-1]
		ifFalse: [descent]! !

!StrikeFont methodsFor: 'character shapes' stamp: 'jmv 3/26/2009 14:49'!
useUnderscore
	self characterToGlyphMap.
	characterToGlyphMap at: 96 put: 129.
	characterToGlyphMap at: 95 put: 128! !

!StrikeFont class methodsFor: 'dejaVu font data' stamp: 'jmv 8/5/2009 22:34'!
dejaVuSansBook12Data
	"Created using:
	Clipboard default clipboardText:
		((FileStream oldFileNamed: 'AAFonts\DejaVu Sans Book 12.txt') contentsOfEntireFile substrings 
			collect: [ :each | each asNumber]) asString
	"
	^#(12 15 4 0 4 7 13 25 34 49 61 64 69 74 82 93 97 102 105 112 122 132 142 152 162 172 182 192 202 212 215 219 230 241 252 260 275 287 296 306 317 326 334 346 357 360 365 375 384 396 407 419 428 440 450 459 470 481 493 509 520 531 541 546 553 558 566 579 583 592 602 610 620 630 637 647 656 659 664 673 676 690 699 709 719 729 736 744 750 759 768 781 790 800 808 815 818 825 836 846 857 866 874 887 897 907 917 927 937 947 957 967 977 987 997 1007 1017 1027 1037 1047 1057 1067 1077 1087 1097 1107 1117 1127 1137 1147 1157 1167 1171 1174 1183 1192 1203 1213 1222 1230 1238 1251 1258 1266 1278 1283 1296 1302 1308 1319 1325 1332 1343 1353 1363 1366 1374 1379 1386 1394 1411 1427 1438 1446 1458 1470 1482 1495 1507 1519 1535 1545 1554 1563 1572 1581 1585 1589 1594 1600 1613 1624 1636 1648 1660 1672 1684 1695 1707 1718 1729 1740 1751 1762 1771 1780 1789 1798 1807 1816 1825 1834 1849 1857 1867 1877 1887 1897 1902 1907 1914 1920 1929 1938 1948 1958 1968 1978 1987 1998 2008 2017 2026 2035 2044 2054 2064 2074)! !

!StrikeFont class methodsFor: 'dejaVu font data' stamp: 'jmv 8/5/2009 22:34'!
dejaVuSansBook7Form
	"Created using:
	Clipboard default clipboardText:
	 	((ByteArray streamContents:[:s|
			PNGReadWriter
				putForm: (Form fromFileNamed: 'AAFonts\DejaVu Sans Book 7.bmp')
				onStream: s]) asString base64Encoded)
	"
	^Form fromBinaryStream: (
'iVBORw0KGgoAAAANSUhEUgAABaIAAAALCAYAAACNtvp/AAAy3klEQVR4XuV9B1BUWd7vVL36
Xn316r16r77vq93a/WpD7c7U7M7Uzu7UzDozNWaL1NBNp+pucs5IFrFBQMFEMmFCxYRZzGLE
BEZURAVMIEEUSZJpOv3eufd2pAMNMmn7VHWh99x7z7kn/n+/fzgfAfaf7D/Zf7L/ZP/J/tPU
JFVPJZaH5aOqT2X/jWH/yf6T/Sf7T/af7CKp1Ur0VBUjK3MNzrfKbNsvh7rQNaSCaqQHnQMK
+2/EcZKs5RKKCvfhQY9ySt+r6G1G83s5FH2taOoZ/fmOsaFHyA9IQUVzBVIC8vFoSG3DuFTg
bVk6Uk+1QaFWW8hfjMWn35jNV7w+jazcEziVn4nSZuO2UcsacHhpBtatXY7MbffwXqV/Xj1c
j13ZxajrJn+X70L9sGHeExSIwnG85hTme65B7bB6iueiCj0VK7BgbwNkBt9EXe+6moWFB5sw
anBd2VGOlctKcWFjGnY/G9Fff1eO3NwLeHIpD3mXO6Akz6iHa1GUtB41g5p/J2/GY9IPavUg
ajanYdu5nUgvvI9+lZpug+3JS1FWU4acvCvoVNr2nWpZI45kZ9LtumT7faN2Zb5DjraTqZCe
tNKnZ9IgPdYKuZl8+etTyMo5imN5GWb69BWOLsvG9n1FWJW1FKsO1mFgbPlU36YmIznVuF8n
00/KUSVUBnVU9dxAfnKx2feqR55h18I8VHYrx7xnCPW7M5C/swBp2x4Z1ZeuKzX+zIxDOl/e
hnOrsnHkxbBRPSaT5AOd6OgbndB7VCPv8X7kw/CSWjWI+pJ48Fk8xJXUY1A1dfNJrZJjaHCE
HvuW7xlFf2cPhseOE3K9j1wfmcr6KPvQWNeIXoV66tfX0W68qG1En8L6t/Z2dGFQMfZbZejp
6IFMpf5pMbisB10DcrNjkJJR+pqe4/Wg8XhTDfd88BicbPrIqIIDd5EhTsXtfrX+32/uItMj
E3cHDCa1ogX7AgKwr2UYzSUBCDny2mghpJ41fIZaIOq2BcNxjiOCt9ZhkNyraDuGaPEKE7JC
rR5F68lF4Dqx4OLij421Q2brRzdc7y3kxG/H0xFSX9lz7ExYhZvvmfeNDvRipFdzf+8Iegem
XrBQ993E0ogiPJMx9VG8u448Xxe4uLHg6p+Pig6FQd0fYBX3c/z+m1SjtqTzBh9jQ6ALnFhu
YLF8kXP1na49Fe3nkcJ1giuHA1dXbyy/+MZo86Taq6lEjD9/uVDXLtq2Sp3+OWa6ucPdXYT4
fS91m7Fq8CkOLhTAxZUHSVgOrnUoDZ67h1w/6hnyc56GP3yZhJv92n6Uoak0Ge6OLLAc3bHw
aBP9TmojGXp+EMk8R7A4XAjDC3GrS/mTTsTOijyEiXlgzZ6HkO21JpuobYtvFy5FfoZPA06h
XWmubTlgObgidn8DRgz7RNaKC6sCwCb9yeGwIYzdhhoyzvXPccHlcuDG8UTytlt4J1eb6TPy
85TizGu5yXXvjHK809RHNfwKp5d6YN4cZ7hL/BGxeA8eaebU2PliOC/N5ZnMferfRCApjXdD
0LYndBuOfc6wTaRf/QrfL6/BED0mhvAoZwZ+/ZVUV570q99i3to6DKvVpmsE1WYr/eHGYoPt
yob/qgtolalN2tvFyQs51zt082PscwE5l/BaZtqeLEc2Eg836uYAJcS1l6+E17w5cOGK4BGQ
itImmfEccJuFv/z3XzCLane/XNyz0G66Nh19hd1efKyr1wuxow3F8PIsRsMo1Sb9uC11R9L1
XjpvoCoV0/4Rg2vvqbwBVKVzEH2pG8P1m+HtU8Ssa8pOlC/iIaGsnf5mVf995IqCsbeJWc/k
rUcQIVxG1jiV8dwlP7bD3/Gbz6JwvVeta4vZgYV4RAvPT7A+fCWqDNf1wSfYFDwXn3+bol9j
hxtQtmUnbrxTTEiw7K1ah4Vbn9BjweJ9FsbShObogOn+ZHk+d6NiKRdzPVbRfTnee82Ocy2w
0oA/w/9bmxsf+p0/CwBMhL9Xda/Qp/xlfYda1YMbywWYw0vDhXaF8fpG+m9biCM4GVdtBojj
lzeMxuNpkJA5KEjaj/oB24S7ycw1+0/2n+w/WZiHY9Zqy/uVDA0H48BxYcFZlI0qg3VaNdyE
i+sT4SuSICzrEB69J4RJxwXE81JR2UP2XPUwnhRl4EiznCGhq/ciI0QIjrsYQSlFurlMrUG3
ckSYOY/Ib8kleD5iQIB1V2J12jpsXroMZUTe068jI2i9VIAwrivYRI5044Uh/0KzDtDTslma
HwTuXARtqKZJr6ldN8cp30DeECcdQiORu+jvXMnHLFYQIe3azRJgJuUQ/LM5xpNgvtlwJ7Jt
OwH36qFabAl1h5uzAwRZV9FB1mbZq4OY7zYXc+fqf/OEWbjbrx6XhO2sWAXeX/8D//Pf/x9+
802aWXlB1VuFwpSlWLYoD9c6lZox9BLH8mPh4riYkfEofErIPYETwXmOfEhPtxrhMUvj6+3t
vVge6wMeyxHz5hl8g5M/Njwesp0s736MyqpWHdlD7TWtdytR26MwJd0MSV8LWGaq8lXvyhA+
KxAn3ipNZMGOc6H45H9/jKCyd0bECEMUp+Dr33yJBdd6zJImfTdTMesfX+Lj335qgosMsZab
ixszDuO2j8Fa1rHUh1w3h5csyXvm5FTqWtr0vxF8wQXHjQ3vxUfwdECP3aRf/hemZdxlyOwJ
4KWfQ751gv01LuYEkm8mGNjFBV5JS7BoySm0ytUTxqwfmmcdT1mQ58l8bj62CHxnV1J/LpKO
vDJSdCh7H+HAyjycbDAltWWvK7CvpByvhlQG6/8dbMteiZz8Q6gzkBUp8rf3JVFehHshLPcy
2jU8Aa0YyVyHnKVj5vhgNVYI43Dx+QXECFfg4eBUEtEDeFG2Dss3XUKzGbJSLe/AreIVWHu2
EUOGCgBVHx7tW4kV6/KxfEuF7husKQeosl6WbURBSRU6qTEh70RVSQE2lr1kOAiSX79/JfI3
52PFXg0vYUHZo1Z04MoSNlzj16Boyw6ceT6g6xO1/A0ubS7C0W0piMg6hza5nudqu1KItPyz
5FvVZsfvlU1ZWH3mhbGyg5R1sygbOYV5WFZUqeN1tGWVF23FsTFl6RVdhNMZaMbduh6rZL/N
RPRQA86sW4+yphGT9XjgyV7kbL2FLgMSXdVbg5K8POTmH0G9AUGtHWvLwv2xRKOEM+y/reEL
cbJNbhPOtaaUnBQRreq6gFhKgznYgbL53tj4VKbrwNZzy+HP+h6f/PZjzI4qwUuKTBmqwUpR
HMobLiNRsgo1hCS+le2D9KvdJhNVPfwYq70SUd5NFoLRAfQMKc3XjwgXrUfmI/b4G0ZDSYTA
9lMJiDnSShM2vbUnsSV3AVz/yUJSzhYcf/x+UuSFtdR/Jxvhm+tpEpIime5kChBHE0akLueS
IFpKNhHtoFcOoaetEulmylXLe9D8lpkgCrIQhojXonZErdO8jCqZgaF8exLhghzUDBlqDiuQ
7RcAHtt04zO/iA6jtjAQicdbjRZPc2TS+8oUcJOv6zSxVD/mCCJwul1FhPEyRIty6bqo5a04
ECBEwUPqG8hAr9mI6NwqDExiQilHBmzSJlGap4ERy2S3bGAAo+Q9qq6LiBEsR7XBoqzoeUy0
wLHwFvAIIcyHT+I6nHs5YDIWVR3nkOArxWLfaBx7Y34c0nNBtErXJ9QceFbkBcnqe+hVMeOy
r+EhXvYqTRUp1GZOyEevbS8YQn+CRJZaPYL6QiF4OTfRrdC+sxd9sqkhom91tuDEAjb8ttTo
QI7VOrrMhotkDW2hQc3jdRJnzGFl6MpLd/wecxyTcLFTZVwX0mbPt3qBn3MbPUpqo+lFVYEY
3ltN20XeVAI/r214KbP0nAS+202fo/pyvjhPZz1CEbGrhcE43KpZRFVK3TwbT3i02KaE3G7Z
5wv+mlrNmiDDiyIPeO96RYMVak61nwqFIO8xIeNJ3YuDIfb0x7pHQ2Rze4EiiTdKKEBLNtrq
fAJkSxrQcTsbgogjtJCmE94rMyGIOYk3snacTRIgzdw6SgBh5RIuAnc3mB1btKJgTThyHwxa
HGsqAsIOzp+Oj3/1W3zBycblKSbIfnQimgDnLI80m8qbTN1+6UQ0NQdU4ygOpmLf/NG/a/A+
skQLUNFrfg1T991AijDTSClj/X01yBfOhhNHA045ZJ0T5jPWUYpu3C1KxsKi2+iQK9DzYBek
ietR0S4fh4Se3FyzWhf7z7P/PDvLm8x+QcsCXvEop4hlgzWQ3kOJfOa3pQrvhkfQWXcdlS0j
DPm8Rgi/ErKvy+pRnLoHLyh5ZOAOUh1FKLzTjmG5DO9bn6OpT6HDNQUesbjQpTJrodTzsBQH
K/XELXWt61o6uIFFePiekT2VfY+xI4yH1MudDOZRDeH5ISm82LPwxeyleDCVxIMN5Ztfjx5g
GT8Glyis55FnhFXG2z9kjfsRHXMATaOGIL0MMRJTq1+K4LhXIAR3xS30jIMX1KON2OH2K3z0
0Uf4999Pw0wX83WgQfrzKyh/YkwGGMl4pB/zReE42U7GybsziCZ1ezystkqCvy2LhwMvG2fq
OjBEyO4M11Bc6lFPUrnyFFt9Rci/309jrb6qXEhCStAwDgloCctMRT71jW0nkhEtjURCaaux
UZrqHcoiWIjMi4Fb2Gljgx4ig9asDkdGUTpC86tpA7WxhgPliSJkXS5HugVC8NkWTyJP32Hk
f6r/XtWgoU85cSz1Adc/hIjWjSsi89cW+YCfV0O3A4OXvsPMGSE42qaYGF76yfNVGOnpxKBS
j1mGurpoglL7rED77MBD5M75GI7rNTzKj0xEW8NTFvue8CC5ovk4R3CsvPUwggTW14AfT35n
LKJ5P4BF9C9SEU36tr/+FHbuPogdUj4Ey6+hU6H+l/1WWd/7KbU6t17eKJoOS5F9sV1vFPgB
ONcyEU204V1vuzCsYP5SH0hprosWhCOI9zU+/icfQYHu+OrjaRDEF+HxIEM4r+KFoLT+BjI8
Ugnx3E4vRuqROqzziMKZ+rOI9VqH6ppiREnLaM236Ub7CLlO87DkRo8ZckVTJ6ouyjc4Gh6E
vc16gKdoPYiQsFK0KRkiuig3Ca5fuyCRENEnppiIpi0YV4SjsHaY+T/5xrUe0TivETTVPeWI
I99aN6KeULmq9tOI8tqAejOaGFlDCYL9i2kSTktEPt0WjSWnzyLNzMaXNvNLOLCJpjhwFc5p
3ATVsqfYJHJDeKQ3eESIF0auxdW3o2YWtfeoWMhDSuV7vWA+2oS94ZE41CKnNYfREXtpoVE9
QAH9hajs09zXfxPpwcw3GFkMWrBQUQ2+xoMzRcgME8DNfw1RVNgCKGqwxt8NgrBMFJ15YOJm
QI+HzjvYEjIHbstu68h0RfslZPrGo/jWa2ZjJER/V81BpPB8UFhjoC2jlAmn4xFe8hKNhyMR
Vfra7IRTvjmOgHlJuKH9dtkzbPIMxYl2lU1Elar9BMK8NtNW9RMWhkhfbvQIwbG3SpuIsYkQ
0enu3pBGEi194X2aULdJMBPFYK00HOufDGO4thBhC9chwai8ZOzbEADvomdEUWBQF9lzbPYI
RqmBgMu0yxY8H9Mu6v7bSPPMYqyTLT3nXWTyHCUwhHgU6uYV9WyRkAVpaTVaes27UU2UiGbW
oMMI4DOCCT0WJL40uaybwy+KIPHdj1Yi9JxJXIADpVLEHGiBjICaML5eyaR6fxNL2U5gO/pj
V4Oxi69a2YGLC/kIy4iCIOmsyTpKjd2OS4vAiTiMllHLm8TQw3yEF9QYWS0btdnbChw5cwFr
vCJw5OoJnKjp1d0n76jGtce2aW/VI8+xM9wFDpTHh4snlpczgJseZ2wxFsQHQOjugnmcJBx6
McQIgWRjHW44hsUSF7DY7uB6L0H5OyUj1L48jAXu8+DiLoBfTCIk7hm69h9pOo0l3hyw3Tlw
5SegpH5AI1TeQ643Y+HuGLOfBm7Uuwaf7kM8ex6c3cUITEiGp7uB4sRNgPj4IHDnzkHwrmc6
S/7xPQlG8ebiMgTE7sTjfpXp3HLjIzY2ANx5DojYWoZdaYHgzaPKeK4TxtNduYiO9AVnjkHZ
tOfJISzkO8OV7Qpn/kJ9e9HvFSIuyht8QsyMbUvKYyWJQ7WZEP5xC+Bh+J2krKhIP4gD8/Fg
gAEW98k8dXJ0BZfvgYSSF0y93l9B+BeWPQSMBfwB3FsmQYrG0omaF2EBuzSeASOoXecP6XWy
t3RfQvjfp2PZw0EoWvYjOLwUb8j+3XMjG+LoI2iRDaG+yB8+hYyrZf/tTHgsvsEo+QjBsCsg
FIdaFcbeAC7f4HefBhFiSW1xzhr/v2pCAtR4a8Bk0mTn2o8O3Ow/z/7zfsZ51oDa4NP9SOJO
xydkD5jtmUF7R2jnf6bnmH2ekGA3c73w5e8+gYOHP/wDolFwU6/wVRC5L4K7BBUP9kC65Qmz
PvdeR/w8X+wiWEOuNkOcrvUBL3gJdlc266zGqLWwYX8c3OY5kTWdyFurqmjjFbW8GXv9hUjP
TwTXgQVBSC6udyqJIn4PqUsJmilLMUL6ZvNjcfFpGSLc0gw8UJV4/6IGbSPav5PwBqTL90Zx
TSVjtclyBiv6EF4815dviQyp2xVD1mAu5u94YmwxZqGfKAV+Z9UerFx1ADXvlUYWVEUBTvDb
Wm8so5D735xJgLPfDjwbNr8PG1mPyl9ht/uvrRLRtHX5QkKQCQQQcGbh0y/CceW9mbE3Uo9C
kR9KXskw2rwfgRINzhlpQ82L91Bq/+o89l5iq8AN+Y+HdcpwS0S0rOkk0gRzMMdhHpy8snC0
fDeSRSw4zGFj4YkWneHQyIsd8OMtQ2VjJZZJYlDaOiasAlGIpHss0SlWrWGZKcknY2X//BRc
eHYRi6JK0GioSGg/hQghUUh0EWWPOIIm8HXP9d3C8phiPO97ju3zs3Gz1xgzUYZX0b6b8bTL
Ev6hsJZ5/PNLI6Jpmb/zLKI81zPjiX7HApSs9gCv4DGGJoKXfup8sgY82RwIvwKKbCbKkoeb
EeyTjyrKytjgWbWyBzdXJ6Lg+E6EeJtivR9rv7CEpww9cdncIOSWv9XhFvp93a+wNyoaBxpG
9LyBJaxDXQ9zwlxnV7iMvW7p/lAHzCIyOO0Jb3TdmdxP5H/XCBQ/0eCbkRfYHelC1g4WOBw3
uHll4pTWw9ewDFdfZJfswGIvV7Dc3OAqTMbBZ4MGmOs40r0pOdoVTnwpLmrmK4Or2HDjsMHi
xmL3Ez1XYglzjZvXeByLPdlgk/q6ei3Dpbdym+bXRObYSOMxSHlz4ejmillffI3wk0zoIYbj
CMK6bTkId5oG3poaxrLaAGOx3Fhw4iWPwVEW8Nc4eQP1JYhznUX6gEU4rjxc03pKUd7D9zch
hOyvLo4uCNn8wJhvGbYQSoYu7zBSCIfhymbBmeOF4OQDjIGeJUz2IdfV/bglFSOzasAKBrOM
52Uvt4I7IwGXu1UazwPC1frv0ClQP5qo5RYFMO8u8cDim73ou50Oj4w7eqtfxRucimHBN1UK
gcMCXNeEyaDd4K+tQ2JkEtaXP8TJxcnYcW4/8tIzkL44B4dr+3WDUzXwCBtYv8b/+ksg9jfI
rFgCVWOFRE9+aglQqYQhqUYH3mPYMDRHv2xqiWhCvuaEr8WjYT2YXSqW6sNYUMKAhjCztVy1
sgvXl0oQOyamE+12QBaZrz9zxoo7emJY2V6GRTFEG95tZlIS0v49+WYVafuOK+nghB7DG8rl
jdRz8YwZkJa/I2VQeRngRpzE2zHuVqqea0jmSXGj19iVqv9BPty//gbffMVG3r0+ZqIp2nA0
lI20y1TIBAU6rqZh5sx0qxZmasV71F0oRnaUB/iEwM8uPouHb4b0C/qYMAO6n4YA0U3Gtoc4
W5yNaA8eJFHZKL5Qh/fUd8pbcCCIjeSjz3XCMDWZ7mZ5Ie16B9orViOE6w7v+ckIDV6Nu9VF
8CFKjNfaTYgoOo7HRuMwmWDKtycQR4TwVpMNig2n6V/hO48C3NLEq6Lad4loEW70q20Sjphx
spRuK9vcwzwgPcm4AzJlpejKGrifB39Dy6Gx73Obhb9NT7OJiE777vf4/ZcROP5aPiHB7GL5
coRvvI8HG8OQdamcKKSMF7WbLRVIJe1ztfm2wYJn/B3MXCaEs4e+XZgySX/XboDIpwRNctue
o7+f5Yiv/zwNiZf0riX02Gm8gMIF3nCa9lf89Xsv5IxxJZ0MEU2Nm2MhfOTWDGGkvhAi/wO6
caMjvbhxuNx8C9nzd+NZYyliUsrRfDsV3MRreK+zxurG5fgv8GfJYaPn9Uq3I/D9xgsHWkwt
LeVvTiOOHYdTb+TjjD3jNczs91GW2t7RRsBJ3l6OLEkQNlf32RQHjfJe6B9gyH7lm2OI8NqI
p5oNUzrDEbkPtJ4UqyEKYuaZWtGKQwE8rLzby6wxKhVUKub64SAB8nTPFMB5pib8i+I1SsO9
sE6jUJI1EsVdyH60yC30FXnXwQAh8h/qy3eZpQ8lkzpPjD2vSL07ziJanE+307hEtDAOu7cn
w2fRUTQMq8zekzpXiJ1kb1N1nkPotxLsI4oK6t/zDcowW7acqq8A+dpvr86HMOCgzqXRalsG
Wmgz6rnZHGx5OmJg8fEQK7ghON6mdStX2zQfxuYP1eTBM/ESulRyNO8NRvC+Ft386r+dAd9V
1WivWgH/EF+E7XyOtvNx8C/SWNWo+nG/wBNeC2IhDCKEg1aBRMXH9F5Ae0zJ6jfCZ/4YKytF
Oy5liBCx55mO7KHI7jhDr5WxfUiU33miSJS9U+nGa9utfchfLEXmmgOobCKCOuUueO0SXg6p
fxAierJzzf4JSfvPs/88CwSn4dpErfXBvtj2oEInk4xVUM7yzjWW13vKEe6WYRLGiQrXULom
E3GCeXDku0AkPYiXw0zYhrcVm5EgnIUv//4NXAKyUFrXrymHMdaoeNuE8oIA8KXnmRAU8ibs
8fFC8QsGn6hUKp38u9R1HliOUTjzTjVGvtEo4gleqFguITJxJPwDVzMyH4W1ruYhYtEB3Dmf
j+i0Y2jWhMy4sdzXWJYmsuJs3ipUm7MOpsqn5Ng2KnzAX/H1tw6ILK5Bb6++fNuxkplQZway
PBXiUOo8g4Bpdwijt9OgW+uhpqIMevhZuG8g8w/WboGnUxLOvlXYtA/R3p0PixHn9hX++LGe
iDZnGENjsOUeCNvBWBSqR5pwdusKJM7PwRVCHtBhPm4WIoJHyB5eONbd6GSIDVkzjqXNR/6F
OziwKBJ5V7XK9ttIcQjE2S49rsn47k/4cpYmNAc7Acda5YzlcCQb0itdREZVouvKQnz9iRgH
SJ6quxwLJMt1Fu90KJk9fvj6H7OQVPbWmBRWdONBcQRYkcfRZgOWmYp82YttCIw7iw5FJ84n
BqLouUxHYL89HoXAYiosJKnzjiBEn3ir8WBWoas8AynHX9OY8fWxFGSUdxkYAsnRciACUZSH
s0VcZB1r/ZxDc5hbd6ixkqZRIGjfcaPxEhJc43ChcSJ46afNZ8ZMN27l+8IzYQF8yHqh9fBi
eJJFuNknw6vSNEgPNWCEPLtYu6b9RPuFOTw11pApWLQaTwwxQOcLbPMSoqCq18CLxgLWUTEc
FG2U0VaKUE/tdUv3y3T3U3Mu0tv0/oEHKyCKK0ePWnN/n0xHfPZULIZgAYMnDZ9RvC6F1xcu
KHzMkM+UcWNI2EEaIzE4QevZTj2ngEKlwVVhEhRUa3BVw04EBGowuBXMNX6eDzbVDdGYhKqv
Z+YdnRf9VBDRVBlHgnhYocGQo4074eO9i1aUmWAsYY7eu9+fh5x7jMdJ//1c8LUYyxr+sprX
gv0e0xF+pp2sfQq8PRUN3hImYgCz/3ug6JmMVnJuFDOGa+PxX/Q7/XjIvd+P0Y7rKAhiYbrf
QQbv/cBEtCUMZhWDKinPmBnw3NdM9kUZnm32RNBBvffMRxMjX6nFcw4++90nmE60K7M/+x0+
neFqTA7Ke/DiygZ4/u0TzFpUTsf2MiIy761HWnEZ1vlG0fGk6Enmq7FgVLbjfJIrQkvu4UZR
EKY7Z+H683NICtlh4no0HhE9GYHI7L2kjKPNphbDY60JGYvo+bjQPTmLaNo1Z1swJCsq0W0h
ViW1aAQSrSNtPUsUAtUFoVhxm0yy8WKzUO3ikU0Lc1Q9CwOkRtbLUo9luD84JnbX1STwUm+i
zyj28Qts9QnCvqZRjLYcRKjvNtolka7b64vIC+ESzZeIaGaSIPbZqsszr0h4go3+M/GtexI2
HL+Dpv7Ju/0r+ptw5/gGJLl/i5n+G/GEdt98iPzwlcbAghAO+ZJ4XHlbi7WiQLLpjNJWDT5O
hJx9w7SDVtijNia/aTPAEUsgEXMxi2xS+5pNY+HQbkgv9iAscj+aR9U6i+jjE7GI9pysRfRz
bPE01kx/yOZsvPAvxLFSKVi8HNzqUdpMRN9qu4NlAfMR7bsEN9vMlSfDi20+8Fu/n7S3VsNP
2oxoyY8aadhPItxrs05LTguDrhy48WOwrVpDTlp5zrg9KRfGHHgllJmPf0eFT3lICG7eaqMD
U8wTbxRAM7T+v4VUA2DGhAiKAH/lLVStESJobPx8VSfORfKweP9qRK+6h4HhJyiMzMb+XAkC
j7TphHRKqSAOyENBMA8ZlWa8Qyz1w2gLDkdwsOjSOxP3UpONe4xXhy1ENB3aZ/Vc/PrXfyfa
eic4ORn8JMuM4mvqyxlB06ks+HPZ4BCt8N9mpOmE7XT+2LbUrFN0O6cYre9a8jxLnGL0jFSk
te69h8yZBqCBUsoQ4fHRkAUiWvOuG2bfRVn4k/Gs3Zw9M8coRczPm8WzPsPn00Jx9LUV7b7h
ez305RmVYbZs02/Xt5e1trTWZuQ5kZQuy9Dt6u31LUgJ8oLEJxr551t04V1M50OV8bcZti/l
CeUdi7OvX2BHQDhK2/RrPEW8x/qvw8l1sSgoP4FFiSUEyPtgZbU+VAylNRf/6e9IrDDwyqFc
O4sCEHu6EQ/yvLCgvNsABPSiaq0vfNdU6cNJEbJhk/hrcNbp45WbhqkZRv1GLj6fmYRzVAzp
viqsz9uPW/VPUXVmExZSFh18PyzadR89ih+PiLZlrtk/IWn/efafZwMRTYVlovbttvEtE3UW
0TkS/O13n8HFKwDR+ZXoUqrN4whvM/hB0Y+XJxdgNmsNjQEoq7tLKRyE7K5F24NtiEo6wsiL
BJh2V+1CWognxJ7hWEnWNdrjk7LiFXyKP3zujYNETqUUsUpyffTVbvj67sarUU1czGghvdfp
CFwqNAYvBIfq7xB8RCmjFTZ5dozFO3T5FEFeU0naJh3nz2Yhaksd+gzKn7jxzgTCaI08R0mi
B7hsPmJ3PNYZkyg7r2CxszvyDMif8Yhoo3ucp1sOzUEw2OOiYHjn3aLDBpgPjaFv87G4UfHm
FGIlK3Cn7iCCeQxxrB6pxWqOENsbRq1aRFMkxFpRGCGsGdyg6joL379+hnlcAfg8d7C9VhjJ
VuqeiwhlpRvjG7L/3c5mYU7kLt05MeNhmQ/Np2S7urVu+OccLsQSMXhzvwF7rSY0naINpf7T
8D1bDIlEAjH7e3wTcIz2eKLI7RNhszCHq8njzsXs8FM6gygaa/K/xHcuHHqeGZ5bYmwRbbv3
6S/PIpp6xzCerCZtW1CCRbbipZ84X8f1VBeC/8XnYK26qZtPDGYNws6Ta5CoWVONsZ6x3K+V
Y+8NfGieZcxmrc/GEtG1Y4xRRt9eRX6oN6SlDcy6rcE6fu5uYBtiHSrucPl6JEfPR2yUB6bP
Way5bgEbkbWobnc8+C4sk/c0nclGALmf7fgVPpccxmslowRtr9iEBE93uLE54BjlGZfxl//+
VM99GWAkbRve6DPlwpbM/Q7iqDjExZFfTAg8Qjejdsg65rKedx9LZhnkuc6BQ8xZHT6fEiKa
xj1j+32pXuExYYw12Tyy5jvwsUOzB1DnRvkEH8VblUYuETPKNLW6D5ULxci+P2gTF0uVd+3l
daxJWYNrDRUG473KArFsHqvZdD8hom9KRQwRbQGDWcOgtKHkg2VwcMpFTcd9LOdH4rSBd8xH
ExUmKBNr30jCgA+Txcg7SmdFxGyEcsjkmvivrFmYxV5hFLeMOl330PJdqO2qQa4wHKdIRZTU
IiTI1cWVzXOchVSaeCET68pK8GeykH6ty5SI0YTm2NdiuGEeQkjoETo0x2QEIvrEy3fjn+5p
Lr4qfRBZhhCJ59/RGu2OSwshztRbi1t3TZOh9Xgi+PGltPWCkWWyQkZrpRhgfgTBmnhEVJiM
gxFu4IiIcCB0xOe//wzslBN6V3yNRQFNatWsgcB7DyO8UuTTqkis11kBroXIf5+Rqx1lPXE5
kZBlt/uN60k0IblCgxjRBjF3Db+l5YQU8SUNJjGox7YvHdemsx7lJTmIIwsoP0iKwuPV6JKr
bdAIdaH6eCGkQXy4e8Uhp6Qc9Z0y6zFOqdhO4jhcflOLNaIgHGqV04S6r7MUFy6ugCSOISqZ
WL8hCD3EaGzo2L6nYxCyRxPrd8wiSClTwkWaftHGiF6jjRFNNuRG83HLVLI2lC9xh2fR80nG
iJahYacfBMuu6Q88JJM/TZIxBUQ0Qxo3Ho6Co08RngyobBTMiOZs0TT8c0Elei2Up+oqR7LT
HMxwStfFPHu2xQOCvLs0gUS5sd5fI4EXFcLDWruYfU4EyUbTeGO0BjHID9tfaqw1FH1ofd2r
s9CkxkGQeO24iiNGyypEvkbLO/R4LcTBekt6ul+JhnW+Mx9CpxAz8fRG0bhTgpksV8Se7yTv
6EWFlAPXGe5YWzeiATt12Ojli23PR4jyaQ8CyNiqHlCNb11PW8oEgruk0iRuoqU2NIxzb6tF
NHWo2qE4EVLOtNl4GFE1lvMiUdahImDtGIJYeqt86UwnnUXy4CPSloEHDax4+cip6tNp+bUW
0YZWzIOP1uitmKk+DvZH8fMRm9Z9RvstxOoazbtIX7IMLKLH0xKbnzeLcO7aJgQRpZbeCsTC
QaBj3juuhpquL19v2fywgGjdD+gtoq20pcU2MzeOyD4+ookzT1sLCJiDT7Qxto1Ia2pPEETQ
Vnvy5r3wdEw1sESjBBY/BOWkw2us5TLpq31+DnDnp6GiqxWHQ13Bcl1IH9zJ5LfhZIIYKdvX
INgrH/cMgLW8ZT9R3sUiQJiOm1qhRzWEZ3siIMq4ZHQgis4iWmzdIjrfwCL6pwjNMdm5Zv+E
pP3n2X+eDUQ0dZCw2AGLSo9hkWQxrjW9QdeIyvrzyrc4FclGyiXm8HDVwBu86hm1sp/04NXr
fp0yebhuIyEEsnXnk9AHfC11xp/+Ea/3FlUpIJMpNUTUecx3T9cQDgRDlCfj6//8Ff7yPQvC
8AJUNFZjezAHKRffWQ2JNdJ0ChkxhaiqO4UlcRvx2MJhjeqRBhzbXEqf42NOOd9RLgWH7w93
3jLc736ObX4ceBCCZbzyf6hE1bckcA4CzWELyouPELzUPkTJ40FEpr8zASKaOYg9AeJFZWib
DMk+9Bgb45fgVF0VCmMpt/gRHVH7dLMQDkkn8WpYZZmIpi2iOUi7ToF6JbqvSfHPjwXY06ix
lB+V0YoIPRF9CaGuxtb6lJy1jB+Ni9T5SmQPHxqQjY9lPjSflJkbkK23hB28j1Uh+bS8QOHx
UI3lpHbP3x8aQSukR5v2IjLpPDp1hy52EUVNDA5oCO7hJ2vgl3KVlmOtyv9F3vBc/5A50I/y
cnxdj+Z+1S8wRvQg6rf7gp/zUBcjWvsORdtRhMyYgem24qWfPJ86EG07wiSZuNj6BhWrvOC/
vgrvNaRo/TpH/Hn2Kk0YOOZZby0GpvBVsBhrnzAHeA7XbYBHCIOvPihvHMxmqc90oTncA5Ez
NjSHtr97riBRtIJe52msw2dkScrYIpKtwTpDD7FSMJ8+I4CySg5w0Vy3hI0ohSI3wsx16v1R
ONtJGStlw9X7EPONhNtYPs8BKzTYoKdCCkcvTR71DDeM5m2od/n9k5CiL0Z0HIxSrtR4thPM
FeyFzfVjDrijsbMPiupND1+0hrnGzwsg9ZDp6qFSqac0NAdtdR0soK2GtVbKOgtdaxgrQILC
Wu042giPwAM6q2eL+MtqHsE6EmOLaG6m1iL6lZFF9CaxD0qa5OOH5qA8g/1ngBVUgOsdo/S3
Cfw11uYEk+VJ4unQhFSo3xDt2LGA1SzeT3mKCihFH+GuRp6hiCgL0wgRbRGDWcGgjJEc+Vbx
DHhL/eCaeBndKkuHFY5zyjTtanMsDL7FRPvzphSh/kQzbkhgjrzEAWkYwsIk+OaPfwVvjf4k
Z+rZd1c3YiftYko2/aPJYM91hONcDpKPNWsWMMbtKdRpJua5uoMrCIA0ZwHEEbuMTnJk3qdA
a2ks4k8YHFZ4JhExh1rHJUcsCp4UiedpbB1srm2ow03Wh680CT2haL+KHB8WHVvGlRCm194Z
uo49QL7fXHxGCOO5RMstCGLicdJ5768i/C+/wT8cOEbWDbTl9eONCHbngOvOhotrgM7la1xS
itbci8CjtFBO4dhao3ftVXTewNowAdFQucCBE4+99cYH9VGuYAn8DLPCWuORRLjNc4aLAxtJ
pcxpsXQst1A2WGweRB7+SNhUqSMDjNrNWvtSlsXtj3HhSBkabAj8ryYAvezIBTxuHzHvsmzO
7U71HpVSIaTX3uHt1XwEuTOhOUK4HPin7sa9boVuwuz29sDWl/pwLlT80gCfYibGqZG7FukX
lg9WXHyjOz2bAhznVwWAzWKTNuZAFFc85iRnLrhcd7DZHkgsIm01qh7XncySxbta/g43NsfQ
mlMOlw+B0AfJ2+7SJ6JOnIhOw+2xRBjRzD4p8oVj1GE0jmi//W+Y4y5g4ukFrMCNHtW4G4Ox
FTkRRjY44b+/khqcAt2Cs8t94cqitLZs+C0/ixbZ+EHwdc+5uMLp28/xXcwR8yERNJbKvGX3
mQ2AKMUOJvHh4kKUOQRcubBDsbayw9h62ZzwqIkrnMhzgRvHDSx+EvY9HTS2ztGcMP6Jv/kT
xgers/DtH1xRTDSkVL3ajojwx78n68L6NOz0h3i1NmbVMOo2ehIhT08WW5zzvdcR9dlv8Hcy
N00UN5YE6r6bWBJRRFuQ20pEM0qUbrT1jNoG0ii34BV8zHTgwTciEjw3A2tcKqZUQgBEVEwp
dgL2G8UrOwqpyIn0DZkv3pm6GNF0XGe3uXDm8OEVGQsxJ0N38Agdi0sT89kvvhC3upSWBRXN
/bGu5F3uIgTEJULsvtTE8nniChwqLt4WhHgyZPSUEdG6OKdOTPwybhL2a8Ye05YiJMT6Q8Rl
wWFMW+razEyMaJNxRISOnVE8Inxz4U5ZpO2s1ZxW3YObub5EqRmEkIRNeDTAjM+nxYGYNZsN
n4go8NnG+8Zo4y5w//gZImili9rISp6y9v3clxDUKrIerHfAZ17HdRZRr/ZHwGPVHaLMGyX7
fAzEWZV6qxplO04FfI7p2Q90BxxRHkhBn/4O37iYCeE0bozouz95jOjJzjX7JyTtP8/+82wg
oqnwDFXr4fnFf+LfPvof+L9fxeJsu8LYRd7N1MpV3n4Fef4ucCRyCc9vCc60WiGih2qxJcwN
jg5OcHaci1mO/si7rCEvVMPo7hqAnJAW8fyl+lAToy04tkAAV7Y7OKSM0E36GJGUO3frpXyE
kfWcirHpxgtF/oVmmw4kkvd3YIDIgNq/k1qPPqB8s96lVsLs2ZK6Lwbjz//n9/haG9aC+gmW
4q7WG8lhFvgSIfjeEQhzmQbX9HK8U6ptI6L7biDhH3/AN658Rq41wGc2faNiAB39ct1fYy+1
dtwsIrKFiwPBu9/gT//5W31ojnlCZFcxBj9MPFMmRrSDOAOHy0uwUOhCcJ8bJKmEIJePQ0RT
svrWEDg58eDpF4Xcy+3jY5kPzO+7tRj8JIOQcupeVKaIkHm3Hy37iRy74alOaUArprd4Ifjw
azzd6IGgI236c3c03IIPISRpY6ksIRLLe3SyjTlcpMdaQeDxRLRltVfcVlT3qn72oTl0yhMq
/jrBgxw3NjxTD6HejMEPFabsbsY0/NeXtuGlnzqfItWfHi/BNc3ZU2pFJ27vP4waql+o9W5x
MjKSPGnsxXblIGDlebQaWFJTMu4CkTsEYiG4ogV6GfeD8sbBbDaSnYbXrz85ihRPLtjOLIRu
fayTkW/k+MMvIQNLCRfmrFUeKLtRme2O7+dyCQaK0GMgS9iIXL+T74m5jm50vOYZDtr3dOH6
EjamO3sgIi4Qjr4aspkQ+g82+GLGdw7gegQhITUKLD9tHlWGADPnEUVi1Gqcu1WKrAA+uDwe
+EJvJO7Wn0FDncuTEeiDgCB/eAUsRXm70gBXzYXTGFxlDXPZkhfv7ggWwV7e0atR2aWcUiJa
u6amill03GYWuf9Yw7DJQZTmMNZCTzF8A3wh9lxoMsbM4q9x8gZqd2O+yyw4uhJ+0HcVLrfL
9WGjqjYg0JngXEdnBG64p/PmtI4VGnAoJRiebGfCu1ExqQ1jfRNMtiMS4pBkLJZGws1Fq8Ay
j9Us3z+CF3tCMXumG7zmpyHNg0NbRFvEYFYwqPZbu8pj8fl/fAXprT6j7/noB9Fc/0in66t6
byEnoZhxwycgblfiSlT2qCb9PtnLPZBufmx0MIb9p6lLP4f2lb8+iQXC+dhR1Q6Z9rDCx+W4
WN9vU7zbf9Wk6r6IGEnBz+L030mtOfTGdgiLEzfidrfS/iebiVVyDfKFs8EKLsSjQUsn3j/B
plCWxbiR/5LtQsWe1goLNWsh9NFb8Nj0PBXaSLzUajz8H+U7JkCm/lj78w/2rUQIOhPjjfV1
IzaO/WosF8bjsqXDC4kCZ4Fwic2kyA9FRE9Fv9s/IWn/efZPRI8/X272/bhzlQKO++Lc4cQS
IqGEiT9s/+nH3f+oOM5nizZg49azJp6nv7jvVfTi1fPX9j+OtPjl3QVkLj1ncnC3/aefH06T
y+R2jbV/EXMpy/7n0s8btw6jp1f2k80jcxjMlj24/85ioqDPNYmk8JH9d6n9J3tLo++qULIk
DGKNRnB+3knU96vsd1GjTyd3RlAxoxm1/2T/yV6SsuMqlgUIwWM7YKZjKIqqe23e3KmTqkvi
ePDSuCj+3IG44b2/VCJaPVCDjRHu4EltF5Qpi6Kaogi4i9NwoX2MhTpZ+7ZF8BFceM/otGqr
79ModZw4BrHvNAfEWq+7GcvACVoFTqQu9p9n/3n2lvevvPbZf5qa/c/+079WUrRfRIbwe3zj
u8fkLCn7T/af7D9NAA+9u4xM0XR8a/9zyf7TBDGYVc91KlpGWjBEbH+srTI988r+iWj7T/af
7D/Zf7L/ZP/J/pP9J/tP9p/sP9l/sv9k/8n+k/0n+0/2n+w/2X+y//SDpv8PFGykD2NMVW0A
AAAASUVORK5CYII='
	) base64Decoded asByteArray readStream! !

!StrikeFont methodsFor: 'accessing' stamp: 'jmv 3/19/2009 14:52'!
baseKern
	"Return the base kern value to be used for all characters."
	
	| italic |
	italic _ emphasis allMask: 2.
	
	self isSynthetic ifFalse: [
		^(italic or: [ pointSize < 9 ])
			ifTrue: [ 1 ]
			ifFalse: [ 0] ].
		
	italic ifFalse: [^ 0].
	^ ((self height-1-self ascent+4)//4 max: 0)  "See makeItalicGlyphs"
		+ (((self ascent-5+4)//4 max: 0))! !

!StrikeFont class methodsFor: 'dejaVu font data' stamp: 'jmv 8/5/2009 22:35'!
dejaVuSansBook9Data
	"Created using:
	Clipboard default clipboardText:
		((FileStream oldFileNamed: 'AAFonts\DejaVu Sans Book 9.txt') contentsOfEntireFile substrings 
			collect: [ :each | each asNumber]) asString
	"
	^#(9 11 3 0 3 6 11 20 28 40 50 53 57 61 68 77 80 84 86 91 99 107 115 123 131 139 147 155 163 171 173 177 187 196 205 211 223 232 240 248 257 264 270 279 288 291 296 304 311 321 329 339 346 356 363 371 379 388 397 409 417 425 433 437 442 447 453 463 467 474 482 488 496 504 509 517 524 527 531 538 541 552 559 567 575 583 588 594 599 606 613 623 630 637 644 650 653 659 668 676 684 691 697 707 715 723 731 739 747 755 763 771 779 787 795 803 811 819 827 835 843 851 859 867 875 883 891 899 907 915 923 931 934 937 944 952 960 968 976 982 988 999 1005 1012 1022 1026 1037 1042 1047 1056 1062 1068 1076 1084 1092 1094 1101 1105 1112 1118 1131 1143 1151 1157 1166 1175 1184 1193 1202 1211 1223 1231 1238 1245 1252 1259 1262 1265 1269 1274 1285 1293 1303 1313 1323 1333 1343 1351 1361 1370 1379 1388 1397 1405 1412 1419 1426 1433 1440 1447 1454 1462 1474 1480 1488 1496 1504 1512 1516 1520 1525 1530 1538 1545 1553 1561 1569 1577 1584 1593 1601 1608 1615 1622 1629 1636 1644 1652)! !

!StrikeFont methodsFor: 'accessing' stamp: 'jmv 8/3/2009 10:01'!
widthOf: aCharacter 
	"Answer the width of the argument as a character in the receiver."
	| code |
	code := aCharacter charCode.
	self characterToGlyphMap size > code ifTrue: [
		code := characterToGlyphMap at: code + 1 ].
	((code < minAscii or: [maxAscii < code]) 
		or: [(xTable at: code + 1) < 0])
			ifTrue: [^ self fallbackFont widthOf: aCharacter].
	^ (xTable at: code + 2) - (xTable at: code + 1)! !

!StrikeFont methodsFor: 'emphasis' stamp: 'jmv 8/3/2009 09:19'!
makeItalicGlyphs
	"Make an italic set of glyphs with same widths by skewing left and right.
	In the process, characters would overlap, so we widen them all first.
	"
	| extraWidth newGlyphs newXTable x newX w extraOnLeft |  
	extraOnLeft _ (self height-1-self ascent+4)//4 max: 0.
	extraWidth _ ((self ascent-5+4)//4 max: 0) + extraOnLeft.
	newGlyphs _ Form extent: (glyphs width + (maxAscii + 1 - minAscii*extraWidth)) @ glyphs height depth: glyphs depth.
	newGlyphs fillWhite.
	newXTable _ xTable copy.

	"Copy glyphs into newGlyphs with room on left and right for overlap."
	minAscii to: maxAscii+1 do:
		[:ascii | x _ xTable at: ascii+1.  w _ (xTable at: ascii+2) - x.
		newX _ newXTable at: ascii+1.
		newGlyphs copy: ((newX + extraOnLeft) @ 0 extent: w @ glyphs height)
			from: x @ 0 in: glyphs rule: Form over.
		newXTable at: ascii+2 put: newX + w + extraWidth].		
	glyphs _ newGlyphs. 
	xTable _ newXTable.
	"Slide the bitmaps left and right for synthetic italic effect."
	4 to: self ascent-1 by: 4 do:
		[:y | 		"Slide ascenders right..."
		glyphs copy: (1@0 extent: glyphs width @ (self ascent - y))
			from: 0@0 in: glyphs rule: Form over].
	self ascent to: self height-1 by: 4 do:
		[:y | 		"Slide descenders left..."
		glyphs copy: (0@y extent: glyphs width @ glyphs height)
			from: 1@y in: glyphs rule: Form over].
	self isSynthetic: true.
	fallbackFont ifNotNil: [
		fallbackFont _ fallbackFont emphasized: 2
	].

! !

!StrikeFont methodsFor: 'emphasis' stamp: 'jmv 4/26/2008 14:12'!
isSynthetic
	^type = 3! !

!StrikeFont class methodsFor: 'dejaVu font data' stamp: 'jmv 8/5/2009 22:33'!
dejaVuSansBoldOblique12Form
	"Created using:
	Clipboard default clipboardText:
	 	((ByteArray streamContents:[:s|
			PNGReadWriter
				putForm: (Form fromFileNamed: 'AAFonts\DejaVu Sans Bold Oblique 12.bmp')
				onStream: s]) asString base64Encoded)
	"
	^Form fromBinaryStream: (
'iVBORw0KGgoAAAANSUhEUgAACXwAAAATCAYAAAAp8Ve0AAB9+klEQVR4XuVdB0xTaxsmado0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'
	) base64Decoded asByteArray readStream! !

!StrikeFont methodsFor: 'building' stamp: 'jmv 6/19/2008 16:55'!
stripHighGlyphs
	"Remove glyphs for characters above 128"
	| i |
	maxAscii _ 127.
	
	xTable _ xTable copyFrom: 1 to: maxAscii + 3.
	i _ xTable at: maxAscii + 1.
	xTable at: maxAscii + 2 put: i.
	xTable at: maxAscii + 3 put: i.
	glyphs _ glyphs copy: (0@0 extent: i@glyphs height).
	maxWidth _ 0.
	2 to: xTable size do: [ :ii |
		maxWidth _ maxWidth max: (xTable at: ii) - (xTable at: ii-1)-1 ].
	characterToGlyphMap _ nil.
	self reset! !

!StrikeFont class methodsFor: 'dejaVu font data' stamp: 'jmv 8/5/2009 22:31'!
dejaVuSansBold7Data
	"Created using:
	Clipboard default clipboardText:
		((FileStream oldFileNamed: 'AAFonts\DejaVu Sans Bold 7.txt') contentsOfEntireFile substrings 
			collect: [ :each | each asNumber]) asString
	"
	^#(7 8 3 0 3 7 12 20 27 38 47 51 56 61 66 74 78 83 87 92 99 106 113 120 128 135 142 149 156 163 167 171 179 187 195 201 211 220 227 234 242 248 254 262 270 274 279 287 294 303 311 320 327 336 344 351 359 367 376 387 395 403 411 416 421 426 431 440 444 451 458 464 471 478 484 491 498 502 507 514 518 528 535 543 550 557 563 570 576 583 590 600 607 615 621 627 630 636 644 651 658 664 669 678 685 692 699 706 713 720 727 734 741 748 755 762 769 776 783 790 797 804 811 818 825 832 839 846 853 860 867 874 877 881 887 894 901 909 917 924 930 940 946 952 961 966 976 981 987 995 1000 1006 1014 1022 1029 1033 1039 1044 1050 1056 1068 1080 1089 1095 1104 1113 1122 1131 1140 1150 1160 1167 1173 1179 1185 1192 1196 1200 1205 1210 1219 1227 1236 1245 1254 1263 1272 1279 1288 1296 1304 1312 1320 1328 1335 1342 1349 1356 1363 1370 1377 1384 1395 1401 1408 1415 1422 1429 1434 1438 1443 1448 1456 1463 1471 1479 1487 1493 1501 1509 1517 1524 1531 1538 1545 1553 1560 1568)! !

!StrikeFont class methodsFor: 'dejaVu font data' stamp: 'jmv 8/5/2009 22:36'!
dejaVuSansOblique9Form
	"Created using:
	Clipboard default clipboardText:
	 	((ByteArray streamContents:[:s|
			PNGReadWriter
				putForm: (Form fromFileNamed: 'AAFonts\DejaVu Sans Oblique 9.bmp')
				onStream: s]) asString base64Encoded)
	"
	^Form fromBinaryStream: (
'iVBORw0KGgoAAAANSUhEUgAABroAAAAOCAYAAABw4MzRAABUGElEQVR4XuVdd0xU2dveZLNm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'
	) base64Decoded asByteArray readStream! !

!StrikeFont methodsFor: 'character shapes' stamp: 'jmv 4/23/2007 22:30'!
ensureCleanBold 
	"This ensures that all character glyphs have at least one pixel of white space on the right
	so as not to cause artifacts in neighboring characters in bold or italic."

	| wider glyph |
	emphasis = 0 ifFalse: [^ self].
	minAscii to: maxAscii do:
		[:i | glyph _ self characterFormAt: (Character value: i).
		(glyph copy: (glyph boundingBox topRight - (1@0)
					corner: glyph boundingBox bottomRight)) isAllWhite ifFalse: [
			wider _ Form extent: (glyph width + 1)@glyph height depth: glyph depth.
			glyph depth > 1 ifTrue: [wider fillWhite].
			glyph displayOn: wider.
			self characterFormAt: (Character value: i) put: wider]].
"
StrikeFont allInstancesDo: [:f | f ensureCleanBold].
(StrikeFont familyName: 'NewYork' size: 21) ensureCleanBold.
StrikeFont shutDown.  'Flush synthetic fonts'.
"
! !

!TextStyle class methodsFor: 'class initialization' stamp: 'bf 7/31/2009 18:21'!
styleDecoder
	TextConstants at: #StyleDecoder ifPresent: [ :dict | dict ifNotNil: [ ^dict ]].
	^TextConstants at: #StyleDecoder put: (
		Dictionary new at: 'Regular' put: 0;
				 at: 'Roman' put: 0;
				 at: 'Medium' put: 0;
				 at: 'Light' put: 0;
				 at: 'Normal' put: 0;
				 at: 'Plain' put: 0;
				 at: 'Book' put: 0;
				 at: 'Demi' put: 0;
				 at: 'Demibold' put: 0;
				 at: 'Semibold' put: 0;
				 at: 'SemiBold' put: 0;
				 at: 'ExtraBold' put: 1;
				 at: 'SuperBold' put: 1;
				 at: 'Negreta' put: 1;
				 at: 'B' put: 1;
				 at: 'I' put: 2;
				 at: 'U' put: 4;
				 at: 'X' put: 16;
				 at: 'N' put: 8;
				 at: 'Bold' put: 1;
				 at: 'Italic' put: 2;
				 at: 'Oblique' put: 2;
				 at: 'Narrow' put: 8;
				 at: 'Condensed' put: 8;
				 at: 'Underlined' put: 4;
				 yourself )! !

!StrikeFont class methodsFor: 'removing' stamp: 'jmv 3/31/2009 08:19'!
saveSpace
	"Removes glyphs over 128, leaving only lower ascii.
	Also limit glyph depth to 4 bits (it is usually 16 or 32).
	This effectively turns off subpixel rendering, as glyphs will only have 16 shades of gray.
	
	StrikeFont saveSpace
	"
	StrikeFont allInstances do: [ :f | f
		stripHighGlyphs;
		setGlyphsDepthAtMost: 4 ].! !

!StrikeFont methodsFor: 'building' stamp: 'jmv 8/3/2009 13:36'!
buildFromForm: allGlyphs data: data name: aString

	| x |
	pointSize _ data first.
	ascent _ data second.
	descent _ data third.
	
	minAscii _ 32.
	maxAscii _ 255.
	name _ aString.
	type _ 0.  "ignored for now"
	superscript _ ascent - descent // 3.	
	subscript _ descent - ascent // 3.	
	emphasis _ 0.

	xTable _ (Array new: 258) atAllPut: 0.
	maxWidth _ 0.
	glyphs _ allGlyphs.
	x _ 0.
	minAscii to: maxAscii+1 do: [ :i |
		x _ (data at: i-minAscii+4).
		xTable at: i+1 put: x].
	xTable at: 258 put: x.
	self reset.
	derivativeFonts _ Array new: 32! !

!StrikeFont class methodsFor: 'dejaVu font data' stamp: 'jmv 8/5/2009 22:35'!
dejaVuSansOblique12Form
	"Created using:
	Clipboard default clipboardText:
	 	((ByteArray streamContents:[:s|
			PNGReadWriter
				putForm: (Form fromFileNamed: 'AAFonts\DejaVu Sans Oblique 12.bmp')
				onStream: s]) asString base64Encoded)
	"
	^Form fromBinaryStream: (
'iVBORw0KGgoAAAANSUhEUgAACJ0AAAATCAYAAAAwX+47AAB9+klEQVR4XuVdB0xT3Rc3MRJC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'
	) base64Decoded asByteArray readStream! !

!FontSet class methodsFor: 'installing' stamp: 'ar 8/6/2009 18:22'!
installAsDefault  "FontSetNewYork installAsDefault"
	(UIManager default confirm: 'Do you want to install
''' , self fontName , ''' as default font?')
		ifFalse: [^ self].
	self installAsTextStyle.
	"TextConstants at: #OldDefaultTextStyle put: TextStyle default."
	TextConstants at: #DefaultTextStyle put: (TextStyle named: self fontName).
	#(ListParagraph PopUpMenu StandardSystemView) do:[:className|
		Smalltalk at: className ifPresent:[:aClass| aClass initialize].
	].! !

!CharacterScanner methodsFor: 'scanning' stamp: 'sn 7/31/2009 15:03'!
scanCharactersFrom: startIndex to: stopIndex in: sourceString rightX: rightX stopConditions: stops kern: kernDelta

	| startEncoding selector |
	(sourceString isByteString) ifTrue: [^ self basicScanCharactersFrom: startIndex to: stopIndex in: sourceString rightX: rightX stopConditions: stops kern: kernDelta.].

	(sourceString isWideString) ifTrue: [
		startIndex > stopIndex ifTrue: [lastIndex := stopIndex. ^ stops at: EndOfRun].
		startEncoding :=  (sourceString at: startIndex) leadingChar.
		selector := EncodedCharSet scanSelectorAt: startEncoding.
		^ self perform: selector withArguments: (Array with: startIndex with: stopIndex with: sourceString with: rightX with: stopConditions with: kernDelta).
	].
	
	^ stops at: EndOfRun
! !

!StrikeFont class methodsFor: 'character shapes' stamp: 'jmv 3/26/2009 14:51'!
makeLfInvisible
	"
	Make line feed characters invisible
	StrikeFont makeLfInvisible
	"
	self allInstances do: [ :font | font makeLfInvisible ]! !

!StrikeFont methodsFor: 'emphasis' stamp: 'jmv 8/3/2009 09:17'!
makeCondensedGlyphs
	"Make a condensed set of glyphs with same widths.
	NOTE: this has been superceded by kerning -- should not get called"
	| g newXTable x x1 w |
	g _ glyphs deepCopy.
	newXTable _ Array new: xTable size.
	newXTable at: 1 put: (x _ xTable at: 1).
	1 to: xTable size-1 do:
		[:i | x1 _ xTable at: i.  w _ (xTable at: i+1) - x1.
		w > 1 ifTrue: [w _ w-1].  "Shrink every character wider than 1"
		g copy: (x@0 extent: w@g height) from: x1@0 in: glyphs rule: Form over.
		newXTable at: i+1 put: (x _ x + w)].
	xTable _ newXTable.
	glyphs _ g.
	self isSynthetic: true.
	fallbackFont ifNotNil: [
		fallbackFont emphasized: 8
	].

"
(TextStyle default fontAt: 1) copy makeCondensedGlyphs
	displayLine: 'The quick brown fox jumps over the lazy dog'
	at: Sensor cursorPoint
"! !

!TextStyle class methodsFor: 'instance creation' stamp: 'ar 8/6/2009 18:36'!
changeDefaultFontSizeBy: delta      "TextStyle changeDefaultFontSizeBy: 1"
	"This sample method recreates the default textStyle, with font 1 being a size
	larger than the smallest.  It then initializes most references in the system
	as well, although most windows will have to beclosed and reopened to get the effect."
	| allFonts |
	allFonts := TextStyle default fontArray asSortedCollection: [:a :b | a height < b height].
	TextConstants at: #DefaultTextStyle put:
		(TextStyle fontArray: ((1 to: allFonts size) collect: [:i | allFonts atWrap: i+delta])).
	#(ListParagraph PopUpMenu StandardSystemView) do:[:className|
		Smalltalk at: className ifPresent:[:aClass| aClass initialize].
	].! !

!StrikeFont methodsFor: 'emphasis' stamp: 'jmv 3/20/2009 10:27'!
derivativeFont: aStrikeFont at: index

	| newDeriv |
	(aStrikeFont isNil and: [ index = 0 ]) 
		ifTrue: [derivativeFonts := nil. ^ self].
	derivativeFonts ifNil: [derivativeFonts := Array new: 32].
	derivativeFonts size < 32 ifTrue: [
		newDeriv := Array new: 32.
		newDeriv replaceFrom: 1 to: derivativeFonts size with: derivativeFonts.
		derivativeFonts := newDeriv.
	].
	derivativeFonts at: index put: aStrikeFont.! !

!Color class methodsFor: 'colormaps' stamp: 'jmv 8/2/2009 21:31'!
computeIndexedColorConvertingMap: targetColor from: sourceDepth to: destDepth
	| map f c |
	
	map _ (IndexedColors copyFrom: 1 to: (1 bitShift: sourceDepth)) collect: [ :cc | 
		f _ 1.0 - (cc red + cc green + cc blue / 3.0 ).
		c _ targetColor notNil
			ifTrue: [
				destDepth = 32
					ifTrue: [ targetColor * f alpha: f]
					ifFalse: [ targetColor alphaMixed: f*1.5 with: Color white ]]
			ifFalse: [ cc ].
		destDepth = 32
			ifTrue: [ c pixelValueForDepth: destDepth]
			ifFalse: [
				f = 0.0
					ifTrue: [ 0 ]
					ifFalse: [ c pixelValueForDepth: destDepth ]]].
	map _ map as: Bitmap.
	^map! !

!StrikeFont class methodsFor: 'dejaVu font data' stamp: 'jmv 8/5/2009 22:35'!
dejaVuSansBook9Form
	"Created using:
	Clipboard default clipboardText:
	 	((ByteArray streamContents:[:s|
			PNGReadWriter
				putForm: (Form fromFileNamed: 'AAFonts\DejaVu Sans Book 9.bmp')
				onStream: s]) asString base64Encoded)
	"
	^Form fromBinaryStream: (
'iVBORw0KGgoAAAANSUhEUgAABnUAAAAOCAYAAAD5VJn9AABJ1klEQVR4XuVdB0xTaxu+yY03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'
	) base64Decoded asByteArray readStream! !

!StrikeFont methodsFor: 'character shapes' stamp: 'jmv 4/22/2007 20:47'!
characterFormAt: character put: characterForm
	"Copy characterForm over the glyph for the argument, character."
	| ascii leftX rightX widthDif newGlyphs |
	ascii _ character asciiValue.
	ascii < minAscii ifTrue: [^ self error: 'Cant store characters below min ascii'].
	ascii > maxAscii ifTrue:
		[(self confirm:
'This font does not accomodate ascii values higher than ' , maxAscii printString , '.
Do you wish to extend it permanently to handle values up to ' , ascii printString)
			ifTrue: [self extendMaxAsciiTo: ascii]
			ifFalse: [^ self error: 'No change made']].
	leftX _ xTable at: ascii + 1.
	rightX _ xTable at: ascii + 2.
	widthDif _ characterForm width - (rightX - leftX).
	widthDif ~= 0 ifTrue:
		["Make new glyphs with more or less space for this char"
		newGlyphs _ Form extent: (glyphs width + widthDif) @ glyphs height depth: glyphs depth.
		newGlyphs copy: (0@0 corner: leftX@glyphs height)
			from: 0@0 in: glyphs rule: Form over.
		newGlyphs copy: ((rightX+widthDif)@0 corner: newGlyphs width@glyphs height)
			from: rightX@0 in: glyphs rule: Form over.
		glyphs _ newGlyphs.
		"adjust further entries on xTable"
		xTable _ xTable copy.
		ascii+2 to: xTable size
			do: [:i | xTable at: i put: (xTable at: i) + widthDif]].
	glyphs copy: (leftX @ 0 extent: characterForm extent)
		from: 0@0 in: characterForm rule: Form over
"
| f |  f _ TextStyle defaultFont.
f characterFormAt: $  put: (Form extent: (f widthOf: $ )+10@f height)
"! !

!CompositionScanner methodsFor: 'scanning' stamp: 'ar 8/4/2009 23:53'!
computeDefaultLineHeight
	"Compute the default line height for a potentially empty text"
	lastIndex := 1.
	self setFont.
	^lineHeight + textStyle leading! !

!StrikeFont methodsFor: 'character shapes' stamp: 'jmv 3/26/2009 14:41'!
makeTabVisible
	self characterToGlyphMap.
	characterToGlyphMap at: 10 put: 172! !

!StrikeFont methodsFor: 'emphasis' stamp: 'jmv 4/26/2008 14:11'!
isSynthetic: aBoolean
	type _ aBoolean ifTrue: [3] ifFalse: [0]! !

!BitBlt methodsFor: 'private' stamp: 'jmv 8/5/2009 22:26'!
installStrikeFont: aStrikeFont foregroundColor: foregroundColor backgroundColor: backgroundColor
	| lastSourceDepth targetColor |
	sourceForm ifNotNil:[lastSourceDepth := sourceForm depth].
	sourceForm := aStrikeFont glyphs.

	"Ignore any halftone pattern since we use a color map approach here"
	halftoneForm := nil.
	sourceY := 0.
	height := aStrikeFont height.

	sourceForm depth = 1 ifTrue: [
		self combinationRule: Form paint.
		(colorMap notNil and:[lastSourceDepth = sourceForm depth]) ifFalse: [
			"Set up color map for a different source depth (color font)"
			"Uses caching for reasonable efficiency"
			colorMap := self cachedFontColormapFrom: sourceForm depth to: destForm depth.
			colorMap at: 1 put: (destForm pixelValueFor: backgroundColor)].
		colorMap at: 2 put: (destForm pixelValueFor: foregroundColor).
	]
	ifFalse: [
		(Preferences subPixelRenderFonts and: [ foregroundColor = Color black or: [ Preferences subPixelRenderColorFonts ]]) ifTrue: [
			destForm depth > 8 ifTrue: [
				"rgbMul is equivalent to component alpha blend if text is black (only faster, hehe)"
				self combinationRule: 37.		"RGBMul"
				(Preferences properAlphaForBlackText or: [ (foregroundColor = Color black) not ]) ifTrue: [
					"rgbMul / rgbAdd IS component alpha blend for any color of text (neat trick, eh!!)"
					"This colorMap is to be used on the second pass with rule 20 (rgbAdd)
					See #displayString:from:to:at:strikeFont:kern:"
					colorMap := self colorConvertingMap: foregroundColor from: sourceForm depth to: destForm depth keepSubPixelAA: true]]
			ifFalse: [
				self combinationRule: 25.		"Paint"
				targetColor := foregroundColor = Color black ifFalse: [ foregroundColor ].
				colorMap := self colorConvertingMap: targetColor from: sourceForm depth to: destForm depth keepSubPixelAA: true]
		]
		ifFalse: [
			"Do not use rule 34 for 16bpp display. TTCFont uses it, but it builds a glyphs cache for each color used!!"
			self combinationRule: (destForm depth = 32 ifTrue: [34 "alphaBlendScaled"] ifFalse: [25 "Paint"]).
			colorMap := self colorConvertingMap: foregroundColor from: sourceForm depth to: destForm depth keepSubPixelAA: false
		]
	].! !

!StrikeFont class methodsFor: 'dejaVu font data' stamp: 'jmv 8/5/2009 22:33'!
dejaVuSansBoldOblique7Form
	"Created using:
	Clipboard default clipboardText:
	 	((ByteArray streamContents:[:s|
			PNGReadWriter
				putForm: (Form fromFileNamed: 'AAFonts\DejaVu Sans Bold Oblique 7.bmp')
				onStream: s]) asString base64Encoded)
	"
	^Form fromBinaryStream: (
'iVBORw0KGgoAAAANSUhEUgAABl4AAAALCAYAAAAeJPBpAABCM0lEQVR4XuVdB0xUW9c1IZAJ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'
	) base64Decoded asByteArray readStream! !

!StrikeFont class methodsFor: 'dejaVu font data' stamp: 'jmv 8/5/2009 22:31'!
dejaVuSansBold7Form
	"Created using:
	Clipboard default clipboardText:
	 	((ByteArray streamContents:[:s|
			PNGReadWriter
				putForm: (Form fromFileNamed: 'AAFonts\DejaVu Sans Bold 7.bmp')
				onStream: s]) asString base64Encoded)
	"
	^Form fromBinaryStream: (
'iVBORw0KGgoAAAANSUhEUgAABiEAAAALCAYAAAAZZi58AAA7+0lEQVR4XuVdB1BT2fdmhoFh
MsmECRkyhKEMZWgDyKCiI/ZBAbGhg9h777o27GtbC7bdtaCuDcuquOuqrKKoKIqASlFA1CgC
UgRCh1CS73/fS4ckBBd/v//+cmcySu67L/edd8v5znfOuUaA4RfDL4ZfDL8YfjH88r9XqlJ2
Y9igCDwWig1fGIZfDL8YfjH8YvjF8EsXlNaKF4g+EInIn//E21r99leJuB6Fb7JRImpFbf5r
5HwVGb4gv7FIJGLUv43GD0t249j2RYiI+QiRRNL1vyNuRHF2DnlnYjQUZSGn9N/3zsSltzCh
+zTE5Ur/vS/UX06S5nKknlqL1WcyUSPW3q5VmIpjK9cjOl2IFg3vQdzwETd3R2DHnk3YcCoV
wtb210hqM3B41hhMWrYVa+YsxMFnFWhtcy9J5QPMc+eAwyEf93l4UKnhPjVJWO3FgHW/8ehl
yUKv7Wmo+x5jQ9KId6cmY+yBTNSr3J8am5WJGzB68Z8obJYovqt9FYnJKy7hwcl5mHY8B42y
NpKa59gwbjEi5/UET+WZxLVpiAyfgQt5TdLrWksQu2QMtiQKISZtJZJapO+fjGXR8Tgxdzqi
3jbqJR+tz1ObjoMzQxE+YwEWbv0L+U0aZCtpQO5vUxCy+SkqtYwH+llf/IQRYT8jQ8PaSNXX
pO7B+HknEHduKcI2PkK5pvFQl4lfZodi4pqT+P23fdi4aBpmb4nB+3qx7D41SFpLySwc22ar
y+7b53sLRI0ttHzlRZR/AytC5uFqfpPmNi3FuL18GOZGv0dDG5lIxFVIjZyMOZFnsXvmTBx7
Xad2b9UxzfNbh+c1GuQgrkHarzMxI/IxSpq7ZhxLWhtQXlyK6ibxN8hIhKqSEghFXYMrJaIC
xG4ehW72dvAMXo2r7+vbyeifPWs9vhaW6HxW6pkqvnxBeaO43ffCkq+oaRbrvV+U5KQhu6RR
7RkkkhZUCTKQ8bFadl0tCjJfIqu4oUufVf25a5Gf8Qpvy0QdrGNEH8nLQNq7CjS1HZviJlSX
FKG0tvm79bPTz9Vci6/FX1GrYy5IWmuQl5GOD8LmNnNV1rbl/8ezGKl1Tngf02xN4b4sEdXU
Ak//bQQjI/KxVd+4JcJHWNQjEL++FSJtW3/02/IStaoDrvopVg9fjafVKt+RQZd1agZ8eWzw
ey/EpQ9kw2j9inurw7DxsbD9wkRdf2Y+/O3YYJjboc+Sv/ClWaK1v/SmVZWMH/vYYcgv0g1O
UvsKO/3tEEA2Sfkm3FBWjKqKRLp/iRVVKC5r+L4DpjYVm4Om4GphC/13U9F97Aj1BI/Ng2fo
Dtwvlm2wZMPdN7YbrBka5E2Uk/3j/eBkyYAZ2w69px3GszLp/ST1b3B4rCf4LFOYsKzhM3oz
bueL2i3iqT/2BttIXV5q75j+8DAy+jOa5fVkcby/dyr8HTlgMLhwGrIFqTUSDe3Ix2464oUS
WjH5dGMDRnXjg2XGAt97JNb/+Un6PqjNOecilg92AofNh0/4Hjwsaf7/MbGJAhJJ5G/DNgPb
rg9mn8hAtVjyDQvEZ1wItSIyYcB3fTJqJG3HrExexgzwPIKw+poADXJ5N+bj7u7J6ONA5M22
ge/4Q8isU5e3sZk5rN36Yfz6S8isatX5HrV9L+1nGZJPrcQIX1uwTU3B5ruj/4wjeKP4vbZr
gfa/ta8fsr/J+Ms4MgZ2LHuEHctErVjzPdrJycwDyxOotUEMYcJyeJgp54b8GmPrMYgmSqrG
PlHjN3IGBrhwwSTj12XgbBxKKFZsNGryMWHBtvdMHE0VKhT/du0HzMLBR0Wa2xubgesyGEui
c+jnk25uTfgStwNhvtZgmZqBY+uJoIj7KG3VMoeM2j6fjncgEuDkMEuweu9Eep3091oKr2G8
DQOeK5/QCrJEUomExa5guCzEQ3LP1uI/SL0RLEecQx5ZS2tTN6A7eSfTYr+Sa0V4f2o0rFne
WHHvK1rJ+pu+bxAsOP7YllKF+qyfEUjWH7cFsSgh/W8uuIapjgzYjDkNgUjH88jXBZV6zsCD
yG4k3zW8QeSIsTglUCq3dS+3oCeTuk79XbaUp+BM5AkkdmK9oNYiQfQ8hO99oRNAattPOgfI
qpG4zB2mtvqBXElrGZ7sGA5nc5N2631n+9fp+ahH+/85o02zEDkpT5H6vlKjkeBf9SytQiTt
C4W7hSlYvbYhjVqzCZCb7T+bBqE1z36AJ8MMPJ/JOJZR02XKM62TnZsNbw4brhOP4VVla4dt
vmXeGn4x/GL4pXP7gEbMRfb0T3+sRbC7JRhmbNj0i1AYeSStVci4sBajfKzBZpjDofd0HM8m
xg+C7VYSA6Zl0DHkkn1d9C4KwyyNwOq5CUlVUkOEuPIVTszrD0eOGUyJHu/afx6iBSKFga06
/Tim9yQ6D9MSrsN24EWtXB9qRuGfyzB24TrMHLcVTyrEKn1tQsnTKCwf4QMbcyY49j0xZs0Z
pHxtVjHKZSAy1B2WTBZses/B6eza72fA0Kc/KjqNef9IvG4g63BrBZ7tHg4nnhvC9j8hxnuJ
/vhjtBu4LCv4LbqGPEqnIpjwp0B7mJsR3dJjDPY+lRqlKRmLhAX4KHiH9Ad/IeZmAjLeCSDI
K0Fdq0QvAqNBcA2rhzqDYyLtv6nHCrWxo2o8Kvl7DcLmrsWscZvwsFyGOQi2jpzaHw5usxSG
T1rfuroCA+zNYW4/ACsItmnU8/1Qxq7q0gLkCchztPl8Kqr9pj1b0lKJ3KSHePA0GxVyY3hT
GV4nPsCjFAFqWiUKI1RRTBj4zJ7Y8rJObzzX1dfIx/iefkobRvv3UYvUzT3BNDKG7cQYfNFg
TKKM9Ten2sOY0r9N3bD4gVDjPKF+a5c/u73OrooT9cCk+mBO/b83Am/UBeS3fCPu1KKHK3/H
GGbmNvAaOg8/Py7RiOWsRkXjc2nn8WSXXkPwecpvP2BUDztwGExwnfwxYcs1ZNeIO3Uf3cbv
IiQcnovBbjzSngN7v7FYum4B5v+SRuOlztoBvu1vJeZt/XINY62Y8PvxFW2v0w9zasE0ZO8r
iP0RYUR+5gR7m9v1RPiOOHyREUsScQPy7uzB/OWnkF6lgSgS1+HDjV1YuSUaqV+b1Gxpr8+u
wdLNW7Fs2RGkCJU6sLg6FTuIbavfos0Ybs1Ej02pCruoLntqY/ZBDHQIwJ5LuxFgwUD3Dalq
9tR/rreTZ/37Jyxcfw0fGjQ9ayVeRi3FksOPUSySqD1r5unVWLFlPRZvUG+rkP3kDRipNv8I
OS64gc3TVyA6p1ZGFjaj5MFPmLHoOFIrWuj+vLu4Cgt+PIiN8zfgBrFXapOPRFyNl/uDYcPv
hSkrIrDhp2hk1ogV+5jw2TYE2NohcN0ujLKhZP5CKXNKF3lzCWsnL8XZ15pxELXPF8fvwvS5
B5FQ3NZuWo2M0yuxYONuRMxbh8tvlQQa1a6QjK8p4+Zhw/LJGL/qMj0mdcmm695nDXJitmDu
2kvI0URyEnyY/PNczD9E9I8m1XXnM25tXYC129di4Za/kNeoxTapxR4hafqE6Ml9MeOi0uFB
H9uBrnt/MwlRl7Yd/f03IFVIDGEh3THnfoV0sJHBJYiJwMhu1mCaMsFz8cO4fa/oQSGpTsQy
dzPYDp6Kvjwmem55gZKMA5j6A1lgNG2kVY+xyMUU1qGn8epDBh4/zFLzHmi/+TTh0/lQWNuM
xaWCZsVC9D4qEDzHafijSGq0L4yLxKKJIejm4I1hExYiMq7wuxpjal9uRfDk31FAbarictxf
5AaOz0rcSLmBlT4cuC+ORzm14Dd8wF/nfsOeUDuYtCMh0nHi4EUk5giQcXUJujHN0T/yNW28
pjaS5PinePPpM7JuRcCPTclWnRQSCX5DKFEMGcaaNnATuMy5iffFxSguLkFFvUzJlNTj9f4A
8PgB2HorEx8/vMTt6BjkUAoIxY6WUtcXoyj7CqY5kfc6/or0GWueYoWHGSyHROJJTiIODLWE
GaXg1kgNp6eG82DeexPupsdhcx8u3BbGoUws+Uag0Axhfh6EerDjlBEqL1+oIFja1de/x62r
95Dx/iVOhVrD1HkBEqqUi5mo8AmiVo9DX3c72Dh6Y9DkjYhOLWt3v+a8aIyyoozSRmD4RKgx
+6ryfvc5CYeCiGw8f8AzSjaSOmTsGwgLdjcsjE7BB8Iax0VfQXatRKXdX3j7KRN3D4yHsxkD
3qsSIBRLtL5Hrd9LGpBzdDghrlww8fB9eux8eHUP534+i9e1XUxCLL2H1OhpcGXxEbT3uWIO
60VCEEO0G5kfFQTYxS92g6lRexLCyIgN/90ZqGu3Hsjkad4dyy69wId3SfhttgdYVsNxPLex
zfv4C7nv/kaEHxucQYeQ09hRe1H79p+e4mAQD6ZuS5EoA3MUAbnelwmrkF/wTPAZ71/G4eof
6bQMFHPo7VWMs1Z5R6VCiPRRAMl6JzgVAkt2H+xMr6PB4peYCbBleOGHxErZ5t+CgsuhsGL3
xZ7MetQkrUY3sj4wXeYSYkAEwclgcLmBiHove576bPwazAO7RwTiEn9GMCGMu0c8lo4xisjc
4Q9zdi9sfSbA/ZXeYFoOxeE39UqPCdmaUPzlLW790B1sYwsM2JksJURUxuKH8lo00yRJA17v
G45xpz8qFGdxUw3KcimZKJ+1pTwRuwLJnDQyAW/AJsR/B4Pmf5yEqHyIOY4msJ90Gdkl0nf+
zSQELfsSfK0SKZWkNt/9r5IQYrH4P/J+/18ZIqseYb6TCayGH0Pql2o0idVJCLGoEvmJezGI
ABqfiBS9AQ3lkbjOjyf1IpR95N5pkuZSPN47CaOXnMCzgkKknl+NscSQeLdApIOA+LZ5q7Mf
hl9n+HUGVtfRWq+VhKD1DwYsBuzCw/cCZD5/QRsZaDLg+iy4mLHgPfckEjKzkHr7PK4Qoz6F
md4eGQouwxurHr7H/eVeMDN1wZybxbQhWKF3cPpiS2wGct4k486laMQXiBRG0pQIHzC4Qfg1
KQspD5NQqGrYIOtI8u9ncCOrWgXQt6LsAcEuHC76LI9G0rtPyHl8EnMJPrLouxVPZZGMkuYi
xK7oCY6xEW3M7cza1rm9XM/+qOg8JXKdhl6bTWEbMB39rAhO2/da4WSkk0Rq+orszOc4PYaQ
N903IpXSw5srkJOejdzE/RhsocR1tN60tx/YbYzHxo5z8VAPT2iJuAx3ZjnSRmpT17m4mXYT
C4NXaSQh5EaNrPs38SC3Ws0zX3XPka7bSVhFeeCHRhKyyBoMr9VIqulArxEVIn7/DPS1Y0qN
5ho+/HHXUdzadh60oKlFxSgmbkZLOy9sorNu7wO2qT3GnxcQw0kDck+Gwobljnl/FKgZa1sb
hCgpKUNNG29hXXiuq6+hcObXuwvgZkqu8V6lMYJXXJmIVd4M+j7G1kpbh9q+W3AF4TbG5BoT
IlMTOM+ORakG/bI6KQK+bEdMjTqGMGtNOFGOSX2wmMKkH98g/neZDaCzmFPn97Jx+F42lyrq
pWRbl5MQUqyWk/sYx6e6gcUfgSg1LCcbczYTcD3rTufxZJdd04icYyPANzaGRc/5OH4vA4L8
z8hNuY3zvyfja4uyP1YOodgfn42Pbx/j6GRXMNXuQwzCxR9Q3CBW2MNKBQVSJ0AyF7J/CQaP
I+9HAvYP48OY1Rs7XtXq5cj0vUmIDjGnLkwjiwbijzyGpNcPcYTIhmHeH5Gvv5/TsUhwCUvG
L8ahI5sxY8IynFUhydXwcak63pM0fkTMqgA4cc1h678A574jud51hnCZHiKsRoUGfeTb7qcu
Hzpi6PVF7D90Dr8fnYfu9v2xJaFMQUhTNsqs47MQMprYcQ9EYNqElYT4qPuvy04f2Uijf3jo
uTZJKyGt1JmITaS2+T/QZ83jU+6MUHRrOcI2PcDXVkmncLWue6uTEFUJWODMUih2ktY6lOTJ
vBFkHhYdeu8SomGJmxlshszH6EFzcPHJQ9x+kCeLSkjG2m5MOI5ahkBrYjj88QZOLV6K3/O0
hHiJcnF0KBem9uE4ndugQTGS9u9zqTScR9JEDNzDuOAGn4RAhf1peBOJ/ubWGHetkB68X+4f
wOKJw+BNSIjgCYuw//6X72aooDaKtO3DMPFiPm2slsqAAYdZ8RBKhIif5QBGt3VIVngKdWzI
ai2KQRhfuVCrKs7Vrw5gEJeHYVHvlExVaynuLOqBASt2EKZQcySEqbkV+HaeCCQKd7aMWZPU
vcKPfoQkWSY1dGt+vhYUxkyCHcMdS+LLpe+BbseGddhlfK7/jMth1mArvDUpw5spXBc/QZWk
Ck8Wk03TaxWtqOrruUsBqCrBU8QcXoOJfR3B67EKz6r1ULyrn2FVDx4c+07E2sMxxChcpZGQ
EBXcwGIvtoJtp7/Lu4rZ7mzw+i7DyfvpeJubgYTotRjs2h+bHpcrPecpIuzcSPCYnpi4dAj4
DB+sS6rWPL5aChEz3gZM2fuX1L7A5h7EYD36Iu0FopMgbP6EcyMsaWU2uVaHrLR9T78jFu0R
/0kDgdN1JARRotx6wNGci74b49XIRn2Monxff7h6z8OdnDuY5+0Kf1++Ym7IlUpLd184+SzG
/fd31X+fyHMTJc/QyzQ5Rr/H91EItDDHgANZ0jVJrQ9VeLzIBaYOUlClvT0HAw9mt2/fXIAr
4TZg9dik9PyjiVdTsDymYPfleGQUtPfo0vfdabqu6eNpDLdko8/OdNS3FuH6RFswvVcjsUp5
n/rMPejLtsKY3wXIJsYFz+ErMda7H3amfcadGQ5gkjGUUqsSMp0eicFcM7A4DLC8liOuVMXT
o+IR1vqwwHHtCUe2Ofy3p7aLFqLWhNL7q9GdZQKb0VHIkYcOa3nO+ozdCAkn47BJ+7PXvLmM
X0/+jFDvEOyL+hnnX1YqwV3pKzx6LWwXtq55vSLEy/np6G5jDlMTBniew7H+r8/0WikfTzaD
piOsJx8WzsOxM+GrzPBC5JIbg4hRPrBmMcBxGoH9GVLi52vCTgx3tgC/5zjMGGyjIJBpBepN
NJYNcQWXxYFTwApcknuGtN1HFW2I7B7toO9n1SNM/X7y/gXMxZR+djDnemHSce1RRdrHzxN8
yTqFSS48dF/6B+0NoflaE1j3n4gR3XjgdZuE3VGbMdqNC0vvqfgtp14N2FkPmIKxfmSdV+2T
TGbrR/vSMmPb9kT49liF94Wibb/xGOZl2UbeHcvBuh/pm48V3OY9RCXVpqUMiXvD4WvNgqkZ
B7beo7BbDUx1FG2kvvdKxKWIneUEC5mHa9OncxhpZYURZz7ShrYXm3qAQ/auZ5Xkumn24AzY
j6zqjzgdYgnr8BgUtUqjAt+dDoM9byD2vihGxqFA8G1HI+ptA73XP1/fHRyPZXhEjA3ir7GY
5chB373S1Aba+qxtLrUzCH2DLkMZMlcFzSMAPA95eeSTdR3zgrQbpzoq3zpvdfXD8OsMv87Q
6jryaq/OPIOF/WzBIEYrpuNoHMlp0LkG5F2eCR8LE9qQz3PxRjffoVgb/1UxF1tLYjHPlQFu
t0HwItfxR5zAe5HS2z374ECYM1wxYddlxBM9oqpZPRVLxeMN6E1FS41cjah4gSIytKngFtYM
JP2kDOYMK/gtvSuNChXl4JcAC7C9J2FReA9YsSzRd2sqvjzfhJ4sK4w894k2GFMYdWGPYERe
2YsAizbrH8EFZa9TUdAo//cfGERk/TH3DERPKyInUy68Jp9A6kP1/mj2vi/B/Yi+4JoYw5Ss
+5uJ0aRVH51c3AhBzGqMm3cYD/KVKSoUenSvH3D7S7NGguDZrgDwWG6YfeWTii6jeV+TtinG
9XBrZQREQXsCS16qEhbA2UTLPtSOhHiKlR4E3864gAvTCbb1WCl1PmssQOrrMjTL/1W8M2II
PTQEXGMOei6LRmoBIdQrpPuePLKknRG+/gNiIkLgziHvxcQCXqFrsHPlcLiyjYkB1RFDVl1V
pKuhx3LpHSz2MIOJTSgOX49EiDXBIlsT1R0aKV3lwz1cir6BF6qRLh3gua68RjruPuDkcB4Y
lo6wZNpg3MXPahiV6md5/CJCUnDhPysMHkweRp5VH4vUb308MwI8IzN4TonAGEdCRNhNRMyX
ljaGoQo8WOJOsMlSPBTE0ePFdWEcCqurUV1dgzpCxigwqQoG6ixu0e97zZE4XU9CKK8TvTuG
oe2woAksnFzJe3LErIsXMaWzeLKrrqlLw/ZeLBix+2BXmnpkjrixElUisew+PPTZlaFIhSXK
PYohqvcRl+PB6t7oPvsC3tU1IC9mMfy6z8fNohbyG+nY0Zsl60cTiu6sx+hhQXBns9F3T6bU
wfW/TEJ0hDkV2RDM2OBYWsO17xTsjS+W2trkvzXnGDYHWMIu/BIEhPSSOufpwIHfWteQjSPj
vMBnm8KUZQ3fsVSWk+aOcafOdsTwe3sp/O0twDCzgHPAAuzesxhDnDlg8bwwekss8kUq2F0j
RlXBoUwOHActQXRWjUwOeta1xa866rpy3lI2zcr0s1ge7A1bSwtwzIxh5jobfxY2q+M6cy8M
H+QCrsNw7E9T9l8n/vzH9c0oid+KEIJRLZxDsDW+RDruOminXH/r8bXgMwrL26atEqPu/R/Y
NLYHbNlmYPK9MSBwFDbcL5ViY12Y9XvU6YVTtdlN6pF5YDAsjK0xlt7LmvE5ejSsLALwS06j
BhKiMQv7Bzhg2G8C7QoWxWgUpuIXMijCz2cg8+JEeAceREqhjLlqfIujIVYw49jAyqY35u+/
jleyUCZqIubH/ojxg/wRMPUnXLmwHgt2n8WhpWMQFBiEMcuikFIhSzEkrsXro2PgYGEHD1s2
LPpsxIPsG5hIhThtfqHR+0VKopjCaf4jYuBW1ou/3ibtlF4z9SWFEJbL0jGVC1FYWv/9SAiy
0O8cNh7Rn2WTpjIeM+1N4bZU9rKXuhGSZRbiK/UjISTNxYiL6AVL+3E4/V6kxqrNdWPRHodW
Q3bhuYoHRW3abgzusQCxOXfaLwQNAvwdE4cXOdl4cmwinM14tJGFVviF8Zhhx4CNXz/4OtrC
udd47LxbqJZ3VCJ6j6hgS5pkeFmrXDjKn/yIgTyyqJqRj+UAbJEZ6inj9zayuXKDovC28h2d
TsbIfqY0XUtbz922f4sK8eD4Okzu7wI772DM3hKFv1LyUNMiUWEWOWqeZG3zQkpaapCX8hei
Ns9GsLcdXAdMRsTxBwpPLXr8DrOG7bC9SJSnuxKXIW6hG5gOYdh3ZA1CvBzhEzwO/XqFYmmg
DbiBx/FO3r7pI86O4MHUfSniUqMQxGWg25pn7UgfatM0JwuMsYk1Rh7LkW34lLxNZARNB8qY
zGBuYjdDLdUNvRnTz+2E8b8X6PieGocmcFn0mPxWNZ6u9IWliqzat6PG1reQEDIPLZuxOCsQ
6e/ZLa+bdRir+7ojeF4w3PuuxuFZGhbOuSewY6gbQg9GYYLa71PyNFWTp6TiDqYQIs7zh2c0
+6zahyoqCmCIhTS9UX1n2lNyYsGcZQpjcz+si/+qZOrJRpN7cTH68s1kKZ+sMGjrE7X8n/+E
hJCPN3afXXgp+BOT7ZhkvD1tc5+HWOjCgNuiq4ie7IWgIw9wLtQDo6KuY31PFmwn30SJqldG
cx6iR1Fh4yyiDLZJs0eUouJb8+FmZkTIizV4VNHeU0v0+SpmupjBzGUmrn4W6UGIUWvkBMUa
qdXISn3nG44/SpS/2VwSj01DemHm+WwI6+pQJ//UizQbNylDRUYCkrI+oeDDExwI4oHpu17q
dSh7l+Z9tiCOjtIyp4HwGyrFgugtjhBCnOm1ABdeElI+MxnpJU3SdFL9yXX+W3E/4x62+Jsr
DdyNOfiZUn7HHMOz7EfYR/7PCzmBDyLZ2vZOJQJG7vnR8Jq+H5uKFEu7i0292e0if1jdV+FG
RhIdsWLqvpyOutF/PprAdsgsjHIjBqCVN5UKrJa5S/UjNv4AATYq/+eqeGTq6pNMZizfFYjJ
FODVhTkENFtjTHSebH/RIW+ZHDTKVdaO6Tkfl9IEyCuokSo8VY8wz4mQkkP3Ij77Hd4kPUDS
F5FSb9Ekb53KlxjCh0vhwfXHTxmVtPevle0EXCtskdbFL4ALdyAOJD/Cuu6WsHQMI2PjBqbZ
WyIw6r3SCUCUh8tTnWHp2gtuPEdMjBYo6hqy9mMA1xmzY0tQGjcXzpaUciZS8x4pSDuNKS4W
6LbsNopkxj4qsnGYZZvQ47YGoeonWOJqCqtR55RhwuIaZF1YgaEeTugeGoHo1GI01Bfg/pFf
kFolaedNrcm7+psijDo5b3X1w/DrDL/O0Op04TRJYzYODuTA3D0AffrMxZWnKXhd1izVh2lM
INPjVPVg2fqqKeyectaJCPSFhz0XZnRbLuzcfdAjMELh7EORCWsHWdP1VHoTc6+pOPFGZqCg
9nOyllsF7sCpHaNgz7RF2Fnpmld6awKsOf2x69EnlJR8xOvMQtSLpc5Jc4mx1MycA/7A7biX
8wE5H4RoKovFJBszdFubLN1vRAKcH+8IK09/OLNU9itxNTLPLsCQsO24dHQBAif8iuwGKQmc
c3go+CwWWGofDnxWPdOeEofujymcx2/FJFcTmFh4YuSGv/D5i3p/tBNDLagtK0FFQ2sbz0e5
Lq2iWyt0bqKTO5iCpfpdawOEldUoST1ISBcWeu9IV3c8E9ch57cJcGTyEbz/BarEmvZzzcad
ssc/Yoi1aTsSgurHbBelfMQiIYoL85F1Yw16W1jAb80dFDdL6BTBvy4ci4B+AZi4kciG1mvq
8fbcbPhyyX253THnfK7UUEEMbb9OCMSCo5ewPWwoFpzNpA2JNH4MtICR1Vhc+6IttayKZzQV
hXN6JKyY7ph9MQOfMq9goRcTRmRM7U4qRVnqXgyw4NM6RrOKY9jH82GwNZFGVtuGKh1jlPvR
A2wL4BMSTN3ppiM816XXUGTi8w3owTSChU8IIQmJzuW/i3beU02zdGuGI0zYfbH70V+Y62wC
bnAUrVOqE2gcOg3Tkvgc3JhiB2MjK4w6r05WtJbcwgxHNnwjnqNaa6qkjjBpZzCn7u+pdLZs
GWZ3lmdV6CpjpupaKHcy04IF3abuwhxvNtwnrkOITWfxZBddQ+lyDsYwspmMv8vFWvQq6j5W
CCUyVODN8juYrHIfKWmXi+iZPvAcNATeXuMRlSkz0tK/QfXjIT482o5xM44h/VMs6YcZvFYn
tcPH/y0SQhfmlGMa55kxeJ0Tj58GcdvgOfJbMw9gWU8mzOyHYdOfAul+owsH0nVP8JyqEyTi
ULBVmzot7UQlSE1IRk5ePnLv70B/QsL3k0XBUe0qspLxKvczCt4nIDJQpV1TKdKT0vA+Px9v
47ahn1o7YuwXpCCV+r1PKTgRbg8TZjcsjcnAm9gN6MWxw6QYqXO1AqN6zMaZ5A/Ie/caOeXN
Shw69hiSch4jcqgluEOP4K1Iol+dJvxK19mh94ZYZBG57yJyl9d1KQlRn4k9fdlg+SzF5ZQs
vLqxHr3NLTDkyFsVsp2MH3ZvRJzfh0CCibpvTJXpCh3gz39aX5+B3VQqO8teGN+XD/O+e5BZ
r0e7DuyUdPtAWfvUBBwYYQNTY2vFnvafJiE6xKk6cDy9/ggTsMaHCc7gn5FT+xnRo4l9Nfx3
FMiwrFGnASUtQDbMjE3AYHPAZpi0U3BbawVIOLsWgxzs4MQzg8XgA8hq49FAHbhzbOUenN3Y
F2x+GK68vIowvsrkq07EUjczOMy8g4Lc85jqzAbfpwfsyAvfklKtObeXjIRwnp+gk4TQ/lza
FURNG8BsF6lCyx9ysN3zafPyldQ+x1pvWSSEWIj7M+3B6LZWr0gISVMR4tb3Bc+KGPUfflXz
qKaUv9L893hxbRV6kPcyUM6ENxfg6mRfjIx6i/qyu5hKp8d5rDGyQSxT+L1WyTagmmf4wdMM
vKADePw6AfvJwtk2vLb21Xb0ZlsiSNXoQgDOvgEW4A2NxMPMR3Q7Tj/ZBKXyqN1aBX9LU5gw
2LC0IsZ4QmC8qtPDi7kmGRv8uWA7BmPlL9fxTFCp7iVCM4syLzLVT8FXeuNRNURWCp7h+i8r
EUyUMK7/BiTL8+SKviDxz+t49FEl9xuRw0oiB9sRGzCTvDtL8lz3/t6O/l6h2DjRFaaOcxQh
0FLPdBM4zIjF1zqpgdJMxTNdbdPMfSyVqUokhNRD4lKHXieKSAh5W5X7vqGfuwAltS3av699
iS1kY+ZRuS+bxWgsy0HMTOd23saKdpkXMJb/LSSECaz9Q9GPjCsL//W4X9LcORJi2T0k7iFr
hBHlnZGIexoXzgTkXJ8KD2Lkc2Jr8FwZ87uax0kQ1xwD9qt6vyhJBFNeP6yJ/SKLWkrFxu5M
8MdeRWGrentFKjSFnK7hxeOfMcaeCYcpVxULrGJuiSrwPvEclvUwh4nzfEWaL53GeVnUkDMh
VSlPb3odI3L0XvtcJeehzMOK7YdFm0Nhz9LghdWcjwujeDDvNhpBnn6ISClF5p4BcB8UDj+u
BQJ+faucu5QXY8I6+LLZsHWyBNN+Ii62iVTT9d7E9TmIGm0DE1Z3rJYx9x0+Jx0tFqyIFtOX
hKC80V9uoXLjao/Ma0+iV+LViYUI7OYAPpfsX2bGbYzbcmKuTVQMIY9nEdLOeYH63kLtG7Mc
lJFdNDEovx/dxhjGDOlewjIlv6VKOGvxZqfup9qHtnNS+lsyAlvL+SEdkoLWoYTEbuyA8JL9
lvAe2Tfk/5ddt1zDdW37JJOZy0KpzNrtLzrlrUOu8nYLH6u/i1YhUo/OxWAPPp0K0qbnFBxO
EWr1ztFkrHmyxFUtFaKkOgkRvpbovfEK9gdZwWmWMq0BBZjGWfMxbNMqBAYsxZZQf4zfOhNe
3F7Y1sZ7rTZ1M33OCcM3As+r2xgnRvJhN/44zs5xBT/klIIwoOcTZegZaQ/7kb8qDjikwaOj
MUysgnAgs057agwy1p//2A8WxkZkzZkjM3Q9xoblh3EvPQMJ5yMQ4sQi+7ANhmy+JzUs/QdI
CH3mreEbow2/zvDrtJAQbSPWZcYkl4nbMUu1PaUPv6H0Npkep6IH512eAW/qLCJjFmzcfDB0
7X1FiL2+WIjy3C/NScS1PRPgyjBTGtBkehOnPyETnvyMQK40XSZljG4uisPWUZ6wNDWivdYD
N8bRB43KiRQ69c5oQpo2tqCxthGVKVvgx7LE8NMCRSTEIg82mCymulMM0ZXm+43A0ae3Ma/3
GJzIqVd4QzZVFiFfFQ+002XbYzl5fzhewejj3RtB/sHYGF8CYZv+dC7dgQyfZKq8ExV8ooZf
5N/VpiCiBwdMCmeb98Dy2GKVVBQES91cBh+iq/kuv63jvETtmFJcdg+LqTRMqiREGw9N2rMz
+zdMdLKA1/xr+KTjjAvF2GExwGCpGFaotDA5JzCm9zzcfnoUI/zm05iJ2v/OhFgSQ84InMtT
925l9YzAnWwqE8NHFFTIHNGoPXox2aOtJ+LWVzH5uwJx02zJuCH2CKacYLJAj3XP1c/io/dx
Bv075/Oa20UfnCKGEbbXQsR8VPdK7QjPdeU1EioyfgoxMhJSz2H4Ugy1ps5zcMG82FKFQw19
5putMd02SViA38fwYUR5lb4VqdgcfoI/m+z5TnNwt4yMkWvhsCHzymLoMaWzHMHABZfDYE10
A1OWucLJzG1RPEpoh4B6NLaIFRjKcvhZtUjltlhWL8yp83vSD5fZiiiwgpJaDV6//8CYqboW
zvmb1uEUkRAEC6p7/ccSO4svLPgu4DM6iSe76hpFJIQ/fkpvEwkhqkK1SiSE/08qkRAqz6Q4
9FsiQt61OXAja7TjhLPIlUem1yZjXTcGIa+HIHDifiQLW2X94CgwYUcYtGvqKbJlEmLLxGjJ
v4BRPOV+0SlHvabPuBRGiHFZOmTVyO+SgnjsHWELlvcaaepDXTiQqouajwBPW/B4luAw2tRp
a9fyFQm7w9HblbSzkDltynESqXuydyL83e1g1bZdUz6uLx8MD0IocTlt2omrkHZyMYJ8HcG3
lLUzkhHV9LUqhJFWjCrDoaYMet9kUI7Bjqq4toM6DfhVXmfK4uiFbf8JeTjbQflMmjEkhRum
4O6He+rYtCP82SX11G8PR8QEgnsdZqnZCrS268BOKdfnnKZG4diqadh4+hjGWLd9Zs2Y9XvU
dYRTdeF4xV5zbSoczXsi4upRjLJ1x6L75Yp91kifXKNtFSlBzDR499+GBxmx+KGXH1bczlEK
sP49/rp0GykvYjA/IAzLhtnB1HUxnlSpG4Hzr29GZGIBXmzrBRbZRPfS4bUs9NqWJvV4oNPF
MMHstggXX75D8pFRsCHEh/3ka+0MtEpAL03HZBlyGh91pGP6JgWxTf4u1YGUX1Qp9aps67mv
Id857VW/wJU+E+KvlD+xrJs53Bbeo89EkKaXysDVGcQYzB+D82kqabDoCIi+4Jp7Y150OgqK
lb/TXJKKuw/S8KEgH1m3KKaQyHG7TI6Erfup3cFTLEUIn+jTLRw9HYcMgQCpp6cRMGGFkfJI
CHEp/p7rCpuQX5H87jl+GUYY4e4baPZWHs75cJkHMVROxnWVUE/52R+8YT8jSdbOzH2ZdGNo
KkdORg4E7zLw9O/TWNXPCQGRsrAePXKYU54/ha9u48SWWRjqYQ3HPmFYfvBv2qNXFUyofYhy
Q0cLiPLx98HlCOvtAGuPQMzecgKxrwpRp0pQyPogVPVgkpFbjmM2YIKrKWzGxyDvw3mM9ByE
6f35Su9dea7ctoYVM5Uc/WpnQkhlY+q2RCobYpxJ290fHHNfLLmQCsHHN7h/8Wq7MyFy814j
7uAEuDAY8P7hkR5nQmgy/Nbj9YEhsGR5YtaJJ8j9/BqXpzhqWZT+6cHUCRA8/hEDLc3AD9qL
58JWtcXLftwx3EtMRGJiEtI/17Z79yXU/LXpj8g3JVrZ26qqp1KQoQpMiTzTibHdgtMTK35/
CcGHZJyd6wUWbxiOvm1sp0hn5RdB2ChWzye7rTfMOb2wOiZN2d5iECJfa8pJSYzpO/uArZJ3
UlKThqM7j+F2ai4+CxJxMJinlq5Jd45gAU6P4IHpNg1H7z7B7f1j4cCgPB++qK1j0lyzRFkw
MaZTK7XLIU3edcauPmBRBgXbybhZ0orKR4vgaiIdm6ue1SgVXPpgf3NwA/bjRfZlTHZkwWXW
Hyhs1iedQCWSdxF5E8NG9x9u4u2XNvkddZAXtS9/VJyb05lICDrn/PC+mHNRvwMQqbk8n/Ie
G7gF1+5eREQ/i3Ye9hSjf4/yvm8TCUFFyUgjIT7iU1YqMtQiIX7E/Yz72NomEuKXAB5sQ7Yj
5lEiHt+9hhNHfqfz6Wp9RrX7Sftg1GlPBt3z0WXSbqwbwge31xrcKWrqWGnU9v+OvDJkMqM8
Oq5nCpB2YQ7cmXyEaoiEaCdvXXLVNv4a84mME/FaUABBwk8YwGGg27pk9UgBotDaT1SewSFP
l2Y16gyyPj1QizyRE2TpZE5bcO3AZXtg2SMVUkP0DseGWoLF5cKLOvfmeDBsLIgiT9bzBFVj
XX02jg63Ab9nMPysrRF0KEPl4PpWFP81HY4sLvgcW4y5oEy/QOc/X+4DC+fJ+O1VgXIeEd2j
8GkknSNcNSq0fSQE5chhCl7wQTz+UCIzdLVApJJHmwK0ZcIGZTrB/1AkREfz1vCN0YZfZ/h1
WkiItmuwKBfHArkwdxuM3n3m4erzF8iiPCDbRn+p5VpuwqfocbA1MYff6hvILa/El7S7BMjX
d4yFSNuCuCicvEl01JJyFD6LxCALVW/1VlS/uYrNYT7gmpjAevhBvJQd/FlfkIaMj0LU1+Xh
z7luYDjNw6NKafq9knur0YMt05lN2XAKWoDJ3Tmw6LMJTypkOqO4gTaQS4G7qqG8BRUpRzBt
xBrciqf+Xa/1LAJJ9XNsHjkQ4yPTpYYwTVhOtT+E7N2wsh8xRlnDjY7KV/bnm3Muq35KdZ8H
JW6qRklhEcrrW9RS7wqf7UIAzwQW/hG4mfFBY9pky6EH8PTtMxwKJIZ+q1Bc+qjlHBEd6ZhE
n65hnicbVgHbcC+3AAVF5WgUd4Cj2xpWapKwfuR0HIm/hTUjpuFISoXifJG8ixPhQIxgTmN2
4MrjdOS8PI8xfFUSQoCPhfL3IkLusUBwmd2wIjYf1YX3sLY7MdZyh+BwBsEO4iaU575CrrBN
6iFdkT80vqNSjh3Fs5wMxF8jGKtOTzzXRddI7RQHMJDTnpi3DI6iU6FJz7wcBat25D3lFPVG
5jldg+QN3TUT/Ob9sE+OS6i0T8N4sAo5gmSBcq63PxNChkkZLpiw/yYSk+Jx8eeTSK/9l58J
8e4Jjk9z03A+oPQ+RS+2wo9p1Hk82WXXNCDnSAisjI3B7b0IJ+IzICD2nfepsYi+Ij8TQnof
nmMYDsYTG9y7RESRZ2Kq3UeEgls/oI9nGH4h+PrkFG90n38FggZCYoiFSFhJnffjhEmnUhT9
YNuOxRlZ1oKOMOg/rhcJ8NtwHowYrph2/A5uHwiFPdMF8+PK1NepDlJ50ZklWKYwYbtjUtRr
9RS1C//Cy7dv8Xj3AHBl53zqxIGyOnpuZD/E3iGW7eo0tqOj54gxntMP639dB3+OOklORfpp
bvcAC/qPx6HbD/E3ITh8VCP8ZGuTRf+NuHL3KrYFWcOE6YU5x2LxJPEx4q6fw9m/P0mJKzlG
9ZiNsykC5H/IRm5FswKHOoRHIYlgo0/ZSbj1eywZAxK96jThV7puiB26LziO2wlP8TThLmIu
3MSH+i4mIcj4OTPKCizPBbiU9h6pZ6bCmWmHidcKVEhKmfOSoK1e1AH+/Kf1KpEQ4VQkhP9u
ZNR33E7dkb19RKY8ksLIzBmTTz1HKt1eJZJCB2b9J3UUVtSOg3XgVB04Xrn/ZuOXQD4sbLjE
7rBVzf5lpK+Hq7pBawD6RCSjQnASId3n4r5qeBRh+Y/O6A9XSwaMCaPPsu+PxdE5CtAtzfGW
iEP77tH54UUFtxAR5Ew2OQ5cgiJwS3G4WStRKo9j3gAncAg7Z27fC6PGD4QtywHjjmfSJ/e3
75v0YGobu/F0ygT5Iiw/mPrPohb9ALMGGbQWXyfKPBdDf8nRauxqN6koQ8qIsTglUPckbvpy
Fz+O8gCXvFCPUdsQ96VJSxiqpkN45R+V3IaCi5jT247IyQRmXBf0n3EAj2Ue55TSXvL+DTIz
M5H59ARGWpnAcXI00kukOUepsOp1Id6wYZuCwfPE8IgYvKtTvs+movvYMcYLlgwWbHpMxN6H
JYrB1/IlBpPsmPBc8UgtsoJSRD9cXYNhnjwwqPx3HsOw5toHqZJUk4JNg+xgbmYGc4c+mLz7
LvIbNS9KreT+YdZWCDmeq5YCSun5WouCFzcRFXlGephyRwxj7WuciYzCrRcFqG3V9Q75CIsp
Uhpmmj7hHFkIGZ4zsW99COwIG23u6AMHlgnMPcJxIKlCqjCRDZVKL8XwmIfLqdnIzs5GZvwe
BJC54LnyicrhvMp3aOE8CEvI/JATIeLGPPy9ayJ625vDjGUNn/BDyKxr48VMABrfrS/C119E
RqW2EGZ5OK2OaANRERIOz0WAG+kzdYi8qz/Grr2E943fSEJU3KVDOTWlOqomc/NL7Cr0NDeD
w7go8r7EGvrMRr+9rzXmotQUJaR+jewwRSP1NmJimLy7Zxr6OVnAzIwDp/4zsP/BF71P9hfX
vccfW8LhZ8+GCdVHVjcsvPJB4VHYPs+oLNR6daL0fde9xpFZg+Bty4GZCQvW3cdh572iNpuR
NqJIjNqcy1gV7AFLMreZfB+EbvoLn9rmFmz+jAuhVnR+Z9/1ye1SDEhTx8yj8/paBPxKh1q2
FFzEaOqQPOvx+KO4VZECL33fIKIc+2M7HW0mguDMWLLmemLJnRI9FMJ4TLfT4d2sayzWpmJz
0BRcla/bepIQ9DokzEbKuyq9DqOiPFIebQuBE5usSz3DMXuIbfszFwZNQ6gvDxynEOxQPRMi
5wrWjfCGFdOU7GvDECk7E4I6uyDEyRwW7oEII8qI6pkQtTm/Y+1waRsmzw39Zx7Dm3odJITi
fhzwfEdjSn+idNpNV0m59g0kxPL2c7a86G+s7mkB3qDteFLW8n1ICBWZ8ZlmYNv0QNjWm/jY
IFYDhTaDZ2JcT6s28laVQyimDrLRSpAqx9Ar7B7dDXYcM5hQ+VMHzMdvstBzhVH/h77gm6mM
SUI0pv86Hh7EiMbzGYFwf76aBwhVGnMOYRAxDjC7r1dEzMkJilc/+hHAb41wsl9UpW6iUynY
TPxTcYgmPaf2D4GV7WiczK3EhzPjYM8bgF0pVco1RpiAlV5mMLabpE7m6zwTQpomwXF2HMrF
mkkI6dlRpmTvedbhwWf6GP+7koToaN4avjHa8OsMv05PEoJeZy9h5RAnsOkzIUJxLKdRJ56Q
6rXFiN89Dl5Ubn3qbACrwdj+slYPvYSQEH8uQz87luwgYQbsAijs1qRwMhN+yEGBsAB/TCT7
q8phyWXxq9DXWtrOhOOO0bsTUdaq9OwveRqF5cN9CB5hwNyuB0JXn0bKV/0PZBQJi1DdLFH8
+8/O8/vn/dGUvkbfqE3dhEYxro/jd6BrkbHAdwTfwh4Dp83AIHtbDDv6Vg2/6kNCFFwOVTd8
f0t/m6tRJBQp/lXHcdXIitmBmUO8Yc0y0XgwNUemt9L7ZXUGfpvjB54pVWcG634zsHxSD3DN
WLCwICSR18x250zqJCEob+Nj0+Fnw4Ip0wqeo/cgrVZPPNdV14jLEb/MAwyLPlgdk4osck32
m2RcWuILNtMXEc+qaKeH44RsZBCD3OXULPo+2Wk3sbYnC+w+O5FOcKJY+AjLPRmwCt6PB5nS
36I+GXe3oT+HhZ6bpalKGrMOYACHjzGX8lVSfLTHj20xKYNtB7+pR2kdVjfm/CffG4E36gJ9
LmLXkxDS+5uyreEZMAeHE4qVDqKq9yEGxl192Gp2Fn3wZFdeQx3gnxS1HMN9bYi9hAELx94I
3/g73lSL9b4PPbbP7MKZV1KyS1ybhYs/EYMzIVFbyx5hx+yliFg0Aj42bJgxefAYuhDHnn1V
SWWmG4N2SX32BawMcifzl9QTjBC+M06RHls/EkLuRPgF5XUt7dtM2425fsQ4b+GOsZHJUqdN
XTjwm+tKEL8xAHYsc7gHhsJHlYQgdfciBpJ9hAefCeuxabSDWrt76wfBhtgDfcdMgZ/KWUeS
1jIk7hkDDy4THOfBWHoyDjf2TUNf+n2zYeMdhKXR76UkhFaMqh2Hfo+6rj0TQoyGTzexdWx3
sjcQDGnnh4k/xaFApG4A10hCdIQ//3F9M4rjNiGIYH9zpyBsiitWngmho12HZ0KI8nBl8QgE
9ydzhiF95vGqZ1HowKzfXleNV4fHwpXDhl2/SZgxwLodDtaNUzXjeDUbVOJ69CBjPPCYuj3X
CN+pdAV4/ZYirqY8ee0RJHtQSW0advnbIeBAplouzc4W4YNF8AuMRHqtGIZf/jOl8skqDBpz
FFn1/+WT7ilC7PF6+LGZcJt0ALEvBfhaU443928hpbTZ8F+UzKB099AEODN0H9r3by6i4if4
eS4xiO59iOImieG/9G8E4ZTXiu2wI8jRcnBkXfouDOSrn0FiMDIixE9hciLeFFej6nMc1vdi
gzP4kFZZab+PGI3vTyPEUhld+P9zPHT8jjs6J+nf/b7FaK3LQVQwX5EmQD+jTiH+XOANFuUp
N0DmgaNCQtQmR6AHdVAnp7fagbP/DRKiK/RHwzdGG36d4ZMQ3wdziUXVKCspR22zuNN6cWON
EMIa9fOXKA/dlPXdwTIxhYkJBz2W3VRPFUTWvGaRCM1iw9eh/ut7K8HH+5ftR1qJ7N/a//47
EesxLug0W7XlKCmvpccR9beo8iv9d5MmB0VxLfLTk5CYkgNhs+GPu86W5ppCvIgah4ELr6PA
8LHP/8YaIW5Cvcjw7Vn/c7aY6hycD++GgA13FWfIGX75N81LEarK6/TGbP9tnNqRrkG1Fbc0
oSb3Iqb1nY6YQvVgACPDf+WGXwy/6LMwNCIvdjvGeHJoj3hTjhtGbL6FTw2Gv4lTpfLhXLhy
XRCwLBrZhk/UGX7ROIdU0h4UV2kEi1KjiBBfPqunWzAYGVH58ncGwsGcGHCYVvAK+QHRb6o7
LQNaMbAzg1WvBbgkaPx3G0r+l0kImRcJ12cWzuU2dHI+NaOmtAD5RbIUKyokhLixAoX5hSir
bencPYkhc4UnU5lfm8kA03NFh4bNdqkQZSkQv1kuOvph+HWGX2dodf++fYw6mLkIRQRMt0gM
3xDy/3VvNfxi+EUfA1Tp33PhzmTCfsRhhbez4RfDL4Zf/j/O1XlwZxn+XDX88p/BqR2SELKo
TIa1PxZflmbEUS2GT0IYfjH80inDD2EpS0vUwv4Mvxh+Mfxi+MXwi+GXf//+1ojyQnnOdenn
c6H2HODyokow0h9ZCsRvLbr6obVOLDH8OsOv+5+sM/xi+MXwi+EXwy+GXwy/GH4x/GL45X+l
/B//S4lkkfSscwAAAABJRU5ErkJggg=='
	) base64Decoded asByteArray readStream! !

!StrikeFont methodsFor: 'emphasis' stamp: 'jmv 8/3/2009 09:20'!
makeStruckOutGlyphs
	"Make a struck-out set of glyphs with same widths"
	| g |
	g _ glyphs deepCopy.
	g fillBlack: (0 @ (self ascent - (self ascent//3)) extent: g width @ 1).
	glyphs _ g.
	self isSynthetic: true.
	fallbackFont ifNotNil: [
		fallbackFont _ fallbackFont emphasized: 16
	].
! !

!StrikeFont class methodsFor: 'dejaVu font data' stamp: 'jmv 8/5/2009 22:32'!
dejaVuSansBold9Data
	"Created using:
	Clipboard default clipboardText:
		((FileStream oldFileNamed: 'AAFonts\DejaVu Sans Bold 9.txt') contentsOfEntireFile substrings 
			collect: [ :each | each asNumber]) asString
	"
	^#(9 11 3 0 3 7 13 23 32 45 56 59 64 69 76 85 89 94 98 104 113 122 131 140 149 158 167 176 185 194 198 202 212 222 231 238 250 261 270 279 289 297 305 315 325 329 335 345 353 365 375 386 395 406 415 424 433 442 453 467 477 487 496 502 508 514 520 530 534 543 552 560 569 578 585 594 603 607 612 620 624 636 645 654 663 672 678 686 693 702 711 722 731 740 748 756 759 766 775 783 791 798 804 814 822 830 838 846 854 862 870 878 886 894 902 910 918 926 934 942 950 958 966 974 982 990 998 1006 1014 1022 1030 1038 1041 1045 1052 1061 1070 1080 1089 1097 1104 1115 1122 1130 1139 1144 1155 1160 1166 1176 1182 1188 1198 1207 1215 1219 1227 1232 1240 1247 1261 1274 1284 1291 1302 1313 1324 1334 1344 1354 1368 1377 1385 1393 1401 1409 1413 1417 1422 1427 1438 1448 1459 1470 1481 1492 1503 1511 1522 1531 1540 1549 1558 1568 1577 1586 1595 1604 1613 1622 1631 1639 1652 1660 1669 1678 1687 1696 1701 1706 1712 1717 1726 1734 1743 1752 1761 1770 1779 1788 1797 1806 1815 1824 1833 1842 1851 1859)! !

!StrikeFont class methodsFor: 'character shapes' stamp: 'jmv 3/26/2009 14:53'!
makeTabVisible
	"
	Make tab characters visible
	StrikeFont makeTabVisible
	"
	self allInstances do: [ :font | font makeTabVisible ]! !

!StrikeFont methodsFor: 'character shapes' stamp: 'jmv 8/6/2009 14:23'!
useUnderscoreIfOver1bpp

	glyphs depth = 1 ifTrue: [
		characterToGlyphMap ifNotNil: [	
			characterToGlyphMap at: 96 put: 95.
			characterToGlyphMap at: 95 put: 94 ].
		^self ].
	
	self characterToGlyphMap.
	characterToGlyphMap at: 96 put: 129.
	characterToGlyphMap at: 95 put: 128! !

!StrikeFont class methodsFor: 'dejaVu font data' stamp: 'jmv 8/5/2009 22:32'!
dejaVuSansBoldOblique12Data
	"Created using:
	Clipboard default clipboardText:
		((FileStream oldFileNamed: 'AAFonts\DejaVu Sans Bold Oblique 12.txt') contentsOfEntireFile substrings 
			collect: [ :each | each asNumber]) asString
	"
	^#(12 15 4 0 5 12 18 31 41 57 71 74 82 89 97 108 114 120 125 134 145 156 168 180 192 204 215 226 238 249 255 262 273 284 295 303 318 331 344 356 370 382 394 407 421 428 438 452 462 479 493 507 520 534 546 558 570 583 597 615 630 643 656 665 670 679 687 700 705 716 727 737 749 760 769 780 791 797 806 818 824 840 851 862 874 885 894 904 913 924 935 950 962 974 985 995 999 1009 1020 1030 1041 1051 1059 1072 1082 1092 1102 1112 1122 1132 1142 1152 1162 1172 1182 1192 1202 1212 1222 1232 1242 1252 1262 1272 1282 1292 1302 1312 1322 1332 1342 1352 1357 1364 1374 1386 1399 1412 1424 1433 1443 1456 1465 1475 1487 1493 1506 1512 1519 1530 1537 1544 1557 1569 1579 1584 1595 1602 1611 1621 1640 1657 1670 1678 1691 1704 1717 1730 1743 1756 1776 1788 1800 1812 1824 1836 1843 1851 1859 1867 1881 1895 1909 1923 1937 1951 1965 1976 1993 2006 2019 2032 2045 2058 2071 2082 2093 2104 2115 2126 2137 2148 2166 2176 2187 2198 2209 2220 2225 2233 2240 2247 2258 2269 2280 2291 2302 2313 2324 2335 2347 2358 2369 2380 2391 2403 2415 2427)! !

!BitBlt methodsFor: 'copying' stamp: 'jmv 8/5/2009 22:09'!
basicDisplayString: aString from: startIndex to: stopIndex at: aPoint strikeFont: font kern: kernDelta

	destY := aPoint y.
	destX := aPoint x.

	"the following are not really needed, but theBitBlt primitive will fail if not set"
	sourceX ifNil: [sourceX := 100].
	width ifNil: [width := 100].

	self primDisplayString: aString from: startIndex to: stopIndex
			map: font characterToGlyphMap xTable: font xTable
			kern: kernDelta.
	^ destX@destY.
! !

!StrikeFont class methodsFor: 'dejaVu font data' stamp: 'jmv 8/5/2009 22:31'!
dejaVuSansBold12Form
	"Created using:
	Clipboard default clipboardText:
	 	((ByteArray streamContents:[:s|
			PNGReadWriter
				putForm: (Form fromFileNamed: 'AAFonts\DejaVu Sans Bold 12.bmp')
				onStream: s]) asString base64Encoded)
	"
	^Form fromBinaryStream: (
'iVBORw0KGgoAAAANSUhEUgAACPsAAAATCAYAAADsppoMAABsrElEQVR4XuVdB0xTbRc2ado0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'
	) base64Decoded asByteArray readStream! !

!StrikeFont class methodsFor: 'font creation' stamp: 'jmv 8/4/2009 09:55'!
createDejaVu: pointSize
	"Warning: Uses the methods in 'dejaVu font data' category, that will be removed soon (or are already removed) to save space."
	
	| base bold oblique boldOblique point |
	point := pointSize asString.
	base := (StrikeFont new
		buildFromForm: (self perform: ('dejaVuSansBook', point, 'Form') asSymbol)
		data: (self perform: ('dejaVuSansBook', point, 'Data') asSymbol)
		name: 'Bitmap DejaVu Sans ', point)
			pointSize: pointSize.
	bold := (StrikeFont new
		buildFromForm:  (self perform: ('dejaVuSansBold', point, 'Form') asSymbol)
		data: (self perform: ('dejaVuSansBold', point, 'Data') asSymbol)
		name: 'Bitmap DejaVu Sans ', point, 'B')
			emphasis: 1;
			pointSize: pointSize.
	oblique := (StrikeFont new
		buildFromForm: (self perform: ('dejaVuSansOblique', point, 'Form') asSymbol)
		data: (self perform: ('dejaVuSansOblique', point, 'Data') asSymbol)
		name: 'Bitmap DejaVu Sans ', point, 'I')
			emphasis: 2;
			pointSize: pointSize.
	boldOblique := (StrikeFont new
		buildFromForm: (self perform: ('dejaVuSansBoldOblique', point, 'Form') asSymbol)
		data: (self perform: ('dejaVuSansBoldOblique', point, 'Data') asSymbol)
		name: 'Bitmap DejaVu Sans ', point, 'BI')
			emphasis: 3;
			pointSize: pointSize.
		
	base derivativeFont: bold at: 1.
	base derivativeFont: oblique at: 2.
	base derivativeFont: boldOblique at: 3.
	
	^base! !

!StrikeFont class methodsFor: 'removing' stamp: 'jmv 3/31/2009 08:20'!
limitTo16Bits
	"Limit glyph depth to 16 bits (it is usually 16 or 32).
	
	StrikeFont limitTo16Bits
	"
	StrikeFont allInstances do: [ :f | f
		setGlyphsDepthAtMost: 16 ].! !

!StrikeFont class methodsFor: 'dejaVu font data' stamp: 'jmv 8/5/2009 22:36'!
dejaVuSansOblique9Data
	"Created using:
	Clipboard default clipboardText:
		((FileStream oldFileNamed: 'AAFonts\DejaVu Sans Oblique 9.txt') contentsOfEntireFile substrings 
			collect: [ :each | each asNumber]) asString
	"
	^#(9 11 3 0 3 7 12 22 29 40 49 52 57 62 68 77 81 85 88 95 103 111 119 127 135 143 151 159 168 176 179 184 193 202 211 217 229 238 247 257 267 276 284 293 303 308 315 325 332 343 353 364 373 383 392 401 410 419 428 441 451 459 469 474 478 484 490 500 503 510 518 525 533 540 546 555 563 568 574 582 587 599 607 614 623 631 638 645 650 657 665 675 683 692 700 707 709 716 725 732 740 748 754 764 771 778 785 792 799 806 813 820 827 834 841 848 855 862 869 876 883 890 897 904 911 918 925 932 939 946 953 960 963 967 974 983 992 1000 1008 1015 1022 1032 1038 1045 1055 1059 1069 1074 1079 1088 1094 1100 1110 1119 1126 1128 1136 1141 1147 1154 1167 1180 1188 1195 1204 1213 1222 1231 1240 1249 1262 1272 1281 1290 1299 1308 1313 1318 1324 1330 1340 1350 1361 1372 1383 1394 1405 1413 1424 1433 1442 1451 1460 1468 1477 1485 1492 1499 1506 1513 1520 1527 1539 1546 1553 1560 1567 1574 1578 1584 1590 1596 1603 1612 1619 1626 1633 1641 1648 1657 1666 1673 1680 1687 1694 1703 1712 1721)! !

!StrikeFont class methodsFor: 'character shapes' stamp: 'jmv 3/26/2009 14:53'!
makeTabInvisible
	"
	Make tab characters invisible
	StrikeFont makeTabInvisible
	"
	self allInstances do: [ :font | font makeTabInvisible ]! !

!StrikeFont class methodsFor: 'dejaVu font data' stamp: 'jmv 8/5/2009 22:35'!
dejaVuSansOblique12Data
	"Created using:
	Clipboard default clipboardText:
		((FileStream oldFileNamed: 'AAFonts\DejaVu Sans Oblique 12.txt') contentsOfEntireFile substrings 
			collect: [ :each | each asNumber]) asString
	"
	^#(12 15 4 0 4 10 15 28 37 51 63 65 72 79 87 98 103 109 112 121 131 141 152 163 173 184 194 204 214 224 229 235 246 257 268 276 292 304 314 326 338 348 358 370 382 387 396 408 416 430 442 454 464 476 486 497 508 520 532 548 560 571 584 591 596 604 612 625 629 638 648 657 668 678 686 696 706 711 719 729 734 749 759 769 780 790 798 807 814 824 834 847 858 869 879 888 891 900 911 921 932 942 950 963 973 983 993 1003 1013 1023 1033 1043 1053 1063 1073 1083 1093 1103 1113 1123 1133 1143 1153 1163 1173 1183 1193 1203 1213 1223 1233 1243 1247 1253 1262 1274 1285 1296 1307 1316 1325 1338 1346 1355 1366 1372 1385 1391 1397 1408 1415 1422 1435 1446 1456 1459 1469 1475 1483 1492 1510 1526 1537 1544 1556 1568 1580 1592 1604 1616 1633 1645 1655 1665 1675 1685 1690 1696 1702 1709 1722 1734 1746 1758 1770 1782 1794 1805 1819 1831 1843 1855 1867 1878 1888 1898 1907 1916 1925 1934 1943 1952 1968 1977 1987 1997 2007 2017 2021 2027 2033 2039 2049 2059 2069 2079 2089 2099 2109 2120 2131 2141 2151 2161 2171 2182 2193 2204)! !

!Color class methodsFor: 'colormaps' stamp: 'jmv 8/2/2009 21:32'!
computeRGBColorConvertingMap: targetColor to: destDepth keepSubPixelAA: keepSubPix
	"Builds a colormap intended to convert from subpixelAA black values to targetColor values.
	keepSubPix
		ifTrue: [ Answer colors that also include subpixelAA ]
		ifFalse: [ 
			Take fullpixel luminance level. Apply it to targetColor.
			I.e. answer colors with NO subpixelAA ]"

	| mask map c bitsPerColor r g b f v |

	destDepth > 8
		ifTrue: [bitsPerColor _ 5]  "retain maximum color resolution"
		ifFalse: [bitsPerColor _ 4].
	"Usually a bit less is enough, but make it configurable"
	bitsPerColor _ bitsPerColor min: Preferences aaFontsColormapDepth.
	mask _ (1 bitShift: bitsPerColor) - 1.
	map _ Bitmap new: (1 bitShift: (3 * bitsPerColor)).
	0 to: map size - 1 do: [:i |
		r _ (i bitShift: 0 - (2 * bitsPerColor)) bitAnd: mask.
		g _ (i bitShift: 0 - bitsPerColor) bitAnd: mask.
		b _ (i bitShift: 0) bitAnd: mask.
		f _ 1.0 - (r + g + b / 3.0 / mask).
		c _ targetColor notNil
			ifTrue: [
				(keepSubPix and: [destDepth > 8]) ifTrue: [
						Color
							r: 1.0 - (r/mask) * targetColor red
							g: 1.0 - (g/mask) * targetColor green
							b: 1.0 - (b/mask) * targetColor blue ]
				ifFalse: [
					destDepth = 32
						ifTrue: [ targetColor * f alpha: f ]
						ifFalse: [ targetColor alphaMixed: f*1.5 with: Color white ]]]
			ifFalse: [ Color r: r g: g b: b range: mask].
		v _ destDepth = 32
			ifTrue: [ c pixelValueForDepth: destDepth]
			ifFalse: [
				f < 0.1
					ifTrue: [ 0 ]
					ifFalse: [ c pixelValueForDepth: destDepth ]].
		map at: i + 1 put: v ].
	^ map! !

!StrikeFont methodsFor: 'character shapes' stamp: 'jmv 3/27/2009 09:19'!
makeLfVisible
	| glyph |
	self characterToGlyphMap.
	glyph _ self characterFormAt: (Character value: 163).
	glyph border: glyph boundingBox width: 1 fillColor: Color blue.
"	glyph _ glyph reverse."
	self characterFormAt: (Character value: 132) put: glyph.
	characterToGlyphMap at: 11 put: 132! !

!StrikeFont class methodsFor: 'font creation' stamp: 'jmv 8/6/2009 14:24'!
installDejaVu
	"Warning: Uses the methods in 'dejaVu font data' category, that will be removed soon (or are already removed) to save space."
"
StrikeFont installDejaVu
"

	TextConstants at: 'Bitmap DejaVu Sans' put: (TextStyle fontArray: 
		(Array
			with: (self createDejaVu: 7)
			with: (self createDejaVu: 9)
			with: (self createDejaVu: 12))).
	Preferences restoreDefaultFonts.
	StrikeFont limitTo16Bits.
	StrikeFont useUnderscoreIfOver1bpp! !

!StrikeFont class methodsFor: 'dejaVu font data' stamp: 'jmv 8/5/2009 22:33'!
dejaVuSansBoldOblique9Form
	"Created using:
	Clipboard default clipboardText:
	 	((ByteArray streamContents:[:s|
			PNGReadWriter
				putForm: (Form fromFileNamed: 'AAFonts\DejaVu Sans Bold Oblique 9.bmp')
				onStream: s]) asString base64Encoded)
	"
	^Form fromBinaryStream: (
'iVBORw0KGgoAAAANSUhEUgAAB4IAAAAOCAYAAADKStHdAABeM0lEQVR4XuVdZ0xVSxclIRBC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'
	) base64Decoded asByteArray readStream! !

!StrikeFont class methodsFor: 'dejaVu font data' stamp: 'jmv 8/5/2009 22:32'!
dejaVuSansBold9Form
	"Created using:
	Clipboard default clipboardText:
	 	((ByteArray streamContents:[:s|
			PNGReadWriter
				putForm: (Form fromFileNamed: 'AAFonts\DejaVu Sans Bold 9.bmp')
				onStream: s]) asString base64Encoded)
	"
	^Form fromBinaryStream: (
'iVBORw0KGgoAAAANSUhEUgAAB0QAAAAOCAYAAAC/6687AABTd0lEQVR4XuVdB0xUWRcmmQwh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'
	) base64Decoded asByteArray readStream! !

!StrikeFont methodsFor: 'accessing' stamp: 'jmv 8/6/2009 09:14'!
familyName
	^self name withoutJustTrailingDigits! !

!StrikeFont class methodsFor: 'dejaVu font data' stamp: 'jmv 8/5/2009 22:36'!
dejaVuSansOblique7Data
	"Created using:
	Clipboard default clipboardText:
		((FileStream oldFileNamed: 'AAFonts\DejaVu Sans Oblique 7.txt') contentsOfEntireFile substrings 
			collect: [ :each | each asNumber]) asString
	"
	^#(7 8 3 0 3 7 11 19 26 35 43 46 50 55 60 67 71 76 78 84 91 98 105 112 119 126 133 140 147 154 157 161 168 175 182 187 196 203 211 219 227 234 241 249 257 261 266 274 280 289 297 306 313 322 329 336 344 351 358 368 376 383 391 397 400 405 410 419 422 429 436 443 451 458 463 470 477 481 486 493 497 507 514 521 528 535 541 547 552 558 564 572 579 586 593 599 602 608 615 622 629 635 640 649 656 663 670 677 684 691 698 705 712 719 726 733 740 747 754 761 768 775 782 789 796 803 810 817 824 831 838 845 848 852 858 866 874 882 889 895 901 910 916 922 929 934 943 947 952 959 964 969 977 984 990 993 1000 1004 1010 1016 1027 1038 1045 1051 1058 1065 1072 1079 1086 1093 1104 1112 1119 1126 1133 1140 1144 1149 1154 1159 1167 1175 1184 1193 1202 1211 1220 1227 1236 1243 1250 1257 1264 1271 1278 1285 1292 1299 1306 1313 1320 1327 1337 1344 1351 1358 1365 1372 1376 1381 1386 1391 1398 1405 1412 1419 1426 1433 1440 1447 1454 1460 1466 1472 1478 1485 1492 1499)! !

!StrikeFont class methodsFor: 'character shapes' stamp: 'jmv 3/26/2009 14:51'!
makeLfVisible
	"
	Make line feed characters visible
	StrikeFont makeLfVisible
	"
	self allInstances do: [ :font | font makeLfVisible ]! !

!StrikeFont methodsFor: 'emphasis' stamp: 'jmv 8/3/2009 09:17'!
makeBoldGlyphs
	"Make a bold set of glyphs with same widths by ORing 1 bit to the right
		(requires at least 1 pixel of intercharacter space)"
	| g bonkForm |
	g _ glyphs deepCopy.
	bonkForm _ (Form extent: 1@16) fillBlack offset: -1@0.
	self bonk: g with: bonkForm.
	glyphs depth = 1 ifTrue: [
		g copyBits: g boundingBox from: g at: (1@0)
			clippingBox: g boundingBox rule: Form under fillColor: nil]
		ifFalse: [
			0 to: g width - 2 do: [ :x | 0 to: g height-1 do: [ :y |
				(glyphs colorAt:  x@y) = Color white ifFalse: [
					g colorAt: x+1@y put: 
						((glyphs colorAt: x+1@y) = Color white 
							ifTrue: [glyphs colorAt:  x@y]
							ifFalse: [Color black])]]]].
	glyphs _ g.
	self isSynthetic: true.
	fallbackFont ifNotNil: [
		fallbackFont _ fallbackFont emphasized: 1
	].! !

!StrikeFont class methodsFor: 'dejaVu font data' stamp: 'jmv 8/5/2009 22:33'!
dejaVuSansBoldOblique7Data
	"Created using:
	Clipboard default clipboardText:
		((FileStream oldFileNamed: 'AAFonts\DejaVu Sans Bold Oblique 7.txt') contentsOfEntireFile substrings 
			collect: [ :each | each asNumber]) asString
	"
	^#(7 8 3 0 3 7 12 20 27 37 46 49 54 59 65 72 76 81 84 91 99 107 115 123 131 139 147 155 163 171 176 181 188 195 202 208 218 226 234 242 251 259 267 276 285 290 296 305 312 323 332 341 349 358 366 374 382 390 398 409 418 426 434 440 443 449 454 463 467 474 482 489 497 505 511 519 527 532 538 546 551 562 570 578 586 594 601 608 614 621 628 637 645 653 660 667 670 677 684 691 698 705 710 719 726 733 740 747 754 761 768 775 782 789 796 803 810 817 824 831 838 845 852 859 866 873 880 887 894 901 908 915 918 922 928 936 945 953 961 967 974 983 990 996 1003 1008 1017 1022 1027 1034 1040 1046 1055 1063 1069 1072 1079 1083 1090 1096 1108 1120 1128 1134 1142 1150 1158 1166 1174 1182 1193 1201 1209 1217 1225 1233 1238 1244 1250 1256 1265 1274 1283 1292 1301 1310 1319 1326 1336 1344 1352 1360 1368 1376 1384 1392 1399 1406 1413 1420 1427 1434 1445 1452 1460 1468 1476 1484 1489 1495 1500 1506 1514 1522 1530 1538 1546 1554 1562 1569 1577 1584 1591 1598 1605 1613 1621 1629)! !

!StrikeFont methodsFor: 'character shapes' stamp: 'jmv 3/26/2009 14:40'!
makeLfInvisible
	self characterToGlyphMap.
	characterToGlyphMap at: 11 put: (11 < minAscii ifFalse: [11] ifTrue: [maxAscii+1])! !

!Color class methodsFor: 'colormaps' stamp: 'jmv 8/2/2009 21:32'!
computeColorConvertingMap: targetColor from: sourceDepth to: destDepth keepSubPixelAA: keepSubPix

	sourceDepth < 16 ifTrue: [
		"source is 1-, 2-, 4-, or 8-bit indexed color.
		Assumed not to include subpixelAA"
		^ self computeIndexedColorConvertingMap: targetColor from: sourceDepth to: destDepth
	] ifFalse: [
		"source is 16-bit or 32-bit RGB.
		Might include subpixelAA"
		^ self computeRGBColorConvertingMap: targetColor to: destDepth keepSubPixelAA: keepSubPix
	]! !

!StrikeFont class methodsFor: 'instance creation' stamp: 'ar 7/30/2009 22:03'!
fromUser: priorFont allowKeyboard: aBoolean	"StrikeFont fromUser"
	"Present a menu of available fonts, and if one is chosen, return it.
	Otherwise return nil. Using ToolBuilder for added abstraction."
	| fontList fontMenu style active ptMenu label font builder resultBlock result item widget |
	builder := ToolBuilder default.
	fontList := StrikeFont actualFamilyNames.
	fontMenu := builder pluggableMenuSpec new.
	resultBlock := [:value| result := value].
	fontList do: [:fontName |
		style := TextStyle named: fontName.
		active := priorFont familyName sameAs: fontName.
		ptMenu := builder pluggableMenuSpec new.
		style pointSizes do: [:pt |
			label := pt printString, ' pt'.
			item := ptMenu add: label 
				target: resultBlock
				selector: #value:
				argumentList: {{fontName. pt}}.
			item checked: (active and:[pt = priorFont pointSize]).
		].
		style isTTCStyle ifTrue: [
			ptMenu add: 'new size'
				target: style 
				selector: #addNewFontSizeDialog: 
				argumentList: {{fontName. fontMenu}}.
		].
		item := fontMenu add: fontName action: nil.
		item subMenu: ptMenu.
		item checked: active.
	].
	TTFileDescription offerNonPortableFonts ifTrue:[
		fontMenu addSeparator.
		item := fontMenu add: 'More (non-portable) Fonts...' 
			target: resultBlock 
			selector: #value:
			argumentList: #(TTFileDescription).
	].
	widget := builder open: fontMenu.
	builder runModal: widget.
	result ifNil:[^nil].
	"Pick a non-portable font if requested"
	result == #TTFileDescription ifTrue:[
		^Smalltalk at: #TTFileDescription ifPresent:[:ttf| 
			ttf fontFromUser: priorFont allowKeyboard: aBoolean]].
	style := TextStyle named: result first.
	style ifNil: [^ self].
	font := style fonts detect: [:any | any pointSize = result last] ifNone: [nil].
	^ font! !

!BitBlt class methodsFor: 'private' stamp: 'jmv 8/2/2009 21:37'!
recreateColorMaps
	CachedFontColorMaps _ ColorConvertingMaps _ nil! !

!DisplayScanner methodsFor: 'scanning' stamp: 'ar 7/30/2009 22:13'!
displayLine: textLine offset: offset leftInRun: leftInRun
	"The call on the primitive (scanCharactersFrom:to:in:rightX:) will be interrupted according to an array of stop conditions passed to the scanner at which time the code to handle the stop condition is run and the call on the primitive continued until a stop condition returns true (which means the line has terminated).  leftInRun is the # of characters left to scan in the current run; when 0, it is time to call setStopConditions."
	| done stopCondition nowLeftInRun startIndex string lastPos |
	line := textLine.
	morphicOffset := offset.
	lineY := line top + offset y.
	lineHeight := line lineHeight.
	rightMargin := line rightMargin + offset x.
	lastIndex := line first.
	leftInRun <= 0 ifTrue: [self setStopConditions].
	leftMargin := (line leftMarginForAlignment: alignment) + offset x.
	destX := runX := leftMargin.
	fillBlt == nil ifFalse:
		["Not right"
		fillBlt destX: line left destY: lineY
			width: line width left height: lineHeight; copyBits].
	lastIndex := line first.
	leftInRun <= 0
		ifTrue: [nowLeftInRun := text runLengthFor: lastIndex]
		ifFalse: [nowLeftInRun := leftInRun].
	destY := lineY + line baseline - font ascent.
	runStopIndex := lastIndex + (nowLeftInRun - 1) min: line last.
	spaceCount := 0.
	done := false.
	string := text string.
	[done] whileFalse:[
		startIndex := lastIndex.
		lastPos := destX@destY.
		stopCondition := self scanCharactersFrom: lastIndex to: runStopIndex
						in: string rightX: rightMargin stopConditions: stopConditions
						kern: kern.
		lastIndex >= startIndex ifTrue:[
			font displayString: string on: bitBlt 
				from: startIndex 
	"XXXX: The following is an interesting bug. All stopConditions exept #endOfRun
		have lastIndex past the last character displayed. #endOfRun sets it *on* the character.
		If we display up until lastIndex then we will also display invisible characters like
		CR and tab. This problem should be fixed in the scanner (i.e., position lastIndex
		consistently) but I don't want to deal with the fallout right now so we keep the
		fix minimally invasive."
				to: (stopCondition == #endOfRun ifTrue:[lastIndex] ifFalse:[lastIndex-1]) 
				at: lastPos kern: kern].
		"see setStopConditions for stopping conditions for displaying."
		done := self perform: stopCondition.
		lastIndex > runStopIndex ifTrue: [done := true].
	].
	^ runStopIndex - lastIndex   "Number of characters remaining in the current run"! !

!StrikeFont class methodsFor: 'dejaVu font data' stamp: 'jmv 8/5/2009 22:34'!
dejaVuSansBook12Form
	"Created using:
	Clipboard default clipboardText:
	 	((ByteArray streamContents:[:s|
			PNGReadWriter
				putForm: (Form fromFileNamed: 'AAFonts\DejaVu Sans Book 12.bmp')
				onStream: s]) asString base64Encoded)
	"
	^Form fromBinaryStream: (
'iVBORw0KGgoAAAANSUhEUgAACBsAAAATCAYAAADbRJd9AABtH0lEQVR4XuVdB0xTbRc2IRJC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'
	) base64Decoded asByteArray readStream! !

!StrikeFont class methodsFor: 'dejaVu font data' stamp: 'jmv 8/5/2009 22:30'!
dejaVuSansBold12Data
	"Created using:
	Clipboard default clipboardText:
		((FileStream oldFileNamed: 'AAFonts\DejaVu Sans Bold 12.txt') contentsOfEntireFile substrings 
			collect: [ :each | each asNumber]) asString
	"
	^#(12 15 4 0 5 10 16 28 38 54 68 71 77 83 91 102 107 113 117 124 135 146 157 168 179 190 201 212 223 234 239 245 257 268 279 287 302 316 327 339 351 361 371 384 396 401 408 420 430 445 458 471 482 495 507 517 529 541 555 573 585 598 609 616 623 630 638 651 656 667 678 687 698 709 717 728 739 744 751 762 767 784 795 806 817 828 836 846 854 865 877 892 902 913 922 931 935 943 954 964 975 984 992 1005 1015 1025 1035 1045 1055 1065 1075 1085 1095 1105 1115 1125 1135 1145 1155 1165 1175 1185 1195 1205 1215 1225 1235 1245 1255 1265 1275 1285 1290 1295 1304 1315 1326 1338 1349 1358 1367 1379 1387 1396 1408 1414 1426 1432 1438 1449 1455 1462 1473 1484 1493 1497 1506 1512 1521 1530 1548 1565 1578 1587 1601 1615 1629 1642 1655 1668 1686 1698 1708 1718 1728 1738 1744 1749 1756 1762 1775 1788 1801 1814 1827 1840 1853 1864 1878 1890 1902 1914 1926 1939 1950 1961 1972 1983 1994 2005 2016 2027 2044 2053 2064 2075 2086 2097 2103 2109 2116 2122 2133 2144 2155 2166 2177 2188 2199 2210 2221 2232 2243 2254 2265 2276 2287 2298)! !

!StrikeFont methodsFor: 'emphasis' stamp: 'jmv 8/3/2009 09:20'!
makeUnderlinedGlyphs
	"Make an underlined set of glyphs with same widths"
	| g |
	g _ glyphs deepCopy.
	g fillBlack: (0 @ (self ascent+1) extent: g width @ 1).
	glyphs _ g.
	self isSynthetic: true.
	fallbackFont ifNotNil: [
		fallbackFont _ fallbackFont emphasized: 4
	].
! !

!StrikeFont class methodsFor: 'dejaVu font data' stamp: 'jmv 8/5/2009 22:34'!
dejaVuSansBook7Data
	"Created using:
	Clipboard default clipboardText:
		((FileStream oldFileNamed: 'AAFonts\DejaVu Sans Book 7.txt') contentsOfEntireFile substrings 
			collect: [ :each | each asNumber]) asString
	"
	^#(7 8 3 0 3 6 11 19 25 35 43 46 50 54 59 67 70 74 77 82 89 96 103 110 117 124 131 138 145 152 155 158 166 174 182 187 197 205 212 219 227 233 239 247 254 257 261 268 274 282 289 297 303 311 318 325 332 339 347 357 364 371 378 382 387 391 396 405 409 415 422 428 435 442 447 454 460 463 467 473 476 485 491 498 505 512 517 523 528 534 541 550 556 562 568 573 576 581 589 596 603 610 615 624 631 638 645 652 659 666 673 680 687 694 701 708 715 722 729 736 743 750 757 764 771 778 785 792 799 806 813 820 823 826 832 838 845 851 858 864 870 879 884 890 898 902 911 916 921 929 934 939 946 953 959 962 968 972 978 984 994 1004 1011 1016 1024 1032 1040 1047 1054 1061 1071 1078 1084 1090 1096 1102 1105 1108 1113 1118 1126 1133 1141 1149 1157 1165 1173 1180 1188 1195 1202 1209 1216 1223 1229 1236 1242 1248 1254 1260 1266 1273 1283 1289 1296 1303 1310 1317 1321 1325 1330 1335 1342 1348 1355 1362 1369 1376 1382 1390 1397 1403 1409 1415 1421 1427 1434 1441)! !

!BitBlt methodsFor: 'private' stamp: 'jmv 8/2/2009 21:36'!
colorConvertingMap: targetColor from: sourceDepth to: destDepth keepSubPixelAA: keepSubPix

	| srcIndex map mapsForSource mapsForSourceAndDest |
	ColorConvertingMaps class == Array 
		ifFalse: [ColorConvertingMaps _ (1 to: 10) collect: [:i | Array new: 32]].
		
	srcIndex _ sourceDepth.
	sourceDepth > 8 ifTrue: [ srcIndex _ keepSubPix ifTrue: [9] ifFalse: [10] ].
	mapsForSource _ ColorConvertingMaps at: srcIndex.
	(mapsForSourceAndDest _ mapsForSource at: destDepth) isNil ifTrue: [
		mapsForSourceAndDest _ mapsForSource at: destDepth put: Dictionary new ].
	
	map _ mapsForSourceAndDest at: targetColor ifAbsentPut: [
		Color computeColorConvertingMap: targetColor from: sourceDepth to: destDepth keepSubPixelAA: keepSubPix ].

	^ map! !

!BitBlt methodsFor: 'copying' stamp: 'jmv 8/5/2009 22:23'!
displayString: aString from: startIndex to: stopIndex at: aPoint strikeFont: font kern: kernDelta
	"If required, do a second pass with new rule and colorMap.
	This happens when #installStrikeFont:foregroundColor:backgroundColor: sets rule 37 (rgbMul).
	the desired effect is to do two bitblt calls. The first one is with rule 37 and special colormap.
	The second one is rule 34, with a colormap for applying the requested foreground color.
	This two together do component alpha blending, i.e. alpha blend red, green and blue separatedly.
	This is needed for arbitrary color over abitrary background text with subpixel AA."

	| answer prevRule secondPassMap |
	"If combinationRule is rgbMul, we might need the special two-pass technique for component alpha blending.
	If not, do it simply"
	combinationRule = 37 "rgbMul" ifFalse: [
		^self basicDisplayString: aString from: startIndex to: stopIndex at: aPoint strikeFont: font kern: kernDelta ].
	
	"We need to do a second pass. The colormap set is for use in the second pass."
	secondPassMap := colorMap.
	colorMap := sourceForm depth ~= destForm depth
		ifTrue: [ self cachedFontColormapFrom: sourceForm depth to: destForm depth ].
	answer := self basicDisplayString: aString from: startIndex to: stopIndex at: aPoint strikeFont: font kern: kernDelta.
	secondPassMap ifNotNil: [
		prevRule := combinationRule.
		combinationRule := 20. "rgbAdd"
		colorMap := secondPassMap.
		self basicDisplayString: aString from: startIndex to: stopIndex at: aPoint strikeFont: font kern: kernDelta.
		combinationRule := prevRule ].
	^answer! !

!StrikeFont methodsFor: 'character shapes' stamp: 'jmv 3/27/2009 09:46'!
makeControlCharsVisible
	| glyph d|
	self characterToGlyphMap.
	glyph _ self characterFormAt: (Character space).
	glyph border: glyph boundingBox width: 1 fillColor: Color blue.
	self characterFormAt: (Character value: 133) put: glyph.
	
	"Keep tab(9), lf(10), cr(13) and space(32) transparent or whatever the user chose"
	#(0 1 2 3 4 5 6 7 8 11 12 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31)
		do: [ :ascii |
			characterToGlyphMap at: ascii + 1 put: 133 ]! !

!StrikeFont class methodsFor: 'dejaVu font data' stamp: 'jmv 8/5/2009 22:36'!
dejaVuSansOblique7Form
	"Created using:
	Clipboard default clipboardText:
	 	((ByteArray streamContents:[:s|
			PNGReadWriter
				putForm: (Form fromFileNamed: 'AAFonts\DejaVu Sans Oblique 7.bmp')
				onStream: s]) asString base64Encoded)
	"
	^Form fromBinaryStream: (
'iVBORw0KGgoAAAANSUhEUgAABdwAAAALCAYAAABlNk9UAAA5U0lEQVR4XuV9aVBU19puft2/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'
	) base64Decoded asByteArray readStream! !

